	SUBROUTINE CORENY(IPAN)
****************************************************************
*  Subroutine finds ENY for semicore states                    *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,IS,ILST,ILSB
     &                      ,LRTV,NHSORT                             !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                          !!! from readini
      USE COM_PANPAR  ,ONLY: LSPAN,LTPAN,IATS,ISTS                   !!! from readini
      USE COM_SPHERE  ,ONLY: SMT                                     !!! from readini
      USE COM_POTDAT  ,ONLY: POTRWF                                  !!! from potfull
      USE COM_INPPAR  ,ONLY: ENY,TNY,DNY,MNY,NODES,DHLOG,LNY         !!! from readini
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR                             !!! from radmesh
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                             !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: APHI(:)
	REAL*8, ALLOCATABLE :: APHID(:)
	DATA PI/3.141592653589793D0/
	IF(IPAN.EQ.1)RETURN
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(APHI(0:NRADMEM))
	ALLOCATE(APHID(0:NRADMEM))
C FIND BINDING ENERGIES FOR SEMICORE STATES
	DO 2000 ISPIN=1,NSPIN                                !!! over ispin
	ENY0=0.D0
	SATOM=0.D0
	DO 1000 ISORT=1,NSORT                                !!! over isort
	IF(ISTS(ISORT,IPAN).EQ.0)GOTO1000
	SATOM=SATOM+NHSORT(ISORT)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
      IF(MNY(L,ISORT,IKAP,IPAN).EQ.1.OR.
     &   MNY(L,ISORT,IKAP,IPAN).EQ.3)THEN
C TRANSFERE TO CONVINIET FUNCTION TNY DEPENDING ON DNY AND # OF NODES
      TNY(L,ISORT,IKAP,IPAN,ISPIN)=0.5D0+NODES(L,ISORT,IKAP,IPAN)-
     &ATAN(DNY(L,ISORT,IKAP,IPAN,ISPIN))/PI
C FIND ENY-ENERGY
      CALL ENSEARCH(ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &TNY(L,ISORT,IKAP,IPAN,ISPIN),ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &ISORT,L+1,ISPIN)
      ELSEIF(MNY(L,ISORT,IKAP,IPAN).EQ.2)THEN
C FIND BINDING ENERGY E FOR GIVEN VALENCE STATE
      CALL CORSCH_ENYS(ENY(L,ISORT,IKAP,IPAN,ISPIN),NODES(L,
     &ISORT,IKAP,IPAN),L,-1,DLOG,SMT(ISORT),POTRWF(0,ISORT,
     &ISPIN),APHI(0),APHID(0),NRAD(ISORT),H(ISORT),
     &R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
      DHLOG(L,ISORT,IKAP,IPAN,ISPIN)=DLOG
      ENDIF
	ENY0=ENY0+ENY(L,ISORT,IKAP,IPAN,ISPIN)*NHSORT(ISORT)
	ENDIF
	ENDDO
	ENDDO
1000	CONTINUE
	ENY0=ENY0/SATOM/NKAP(IPAN)
	DO IKAP=1,NKAP(IPAN)
	DO ISORT=1,NSORT
	DO L=0,ILST(ISORT)
	IF(.NOT.LSPAN(L,ISORT,IKAP,IPAN))
     &ENY(L,ISORT,IKAP,IPAN,ISPIN)=ENY0
	ENDDO
	ENDDO
	ENDDO
2000	CONTINUE                                             !!! over spins
	DEALLOCATE(APHI,APHID)
	END
