	SUBROUTINE SUMSUB(ASUM,IBNDT,IBNDS,IORBS,IPNT,IPAN,IREAD)
**********************************************************
* Program calculates tl-characters of wave functions.    *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS 
     &                     ,IS,ILST,ILSB,NHSORT               !!! from readini
      USE COM_LATPAR ,ONLY: PAR,OMEGAC                        !!! from readini
      USE COM_KAPPAR ,ONLY: NPAN,NKAP,EKAP                    !!! from readini
      USE COM_PANPAR ,ONLY: LTPAN,LSPAN,IATS,ISTS             !!! from readini
      USE COM_SPHERE ,ONLY: SMT                               !!! from readini
      USE COM_NBANDS ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
      USE COM_LMTPAR ,ONLY: GAM,AAH,BBH,AAJ,BBJ               !!! from potpar
      USE COM_SUMPAR ,ONLY: OHH,OJH,OHJ,OJJ                   !!! from ovrpar
      USE COM_KMESH  ,ONLY: NPNT,PNT                          !!! from tetra
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: APH(:,:,:)
	COMPLEX*16, ALLOCATABLE :: APS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: APJ(:,:,:)
	COMPLEX*16 AHH,AHJ,AJH,AJJ
     &   ,ASUM(0:LMAXTMEM,NSORTMEM,NKAPMEM,NKAPMEM)
	LOGICAL LOG
C MEMORY ALLOCATIONS
	ALLOCATE(APH(LIMBMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(APS(LIMBMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(APJ(LIMTMEM,NATOMMEM,NKAPMEM))
C START CODE
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	ANORM=0.D0
	DO IKAP=1,NKAP(IPAN)
	IF(IREAD.EQ.0)THEN
      IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(ISPIN-1)*(NORBS-1)
      READ(14,REC=IREC)
     &((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APS(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
	ELSEIF(IREAD.EQ.1)THEN  !!! valid only for panel #1
      IREC=IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(ISPIN-1)*(NORBS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
      READ(15,REC=IREC)
     &((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APS(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
	ENDIF
	ENDDO
C AVERAGING OVER ALL ATOMS OF THIS SORT AND OVER ALL M FOR THIS L
	ANORM=0.D0
	DO IKAP1=1,NKAP(IPAN)                                 !!! over energies
	DO IKAP=1,NKAP(IPAN)                                  !!! over energies
	DO ISORT=1,NSORT                                      !!! over isort
	DO L=0,ILST(ISORT)                                    !!! over l
	AHH=(0.D0,0.D0)
	AHJ=(0.D0,0.D0)
	AJH=(0.D0,0.D0)
	AJJ=(0.D0,0.D0)
	DO IATOM=1,NATOM                                      !!! over atoms
	IF(ISORT.EQ.IS(IATOM))THEN
	DO M=-L,L                                             !!! over m
	LM=L*(L+1)+M+1
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))
     &AHH=AHH+CONJG(APH(LM,IATOM,IKAP1))*APH(LM,IATOM,IKAP)*
     &OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)
	IF(LSPAN(L,ISORT,IKAP,IPAN))
     &AJH=AJH-CONJG(APJ(LM,IATOM,IKAP1))*APH(LM,IATOM,IKAP)*
     &OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)
	IF(LSPAN(L,ISORT,IKAP1,IPAN))
     &AHJ=AHJ-CONJG(APH(LM,IATOM,IKAP1))*APJ(LM,IATOM,IKAP)*
     &OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)
	AJJ=AJJ+CONJG(APJ(LM,IATOM,IKAP1))*APJ(LM,IATOM,IKAP)*
     &OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)
      ENDDO                                                 !!! over m
	ENDIF
      ENDDO                                                 !!! over atoms
	ASUM(L,ISORT,IKAP1,IKAP)=(AHH+AHJ+AJH+AJJ)/DBLE(NHSORT(ISORT))
	ANORM=ANORM+ASUM(L,ISORT,IKAP1,IKAP)*DBLE(NHSORT(ISORT))
      ENDDO                                                 !!! over l
      ENDDO                                                 !!! over isort
      ENDDO                                                 !!! over ikap
      ENDDO                                                 !!! over ikap1
C NORMALIZATION
	IF(ABS(ANORM).LE.1.D-10)ANORM=1.D0
	DO IKAP1=1,NKAP(IPAN)                                 !!! over energies
	DO IKAP=1,NKAP(IPAN)                                  !!! over energies
	DO ISORT=1,NSORT                                      !!! over isort
	DO L=0,ILST(ISORT)                                    !!! over l
C	ASUM(L,ISORT,IKAP1,IKAP)=ASUM(L,ISORT,IKAP1,IKAP)/ANORM
      ENDDO                                                 !!! over l
      ENDDO                                                 !!! over isort
      ENDDO                                                 !!! over ikap
      ENDDO                                                 !!! over ikap1
C MEMORY DEALLOCATIONS
	DEALLOCATE(APH,APS,APJ)
	END
