	SUBROUTINE DENMAT(IPNT,IC)
*********************************************************
*  Subroutine calculates density matrix.                *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                !!! from setup
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                          !!! from readstr
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST   !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                         !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS                !!! from readhop
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV,IPENV,IRENV            !!! from envmesh
      USE COM_ENERGY  ,ONLY: EARR,WEIGH,WEIGD                       !!! from bands
      USE COM_HOPCOM  ,ONLY: DMAT                                   !!! from readhop
      USE COM_HOPCOM  ,ONLY: TMAT,SMAT                              !!! from readhop
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                              !!! from ftbmat
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                           !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                           !!! from tetra
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC                !!! from readini
      USE COM_GROUPS  ,ONLY: NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV      !!! from groups
      USE COM_CHANNELS,ONLY: IUPSI                                  !!! from setup
      USE COM_MASHDEP ,ONLY: LENCMP                                 !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: AKL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: AKR(:,:,:)
	COMPLEX*16 PHSK
	LOGICAL LOG
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(AKL(LIMBMEM,NATOMMEM,NSPINMEM))
	ALLOCATE(AKR(LIMBMEM,NATOMMEM,NSPINMEM))
	IF(IC.EQ.1)ALLOCATE(OMAT(NTBAS*NSPIN,NTBAS*NSPIN))
C START CODE
      DO 2000 IBNDS=1,NSPIN                 !!! over spin subbands
      DO 1000 IBNDT=1,NBNDF(1)              !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C SET WEIGHT
      IF(IC.EQ.0.AND.IBNDT.GE.NBNDE(1))GOTO1000
      IF(IC.EQ.1.AND.IBNDT.LT.NBNDE(1))GOTO1000
      IF(IC.EQ.0)WHT=WGT(IPNT,1)/DBLE(NSPIN)/DBLE(NGROUP)
      IF(IC.EQ.1)WHT=WEIGH(IBAND,IPNT)/DBLE(NGROUP)
C READ VARIATIONAL COEFFICIENTS
	DO IORBS=1,NORBS
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
      IF(IC.EQ.1.AND.IBNDT.GE.NBNDE(1))THEN !!! from ttrint
      IREC=1+IBNDT-NBNDE(1)+(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &(NBNDF(1)-NBNDE(1)+1)*NSPIN*(ISPIN-1)*(NORBS-1)+
     &(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
      READ(IUPSI,REC=IREC)
     &(OMAT(IDIM+NTBAS*(ISPIN-1),IBAND),IDIM=1,NBNDT(1))
	ENDIF
	ENDDO
	DO IORBS=1,NORBS
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=INBAS(LM,IATOM)
	AKL(LM,IATOM,ISPIN)=(0.D0,0.D0)
	IF(LTBAS(L,IATOM))
     &AKL(LM,IATOM,ISPIN)=OMAT(IDIM+NTBAS*(ISPIN-1),IBAND)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  DO OVER POINT GROUP
	DO 500 IR=1,NGROUP                      !!! over group
	IG=IKOV(IR)
C  ROTATE VARIATIONAL COEFFICIENTS
	DO IORBS=1,NORBS
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
      SK=PNT(1,IPNT,1)*RDC(1,IATOM,IR)+
     &   PNT(2,IPNT,1)*RDC(2,IATOM,IR)+
     &   PNT(3,IPNT,1)*RDC(3,IATOM,IR)
      PHSK=EXP(2.D0*PI*SK*(0.D0,1.D0))
	DO L=0,ILSB(ISORT)
      LL=L*(2*L-1)*(2*L+1)/3
	DO M=-L,L
	LM=L*(L+1)+M+1
	AKR(LM,IATOM,ISPIN)=(0.D0,0.D0)
	IF(.NOT.LTBAS(L,IATOM))EXIT
	DO IORBS1=1,NORBS
	IF(NORBS.EQ.1)ISPIN1=IBNDS
	IF(NORBS.EQ.2)ISPIN1=IORBS1
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      IWIG01=LL+(2*L+1)*(L+M1)+L+M+1
      AKR(LM,IATOM,ISPIN)=AKR(LM,IATOM,ISPIN)+
     &U(IWIG01,IG)*SJ(ISPIN,ISPIN1,IR)*
     &AKL(LM1,IP(IATOM,IR),ISPIN1)*PHSK
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  SET UP DENSITY MATRIX
      DO IORBS=1,NORBS                          !!! over iorbs
      DO IUPDN=1,NSPIN                          !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
      IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)CYCLE
	DO IATOM1=1,NATOM                   !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)              !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
	IF(IRENV(IENV,IATOM1).EQ.1)THEN
      RX=TENV(1,IENV,IATOM1)+(TAU(1,IATOM1)-TAU(1,IATOM))
      RY=TENV(2,IENV,IATOM1)+(TAU(2,IATOM1)-TAU(2,IATOM))
      RZ=TENV(3,IENV,IATOM1)+(TAU(3,IATOM1)-TAU(3,IATOM))
      XK=PNT(1,IPNT,1)+SH(1,1)
      YK=PNT(2,IPNT,1)+SH(2,1)
      ZK=PNT(3,IPNT,1)+SH(3,1)
      SCP=XK*RX+YK*RY+ZK*RZ
      PHSK=EXP((0.D0,+1.D0)*SCP*2.D0*PI)
      DO L1=0,ILSB(ISORT1)                !!! over l1
      DO M1=-L1,L1                        !!! over m1
      IF(.NOT.LTBAS(L1,IATOM1))EXIT
      L1M1=L1*(L1+1)+M1+1
      DO L=0,ILSB(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      IF(.NOT.LTBAS(L,IATOM))EXIT
      LM=L*(L+1)+M+1
      DMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=
     &DMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)+WHT*SIGNF*
     &DCONJG(AKR(L1M1,IATOM1,ISPIN1))*AKR(LM,IATOM,ISPIN)*PHSK
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
	ENDIF
      ENDDO                               !!! over ienv
      ENDDO                               !!! over iatom1
	ENDDO                               !!! over iupdn
	ENDDO                               !!! over iorbs
 500  CONTINUE                            !!! over group
1000	CONTINUE                            !!! over bands
2000	CONTINUE                            !!! over spin subbands
C MEMORY DEALLOCATIONS
	DEALLOCATE(AKL,AKR)
      SIZE_MAT=2.D0*DBLE(SIZE(OMAT)*LENCMP)/1024.D0**2
	IF(IC.EQ.0)DEALLOCATE(HMAT,OMAT)
      IF(IC.EQ.0)CURMEM=CURMEM-SIZE_MAT
      IF(IC.EQ.1)DEALLOCATE(OMAT)
	END




	SUBROUTINE NULDEN
*****************************************************
*  Sets density matrix to zero.                     *
*****************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                !!! from setup
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST   !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS                !!! from readhop
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV,IPENV,IRENV            !!! from envmesh
      USE COM_ENERGY  ,ONLY: EARR,EARW,WEIGH,WEIGD                  !!! from bands
      USE COM_HOPCOM  ,ONLY: DMAT                                   !!! from readhop
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                           !!! from tetra
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC                !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	IF(.NOT.ALLOCATED(EARR))
     &ALLOCATE(EARR(NBNDT(1)*NSPINMEM,NPNTMEM,NPANMEM))
	IF(.NOT.ALLOCATED(EARW))
     &ALLOCATE(EARW(NBNDT(1)*NSPINMEM,NPNWMEM,NPANMEM))
	IF(.NOT.ALLOCATED(WEIGH))
     &ALLOCATE(WEIGH(NBNDT(1)*NSPINMEM,NPNTMEM))
	IF(.NOT.ALLOCATED(WEIGD))
     &ALLOCATE(WEIGD(NBNDT(1)*NSPINMEM,NPNTMEM))
C SET DENSITY MATRIX TO ZERO
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IUPDN=1,NSPIN                    !!! over spins
	DO IATOM1=1,NATOM                   !!! over iatom1
      ISORT1=IS(IATOM1)
      DO L1=0,ILSB(ISORT1)                !!! over l1
      DO M1=-L1,L1                        !!! over m1
      L1M1=L1*(L1+1)+M1+1
      DO IENV=0,NENV(IATOM1)              !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      DMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over ienv
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
	END
