	SUBROUTINE HUBINT
*********************************************************
*  Builts Hubbard interaction matrix in real space.     *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY : IDMF                            !!! from readini
      USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB !!! from readini
      USE COM_KAPPAR  ,ONLY : NPAN,NKAP                       !!! from readini
      USE COM_LATTICE ,ONLY : RBAS,GBAS,TAU                   !!! from readstr
      USE COM_ENVSITE ,ONLY : NENV,TENV,ISENV                 !!! from envmesh
      USE COM_HOPCOM  ,ONLY : TMAT,SMAT,PMAT                  !!! from readhop
      USE COM_HUBCOM  ,ONLY : VHUB,DHUB,VCNS,DLDA             !!! from readhub
      USE COM_TBBPAR  ,ONLY : LTBAS,LSBAS,INBAS,NTBAS         !!! from readhop
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 HS,OS
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
      IF(IDMF.NE.1)RETURN
C START CODE
	DO 2000 IORBS=1,NORBS               !!! over iorbs
	DO 1000 IUPDN=1,NSPIN               !!! over ispin
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+} * <S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-} * <S_{-}>
	ENDIF
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)                !!! over l1
	DO M1=-L1,L1                        !!! over m1
	IF(.NOT.LTBAS(L1,IATOM1))EXIT
	L1M1=L1*(L1+1)+M1+1
C  DO OVER CLUSTER SITES
	DO IENV=0,NENV(IATOM1)              !!! over ienv
	IATOM=ISENV(IENV,IATOM1) 
	ISORT=IS(IATOM)
	RX=TENV(1,IENV,IATOM1)+(TAU(1,IATOM1)-TAU(1,IATOM))
	RY=TENV(2,IENV,IATOM1)+(TAU(2,IATOM1)-TAU(2,IATOM))
	RZ=TENV(3,IENV,IATOM1)+(TAU(3,IATOM1)-TAU(3,IATOM))
	DO L=0,ILSB(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	IF(.NOT.LTBAS(L,IATOM))EXIT
	LM=L*(L+1)+M+1
      PMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
C  ON SITE INTERACTION IS CURRENTLY AVAIABLE
	IF(IENV.EQ.0.AND.L1.EQ.L)THEN
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
      PMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=
     &PMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)+
     &SIGNF*VHUB(IU,IATOM1,IUPDN1,IORBS)+
     &SIGNF*VCNS(IU,IATOM1,IUPDN1,IORBS)
	ENDIF
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over ienv
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
1000	CONTINUE                            !!! over spins
2000	CONTINUE                            !!! over iorbs
	END
