	SUBROUTINE MIXDEN(ITER,KEY)
**************************************************************
*  Mixes density matrix according to the Broyden             *
*  prescription.                                             *
*  Last modified 01.11.96.                                   *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV,IPENV,IRENV      !!! from envmesh
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS          !!! from readhop
      USE COM_HUBCOM  ,ONLY: DHUB                             !!! from readhub
      USE COM_GROUPS  ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV   !!! from groups
      USE COM_SPHERE  ,ONLY: FILING                           !!! from readini
      USE COM_MIXBROY ,ONLY: NBROY,LBROY,IBROY,MTER           !!! from mixrob
     &                      ,ADMIXB,ADMIXH,WMIX,WINP
      USE COM_HOPCOM  ,ONLY: DMAT                             !!! from readhop
      USE COM_LMTOUT  ,ONLY: SCRFILE                          !!! from readini
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_CHANNELS,ONLY: IUBMF                            !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
	USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WRAD(:)
	REAL*8, ALLOCATABLE :: WTER(:)
	REAL*8, ALLOCATABLE :: FNOM(:)
	COMPLEX*16, ALLOCATABLE :: BETA(:,:)
	COMPLEX*16, ALLOCATABLE :: CMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GAMA(:,:)
      COMPLEX*16, ALLOCATABLE :: WBRO(:)
      COMPLEX*16, ALLOCATABLE :: WRK1(:)
      COMPLEX*16, ALLOCATABLE :: WRK2(:)
      COMPLEX*16, ALLOCATABLE :: XRHO(:)
      COMPLEX*16, ALLOCATABLE :: XNEW(:)
	COMPLEX*16, ALLOCATABLE :: DENM(:,:)
	COMPLEX*16, ALLOCATABLE :: ACHR(:)
	COMPLEX*16, ALLOCATABLE :: AMOM(:)
      LOGICAL FIRST,RESET
      CHARACTER TCPS*19,TC*19,TM*19
	SAVE LBROY0,FIRST,RESET,WBRO,WTER,FNOM,BETA,CMAT,GAMA
      DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      CALL ABORTNOW()
	IF(IBROY.LT.1)IBROY=1  !!! Skip first iteration. Always!!!
C SAVE SWITCH
      IF(FIRST)THEN
      ALLOCATE(WTER(0:NTERMEM))
	ALLOCATE(FNOM(NTERMEM))
	ALLOCATE(BETA(NTERMEM,NTERMEM))
	ALLOCATE(CMAT(NTERMEM,NTERMEM))
	ALLOCATE(GAMA(NTERMEM,NTERMEM))
      ALLOCATE(WMIX(NTERMEM,NTERMEM))
      ALLOCATE(WBRO(NTERMEM))
      ALLOCATE(WINP(NTERMEM))
      LBROY0=LBROY
      MTER=0
      RESET=.TRUE.
      ENDIF
      FIRST=.FALSE.
C DO NOT START BROYDEN, WAIT
	IF(ITER.LE.IBROY)THEN
	LBROY=-1
C SWITCH ON NOW
	ELSEIF(ITER.GT.IBROY)THEN
	LBROY=LBROY0
	ENDIF
	IF(LBROY.LT.0)RETURN
C SET ITERATION NUMBER
	IF(MTER.EQ.NTERMEM-1)RESET=.TRUE.
	IF(MTER.EQ.NTERMEM-1)
     &WRITE(IUT,*)'<MIXROB>:: MTER>NTERMEM, BROYDEN RESTARTED'
	IF(RESET)MTER=0
	IF(KEY.EQ.1.AND.MTER.NE.0)RETURN
	IF(KEY.EQ.2)MTER=MTER+1
C DEFINE MAXIMUM SIZE OF THE BROYDEN ARRAY
      ILEN=0
      DO IORBS=1,NORBS                            !!! over iorbs
      DO IUPDN=1,NSPIN                            !!! over spins
      DO IATOM1=1,NATOM                           !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)                      !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      IF(IRENV(IENV,IATOM1).EQ.1)THEN
      DO L1=0,ILSB(ISORT1)                        !!! over l1
      IF(LTBAS(L1,IATOM1))THEN
      DO L=0,ILSB(ISORT)                          !!! over l
      IF(LTBAS(L,IATOM))THEN
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      ILEN=ILEN+1
      ENDDO
      ENDDO
      ENDIF
      ENDDO                                       !!! over l
      ENDIF
      ENDDO                                       !!! over l1
      ENDIF
      ENDDO                                       !!! over ienv
      ENDDO                                       !!! over atoms
      ENDDO                                       !!! over spins
      ENDDO                                       !!! over iorbs
      NLEN=ILEN
      NLENMEM=NLEN
C  MEMORY ALLOCATIONS
      ALLOCATE(ACHR(NATOMMEM))
      ALLOCATE(AMOM(NATOMMEM))
      ALLOCATE(WRAD(NLENMEM))
      ALLOCATE(WRK1(NLENMEM))
      ALLOCATE(WRK2(NLENMEM))
      ALLOCATE(XRHO(NLENMEM))
      ALLOCATE(XNEW(NLENMEM))
      ALLOCATE(DENM(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
      SIZE_HERE=5.D0*DBLE(SIZE(WRAD)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_HERE
      IF(TOTMEM.LT.CURMEM)TXTMEM='<MIXDEN> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C  *** SET MIXING ARRAY ***
	ILEN=0
      DO IORBS=1,NORBS                            !!! over iorbs
      DO IUPDN=1,NSPIN                            !!! over spins
      DO IATOM1=1,NATOM                           !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)                      !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      IF(IRENV(IENV,IATOM1).EQ.1)THEN
      DO L1=0,ILSB(ISORT1)                        !!! over l1
      IF(LTBAS(L1,IATOM1))THEN
      DO L=0,ILSB(ISORT)                          !!! over l
      IF(LTBAS(L,IATOM))THEN
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
	ILEN=ILEN+1
	XRHO(ILEN)=DMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)
	WRAD(ILEN)=1.D0
	ENDDO
	ENDDO
      ENDIF
      ENDDO                                     !!! over l
      ENDIF
      ENDDO                                     !!! over l1
      ENDIF
      ENDDO                                     !!! over ienv
      ENDDO                                     !!! over atoms
      ENDDO                                     !!! over spins
      ENDDO                                     !!! over iorbs
C  SEND ARRAY TO BROYDEN
      CALL BROY5(XRHO,XNEW,WRAD,WRK1,WRK2,NLEN,MTER,ADMIXB,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NTERMEM,NVAL,
     &IUBMF,SCRFILE(IUBMF))      
	IF(MTER.EQ.0)RESET=.FALSE.
	IF(MTER.EQ.0)GOTO 1000
C  *** DEFINE NEW DENSITY MATRIX ***
	NEGD=0
	ILEN=0
      DO IORBS=1,NORBS                            !!! over iorbs
      DO IUPDN=1,NSPIN                            !!! over spins
      DO IATOM1=1,NATOM                           !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)                      !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      IF(IRENV(IENV,IATOM1).EQ.1)THEN
      DO L1=0,ILSB(ISORT1)                        !!! over l1
      IF(LTBAS(L1,IATOM1))THEN
      DO L=0,ILSB(ISORT)                          !!! over l
      IF(LTBAS(L,IATOM))THEN
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
	ILEN=ILEN+1
	DMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=XNEW(ILEN)
	ENDDO
	ENDDO
      ENDIF
      ENDDO                                     !!! over l
      ENDIF
      ENDDO                                     !!! over l1
      ENDIF
      ENDDO                                     !!! over ienv
      ENDDO                                     !!! over atoms
      ENDDO                                     !!! over spins
      ENDDO                                     !!! over iorbs
C  EXPAND IT OVER ALL CLUSTER SITES BY APPLYING GROUP OPERATIONS
      DO IORBS=1,NORBS                            !!! over spins
      DO IUPDN=1,NSPIN                            !!! over spins
      DO IATOM1=1,NATOM                           !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)                      !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      IF(IRENV(IENV,IATOM1).EQ.1)THEN
      DO L1=0,ILSB(ISORT1)                        !!! over l1
      IF(LTBAS(L1,IATOM1))THEN
      DO L=0,ILSB(ISORT)                          !!! over l
      IF(LTBAS(L,IATOM))THEN
      DO IR=1,NGROUP                              !!! over point group
      IG=IKOV(IR)
      IATOM1G=IP(IATOM1,IR)
      IENVG=IPENV(IENV,IATOM1,IR)
      IATOMG=ISENV(IENVG,IATOM1G)
      IF(IRENV(IENVG,IATOM1G).EQ.-1)THEN
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      DENM(M1,M)=(0.D0,0.D0)
      DO M2=-L1,L1
      L1M2=L1*(L1+1)+M2+1
      IWIG21=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M1)+L1+M2+1
      DO M3=-L,L
      LM3=L*(L+1)+M3+1
      IWIG30=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M3+1
      DENM(M1,M)=DENM(M1,M)+CONJG(U(IWIG21,IG))*
     &DMAT(L1M2,LM3,IATOM1,IENV,IUPDN,IORBS)*U(IWIG30,IG)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      DMAT(L1M1,LM,IATOM1G,IENVG,IUPDN,IORBS)=DENM(M1,M)
      ENDDO
      ENDDO
      ENDIF
      ENDDO                                     !!! over point group
      ENDIF
      ENDDO                                     !!! over l
      ENDIF
      ENDDO                                     !!! over l1
      ENDIF
      ENDDO                                     !!! over ienv
      ENDDO                                     !!! over atoms
      ENDDO                                     !!! over spins
      ENDDO                                     !!! over iorbs
C  SET NON-SPHERICAL DENSITY
      DO IORBS=1,NORBS                          !!! over spins
      DO IUPDN=1,NSPIN                          !!! over spins
      DO IATOM=1,NATOM                          !!! over atoms
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                        !!! over l
      DO M1=-L,L                                !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                 !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! (l,m'm)
      DHUB(IU,IATOM,IUPDN,IORBS)=DMAT(LM1,LM,IATOM,0,IUPDN,IORBS)
      ENDDO                                     !!! over m1
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over atoms
      ENDDO                                     !!! over spins
      ENDDO                                     !!! over iorbs
C  CHECK VALENCE CHARGE
      ZVAL=0.D0
      ZTOT=FILING
	IRES=0
      DO IATOM=1,NATOM                          !!! over atoms
      ISORT=IS(IATOM)
      ACHR(IATOM)=0.D0
      AMOM(IATOM)=0.D0
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                        !!! over l
      IF(LTBAS(L,IATOM))THEN
      DO M=-L,L                                 !!! over m
      LM=L*(L+1)+M+1
      ZVAL=ZVAL+(DMAT(LM,LM,IATOM,0,1,1)+
     &DMAT(LM,LM,IATOM,0,NSPIN,1))/2.D0*DBLE(NSPIN)
      ACHR(IATOM)=ACHR(IATOM)+(DMAT(LM,LM,IATOM,0,1,1)+
     &DMAT(LM,LM,IATOM,0,NSPIN,1))/2.D0*DBLE(NSPIN)
      AMOM(IATOM)=AMOM(IATOM)+(DMAT(LM,LM,IATOM,0,1,1)-
     &DMAT(LM,LM,IATOM,0,NSPIN,1))
      ENDDO                                     !!! over m
      ENDIF
      ENDDO                                     !!! over l
      ENDDO                                     !!! over atoms
C  Switch off mixing ??? Then we have to reset RHO to XRHO
	IF(NEGD.EQ.1)
     &  WRITE(IUN,*)'<MIXROB>::CHARGE DENSITY IS NOT POSITIVE'
C	IF(NEGD.EQ.1)LBROY =-1
C	IF(NEGD.EQ.1)LBROY0=-1
C	IF(NEGD.EQ.1)PRINT*,'<MIXBRO>: BROYDEN  MIXING IS OFF' 
C  Restart mixing
	IF(IRES.EQ.0)RESET=.FALSE.
 	IF(IRES.EQ.1)RESET=.TRUE.
	IF(IRES.EQ.1)PRINT*,'<MIXBRO>: BROYDEN  MIXING  RESTARTED' 
C  Switch off mixing ???
C	IF(IRES.EQ.1)LBROY =-1
C	IF(IRES.EQ.1)LBROY0=-1
C	IF(IRES.EQ.1)PRINT*,'<MIXBRO>: BROYDEN  MIXING  IS OFF' 
C  PRINT BLOCK
	WRITE(IUN,1010)WTER(MTER)
      WRITE(IUN,1020)ZVAL,ZTOT
      WRITE(IUN,1030)
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      TC=TCPS(ACHR(IATOM),1.D-07)
      TM=TCPS(AMOM(IATOM),1.D-07)
      WRITE(IUN,1040)TC,TM,TXTEL(ISORT)
      ENDDO
	WRITE(IUN,1050)
C MEMORY DEALLOCATONS
1000	DEALLOCATE(WRAD,WRK1,WRK2,XRHO,XNEW,DENM,ACHR,AMOM) 
      CURMEM=CURMEM-SIZE_HERE
1010	FORMAT(1X,'Broyden Mixing for DenMat, Iter-Weight=',G14.7)
1020  FORMAT(1X,'Total valence charge true/found=',G12.5,2X,G12.5)
1030  FORMAT(1X,'   Charge:          Moment:      after Broyden')
1040  FORMAT(1X,A19,2X,A19,2X,A)
1050  FORMAT(1X,'----------------------------------------------')
	END
