	SUBROUTINE SYMDEN      
*********************************************************
*  Builts desity matrix for the Fermi surface     *
*  states. Prints result to the terminal.               *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                !!! from setup
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                          !!! from readstr
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB        !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                         !!! from readini
      USE COM_SPHERE  ,ONLY: FILING                                 !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS                !!! from readhop
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV,IPENV,IRENV            !!! from envmesh
      USE COM_HOPCOM  ,ONLY: DMAT                                   !!! from readhop
      USE COM_HUBCOM  ,ONLY: DHUB                                   !!! from readhub
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                           !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                           !!! from tetra
      USE COM_GROUPS  ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV         !!! from groups
      USE COM_LABELS  ,ONLY: TXTAT,TXTSP,TXTEL                      !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 PHSK
      COMPLEX*16, ALLOCATABLE :: ACHR(:)
      COMPLEX*16, ALLOCATABLE :: AMOM(:)
      COMPLEX*16, ALLOCATABLE :: DENM(:,:)
	LOGICAL LOG
	CHARACTER TCPS*19,TC*19,TM*19
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      ALLOCATE(ACHR(NATOMMEM))
      ALLOCATE(AMOM(NATOMMEM))
      ALLOCATE(DENM(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
C EXPAND IT OVER ALL CLUSTER SITES BY APPLYING GROUP OPERATIONS
      DO IORBS=1,NORBS                            !!! over spins
      DO IUPDN=1,NSPIN                            !!! over spins
      DO IATOM1=1,NATOM                           !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)                      !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      IF(IRENV(IENV,IATOM1).EQ.1)THEN
      DO L1=0,ILSB(ISORT1)                        !!! over l1
      IF(LTBAS(L1,IATOM1))THEN
      DO L=0,ILSB(ISORT)                          !!! over l
      IF(LTBAS(L,IATOM))THEN
      DO IR=1,NGROUP                              !!! over point group
      IG=IKOV(IR)
      IATOM1G=IP(IATOM1,IR)
      IENVG=IPENV(IENV,IATOM1,IR)
      IATOMG=ISENV(IENVG,IATOM1G)
      IF(IRENV(IENVG,IATOM1G).EQ.-1)THEN
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      DENM(M1,M)=(0.D0,0.D0)
      DO M2=-L1,L1
      L1M2=L1*(L1+1)+M2+1
      IWIG12=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M2)+L1+M1+1
      DO M3=-L,L
      LM3=L*(L+1)+M3+1
      IWIG03=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M3)+L+M+1
      DENM(M1,M)=DENM(M1,M)+CONJG(U(IWIG12,IG))*
     &DMAT(L1M2,LM3,IATOM1,IENV,IUPDN,IORBS)*U(IWIG03,IG)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      DMAT(L1M1,LM,IATOM1G,IENVG,IUPDN,IORBS)=DENM(M1,M)
      ENDDO
      ENDDO
	ENDIF
      ENDDO                                     !!! over point group
	ENDIF
	ENDDO                                     !!! over l
	ENDIF
	ENDDO                                     !!! over l1
	ENDIF
	ENDDO                                     !!! over ienv
	ENDDO                                     !!! over atoms
      ENDDO                                     !!! over spins
      ENDDO                                     !!! over iorbs
C  SET NON-SPHERICAL DENSITY
      DO IORBS=1,NORBS                          !!! over spins
      DO IUPDN=1,NSPIN                          !!! over spins
      DO IATOM=1,NATOM                          !!! over atoms
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                        !!! over l
      DO M1=-L,L                                !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                 !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! (l,m'm)
      DHUB(IU,IATOM,IUPDN,IORBS)=DMAT(LM1,LM,IATOM,0,IUPDN,IORBS)
      ENDDO                                     !!! over m1
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over atoms
      ENDDO                                     !!! over spins
      ENDDO                                     !!! over iorbs
C  CHECK VALENCE CHARGE
	ZVAL=0.D0
	ZTOT=FILING
      DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	ACHR(IATOM)=(0.D0,0.D0)
	AMOM(IATOM)=(0.D0,0.D0)
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                        !!! over l
      IF(LTBAS(L,IATOM))THEN
      DO M=-L,L                                 !!! over m
      LM=L*(L+1)+M+1
	ZVAL=ZVAL+(DMAT(LM,LM,IATOM,0,1,1)+
     &DMAT(LM,LM,IATOM,0,NSPIN,1))/2.D0*DBLE(NSPIN)
	ACHR(IATOM)=ACHR(IATOM)+(DMAT(LM,LM,IATOM,0,1,1)+
     &DMAT(LM,LM,IATOM,0,NSPIN,1))/2.D0*DBLE(NSPIN)
	AMOM(IATOM)=AMOM(IATOM)+(DMAT(LM,LM,IATOM,0,1,1)-
     &DMAT(LM,LM,IATOM,0,NSPIN,1))
	ENDDO                                     !!! over m
	ENDIF
	ENDDO                                     !!! over l
	ENDDO                                     !!! over atoms
	WRITE(IUN,1010)ZVAL,ZTOT
	WRITE(IUN,1020)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM) 
	TC=TCPS(ACHR(IATOM),1.D-07)
	TM=TCPS(AMOM(IATOM),1.D-07)
	WRITE(IUN,1030)TC,TM,TXTEL(ISORT)
	ENDDO
C MEMORY DEALLOCATONS
      DEALLOCATE(DENM,ACHR,AMOM)
1010	FORMAT(1X,'Total valence charge true/found=',G12.5,2X,G12.5)
1020	FORMAT(1X,'   Charge:              Moment:')
1030	FORMAT(1X,A19,2X,A19,2X,A)
	END





      SUBROUTINE PRINTDM(ICHAN)
*******************************************************
*  Prints density matrix.                             *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                !!! from setup
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB        !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS                !!! from readhop
      USE COM_HOPCOM  ,ONLY: DMAT                                   !!! from readhop
      USE COM_HOPDAT  ,ONLY: NINF,NHOP,ISCHM,ICUBC,IRE,IWR,IHO      !!! from readhop
     &                      ,HINF,HIND                              !!! from readhop
      USE COM_LABELS  ,ONLY: TXTAT,TXTSP,TXTEL                      !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16, ALLOCATABLE :: DENM(:,:)
      COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3),CVAL(2)
      CHARACTER TXTH*150
      DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
      ALLOCATE(DENM(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
C PRINT DENSITY MATRIX
	WRITE(ICHAN,1000)
      WRITE(ICHAN,1010)
      DO INF=1,NINF
      READ(HINF(INF),*)IATOM1,NM1,L1,K1R,IATOM,NM,
     &L,KR,IENV,IENV1,IUPDN,IORBS
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C TRANSFERE TO CUBIC HARMONICS IF NECESSARY
      IF(ICUBC.EQ.1)THEN
      CALL TRANSS(TS)   ! built transformation matrices
      DO K1=-L1,L1
      L1K1=L1*(L1+1)+K1+1
      DO K=-L,L
      LK=L*(L+1)+K+1
      DENM(K1,K)=(0.D0,0.D0)
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      DENM(K1,K)=DENM(K1,K)+CONJG(TS(K1+L1+1,M1,L1))*
     &DMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)*TS(K+L+1,M,L)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDIF
      CVAL(1)=DENM(K1R,KR)
      CALL WRIORB(TXTH,NB,ICUBC,IRE,1,CVAL(1),
     &IATOM1,ISPIN1,NM1,L1,K1R,IATOM,ISPIN,NM,L,KR,IENV,IENV1)
      WRITE(ICHAN,1020)TXTH(:NB-1)
      ENDDO
C MEMORY DEALLOCATONS
      DEALLOCATE(DENM)
1000	FORMAT(1X,'Calculated density matrix, irreducible terms are:')
1010  FORMAT(1X,5X,'<From>',7X,
     &'<To> the orbital via connection:',14X,'<Value>')
1020  FORMAT(1X,A)
      END
