	SUBROUTINE READHOP
*******************************************************
*  Prepares hopping matrix from the knowledge of the  *
*  hopping integrals read from HOPFILE.               *
*  Also sets overlap matrix if required.              *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                         !!! from setup
	USE COM_CONTROL,ONLY: LMTO                             !!! from readini
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
      USE COM_LATPAR ,ONLY: PAR,ORTH,OMEGAC                  !!! from readini
	USE COM_SPHERE ,ONLY: FILING                           !!! from readhop
      USE COM_PANPAR ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_LATTICE,ONLY: RBAS,GBAS,TAU                    !!! from readstr
      USE COM_INPPAR ,ONLY: ENY,DNY,NODES                    !!! from readini
      USE COM_SCRINP ,ONLY: RLOC                             !!! from alpcon
      USE COM_ENVSITE,ONLY: NENV,TENV,ISENV,IPENV,IRENV      !!! from envmesh
      USE COM_TBBPAR ,ONLY: LTBAS,LSBAS,MQBAS,INBAS,NTBAS    !!! from readhop
      USE COM_TBBSYS ,ONLY: RINPAXE,RINPANG,ROUTAXE,ROUTANG  !!! from readhop
     &                     ,RINPINV,ROUTINV,CHSYS,CHAXE,CHANG,CHINV
      USE COM_HOPCOM ,ONLY: TMAT,SMAT,PMAT,DMAT              !!! from readhop
      USE COM_HOPDAT ,ONLY: NINF,NHOP,ISCHM,ICUBC,IRE,IHO    !!! from readhop
     &                     ,HINF,HIND                        !!! from readhop
      USE COM_GROUPS ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV   !!! from groups
      USE COM_LMTINP ,ONLY: ICHOP,HOPFILE                    !!! from readini
      USE COM_LABELS ,ONLY: TXTEL,TXTSP,TXTAT                !!! from readini
      USE COM_UNIT   ,ONLY: IUN,IUR,IUT                      !!! from setup
      USE COM_MASHDEP,ONLY: LENCMP                           !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	COMPLEX*16, ALLOCATABLE :: THOP(:,:)
	COMPLEX*16, ALLOCATABLE :: SHOP(:,:)
	COMPLEX*16, ALLOCATABLE :: UL(:)
	COMPLEX*16, ALLOCATABLE :: UR(:)
      CHARACTER*150, ALLOCATABLE :: HOPDATA(:)
      CHARACTER*150, ALLOCATABLE :: HOPCOPY(:)
	DIMENSION RENV(3) 
	COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3),CVAL(2)
	CHARACTER SCHM*10,CUBC*10,CUBI*10,REIM*10,SNOT*10,TNOT*20
     &  ,TXTH*150,TL(0:3)*1,TEXT*60,STRING*150,HELP*40,STRARR(80)*1
      LOGICAL EXIST,MODIFIED,INPOUT,DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/
	IF(ICHOP.LE.0)RETURN
C CHECK EXISTENCE
      INQUIRE(FILE=HOPFILE,EXIST=EXIST)
      IF(.NOT.EXIST)CALL READHOP_MESG01
C CHECK KEYS
C	IF(LMTO.EQ.1)CALL READHOP_MESG03
	IF(NENVMEM.EQ.-1)CALL READHOP_MESG04
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(TMAT(LIMBMEM,LIMBMEM,NATOMMEM,0:NENVMEM,
     &NSPINMEM,NORBSMEM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL READHOP_MESG02('TMAT',
     &LIMBMEM**2*NATOMMEM*(NENVMEM+1)*NSPINMEM*NORBSMEM*LENCMP)
      SIZE_TMAT=DBLE(SIZE(TMAT)*LENCMP)/1024.D0**2
	ALLOCATE(PMAT(LIMBMEM,LIMBMEM,NATOMMEM,0:NENVMEM,
     &NSPINMEM,NORBSMEM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL READHOP_MESG02('PMAT',
     &LIMBMEM**2*NATOMMEM*(NENVMEM+1)*NSPINMEM*LENCMP)
      SIZE_PMAT=DBLE(SIZE(PMAT)*LENCMP)/1024.D0**2
	ALLOCATE(SMAT(LIMBMEM,LIMBMEM,NATOMMEM,0:NENVMEM,
     &NSPINMEM,NORBSMEM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL READHOP_MESG02('SMAT',
     &LIMBMEM**2*NATOMMEM*(NENVMEM+1)*NSPINMEM*NORBSMEM*LENCMP)
      SIZE_SMAT=DBLE(SIZE(PMAT)*LENCMP)/1024.D0**2
	ALLOCATE(DMAT(LIMBMEM,LIMBMEM,NATOMMEM,0:NENVMEM,
     &NSPINMEM,NORBSMEM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL READHOP_MESG02('DMAT',
     &LIMBMEM**2*NATOMMEM*(NENVMEM+1)*NSPINMEM*LENCMP)
      SIZE_DMAT=DBLE(SIZE(DMAT)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_TMAT+SIZE_SMAT+SIZE_PMAT+SIZE_DMAT
	ALLOCATE(INBAS(LIMBMEM,NATOMMEM))
	ALLOCATE(MQBAS(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(LTBAS(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(LSBAS(0:LMAXBMEM,NSORTMEM))
	ALLOCATE(RINPAXE(3,0:LMAXBMEM,NATOMMEM))
	ALLOCATE(ROUTAXE(3,0:LMAXBMEM,NATOMMEM))
	ALLOCATE(RINPANG(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(ROUTANG(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(RINPINV(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(ROUTINV(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(CHSYS(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(CHAXE(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(CHANG(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(CHINV(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(UL(NWIGMEM))
	ALLOCATE(UR(NWIGMEM))
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(THOP(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(SHOP(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
C SET HOPPING MATRIX TO ZERO
	INF=0
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IATOM1=1,NATOM
	ISORT1=IS(IATOM1)
	DO IENV=0,NENV(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
      IF(IRENV(IENV,IATOM1).EQ.1)
     &INF=INF+(ILSB(ISORT1)+1)**4
	DO L1=0,ILSB(ISORT1)
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
	SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
	IF(L1M1.EQ.LM.AND.IATOM1.EQ.IATOM.AND.IENV.EQ.0.AND.IORBS.EQ.1)
     &SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(1.D0,0.D0)
	PMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
	DMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	NINFMEM=INF
C TIGHT-BINDING BASIS SET CONTROL ARRAYS
	IDIM=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	LTBAS(L,IATOM)=.FALSE.
	LSBAS(L,ISORT)=.FALSE.
	MQBAS(L,IATOM)=0
	ENDDO 
	ENDDO
C LOCAL COORDINATE SYSTEMS ASSUME GLOBAL SYSTEM BY DEFAULT
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	RINPAXE(1,L,IATOM)=0.D0
	RINPAXE(2,L,IATOM)=0.D0
	RINPAXE(3,L,IATOM)=1.D0
	ROUTAXE(1,L,IATOM)=0.D0
	ROUTAXE(2,L,IATOM)=0.D0
	ROUTAXE(3,L,IATOM)=1.D0
	RINPANG(L,IATOM)=0.D0
	ROUTANG(L,IATOM)=0.D0
	RINPINV(L,IATOM)=0.D0
	ROUTINV(L,IATOM)=0.D0
	ENDDO
	ENDDO
C *********************************************************
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
      ALLOCATE(HINF(NINFMEM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL READHOP_MESG02('HINF',NINFMEM*60)
      ALLOCATE(HIND(NINFMEM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL READHOP_MESG02('HIND',NINFMEM*60)
      SIZE_HINF=DBLE(SIZE(HINF)*60.D0)/1024.D0**2
      SIZE_HIND=DBLE(SIZE(HIND)*60.D0)/1024.D0**2
      CURMEM=CURMEM+SIZE_HINF+SIZE_HIND
      IF(TOTMEM.LT.CURMEM)TXTMEM='<READHOP> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM	
C ********************************
C UNDERSTAND THE LENGHT OF HOPFILE
      CALL FILE_LENGHT(HOPFILE,NLEN)
      ALLOCATE(HOPDATA(NLEN))
C ********************************
C READ HOPFILE TO INTERNAL FILE
      OPEN(UNIT=1,FILE=HOPFILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(1,FMT='(A150)')HOPDATA(ILEN)
      ENDDO
      CLOSE(1)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
      STRING=HOPDATA(1)
      CALL CONVLOW(STRING,150)
      MODERN=0
      DO IPOS=1,80
      IF(STRING(IPOS:IPOS+12).EQ.'input=classic')MODERN=1
      IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
      IF(MODERN.NE.0)EXIT
      ENDDO
      IF(MODERN.EQ.0)ISTART=1
      IF(MODERN.EQ.1)ISTART=2
      IF(MODERN.EQ.0)MODERN=1
      IF(MODERN.EQ.1)MODIFIED=.FALSE.
      IF(MODERN.EQ.2)MODIFIED=.TRUE.
C NO FURTHER SUPPORT FOR "CLASSIC"
      IF(MODERN.EQ.1)
     &CALL FULLSTOP('<READHOP>: CLASSIC INPUT NOT SUPPORTED')
C **************************************
C READING THE DATA: SELECT CONTROLS
C SCHM='        ' - yet not defined
C CUBC='Cubic' or 'Spherical' harmonics
C REIM='Real' or 'Complex' - input/output
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(HOPDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(HOPDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)HOPDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)HOPDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(HOPCOPY(NSEC))
      DO ILIN=1,MSEC
      HOPCOPY(ILIN)=HOPDATA(ILIN+ISEC-1)
      ENDDO
C Process SCHM
	SCHM='Bnd1      '
      HELP='! Bands currenly avaiable               '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'scheme',6,IN,1,0,RE,1,0,CM,1,0,SCHM,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process CUBC
	CUBC='Spherical '
      HELP='! Cubic/Spherical harmonics (output)    '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'yharm',5,IN,1,0,RE,1,0,CM,1,0,CUBC,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process CUBI
	CUBI=CUBC
      HELP='! Cubic/Spherical harmonics (input)     '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'iharm',5,IN,1,0,RE,1,0,CM,1,0,CUBI,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process REIM
	REIM='Complex   '
      HELP='! Real/Complex input/output             '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'format',6,IN,1,0,RE,1,0,CM,1,0,REIM,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C **************************************
      CALL READINI_ERRR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(HOPCOPY)
C ***********************
C TRANSFORM TO INTEGER KEYS
      CALL CONVLOW(SCHM,10)
      CALL RMBLANK(SCHM,10)
      NB=INDEX(SCHM,' ')
	ISCHM=-1
      IF(SCHM(:NB-1).EQ.'bnd0')ISCHM=0 
      IF(SCHM(:NB-1).EQ.'bnd1')ISCHM=1
      IF(ISCHM.EQ.-1)
     &CALL FULLSTOP('Syntax error: SET SCHEME in HOPFILE')
      CALL CONVLOW(CUBC,10)
      CALL RMBLANK(CUBC,10)
      NB=INDEX(CUBC,' ')
      ICUBC=0
      IF(CUBC(:NB-1).EQ.'cubic')ICUBC=1
      IF(CUBC(:NB-1).EQ.'spherical')ICUBC=2
      IF(ICUBC.EQ.0)
     &CALL FULLSTOP('Syntax error: SET CUBIC OR SPHERICAL in HOPFILE')
      CALL CONVLOW(CUBI,10)
      CALL RMBLANK(CUBI,10)
      NB=INDEX(CUBI,' ')
      ICUBI=0
      IF(CUBI(:NB-1).EQ.'cubic')ICUBI=1
      IF(CUBI(:NB-1).EQ.'spherical')ICUBI=2
      IF(ICUBI.EQ.0)
     &CALL FULLSTOP('Syntax error: SET CUBIC OR SPHERICAL in HOPFILE')
      CALL CONVLOW(REIM,10)
      CALL RMBLANK(REIM,10)
      NB=INDEX(REIM,' ')
      IRE=0
      IF(REIM(:NB-1).EQ.'real')IRE=1
      IF(REIM(:NB-1).EQ.'complex')IRE=2
      IF(IRE.EQ.0)
     &CALL FULLSTOP('Syntax error: SET REAL OR COMPLEX in HOPFILE')
C *************************************************************
C SELECT TIGHT-BINDING BASIS SET TO BE USED IN THE CALCULATION
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(HOPDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=tbas',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(HOPDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)HOPDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! TIGHT-BINDING BASIS:                  '
      IF(MSEC.NE.0)HOPDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(HOPCOPY(NSEC))
      DO ILIN=1,MSEC
      HOPCOPY(ILIN)=HOPDATA(ILIN+ISEC-1)
      ENDDO
C Process Filling
	FILING=0.D0
      LHLP=40
      HELP='! filling                               '
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'fill',4,IN,1,0,FILING,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process NTBS
	NTBS=0
      LHLP=40
      HELP='! # of states to read                   '
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'ntbs',4,NTBS,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C PROCESS STATES
	DO 1000 ITBS=1,NTBS
C State
      TNOT='          '
      HELP='! tb-state                              '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'hstate',6,IN,1,0,RE,1,0,CM,1,0,TNOT,20,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(TNOT,20)
      CALL RMBLANK(TNOT,20)
	CALL GET_STATE(TNOT,20,IHATOM,IHSPIN,MQ,IHORB,IHMOM,ICUBI)
	IF(IHATOM.EQ.-1)
     &CALL FULLSTOP('<READHOP>: WRONG POINTER TO HSTATE')
	IHSORT=IS(IHATOM)
	IF(IHORB.EQ.-1)THEN
	DO L=0,ILSB(IHSORT)
	LTBAS(L,IHATOM)=.TRUE.
	LSBAS(L,IHSORT)=.TRUE.
	ENDDO
	ELSEIF(IHORB.NE.-1)THEN
      IF(IHORB.GT.LMAXBMEM)
     &CALL FULLSTOP('<READHOP>: WRONG POINTER TO HSTATE')
	LTBAS(IHORB,IHATOM)=.TRUE.
	LSBAS(IHORB,IHSORT)=.TRUE.
	MQBAS(IHORB,IHATOM)=MQ
	ENDIF 
C ***********************
C Input coordinate system
C System
      CHSYS(IHORB,IHATOM)='          '
      HELP='! global/local coordinate system        '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'inpsys',6,IN,1,0,RE,1,0,CM,1,0,CHSYS(IHORB,IHATOM),10,1,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(CHAXE(IHORB,IHATOM),10)
      CALL RMBLANK(CHAXE(IHORB,IHATOM),10)
C Rotation axis
	DO I=1,80
      CHAXE(IHORB,IHATOM)(I:I)=' '
	ENDDO
      HELP='! rotational axe                        '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'inpaxis',7,IN,1,0,RE,1,0,CM,1,0,CHAXE(IHORB,IHATOM),80,1,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(CHAXE(IHORB,IHATOM),80)
      CALL RMBLANK(CHAXE(IHORB,IHATOM),80)
C Rotation angle
      DO I=1,80
      CHANG(IHORB,IHATOM)(I:I)=' '
      ENDDO 
      HELP='! rotational angle                      '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'inpangle',8,IN,1,0,RE,1,0,CM,1,0,CHANG(IHORB,IHATOM),80,1,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(CHANG(IHORB,IHATOM),80)
      CALL RMBLANK(CHANG(IHORB,IHATOM),80)
C Apply inversion
      DO I=1,10
      CHINV(IHORB,IHATOM)(I:I)=' '
      ENDDO
      HELP='! apply inversion after rotation        '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'inpinv',6,IN,1,0,RE,1,0,CM,1,0,CHINV(IHORB,IHATOM),10,1,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(CHINV(IHORB,IHATOM),10)
      CALL RMBLANK(CHINV(IHORB,IHATOM),10)
C Set input-system arrays
	DO L=0,ILSB(IHSORT)                !!! over l
      IF(CHSYS(IHORB,IHATOM)(1:5).NE.'local' )CYCLE
	DO I=1,80
	STRARR(I)=CHAXE(IHORB,IHATOM)(I:I)
	ENDDO
	CALL COMPVEC(STRARR,RINPAXE(1,L,IHATOM),3)
	DO I=1,80
	STRARR(I)=CHANG(IHORB,IHATOM)(I:I)
	ENDDO
	CALL COMPVEC(STRARR,RINPANG(L,IHATOM),1)
 	IF(CHINV(IHORB,IHATOM)(1:1).EQ.'n')RINPINV(L,IHATOM)=0.D0
 	IF(CHINV(IHORB,IHATOM)(1:1).EQ.'y')RINPINV(L,IHATOM)=1.D0
	ENDDO                              !!! over l
C ************************
C Output coordinate system
C System
      CHSYS(IHORB,IHATOM)='          '
      HELP='! global/local coordinate system        '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'outsys',6,IN,1,0,RE,1,0,CM,1,0,CHSYS(IHORB,IHATOM),10,1,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(CHSYS(IHORB,IHATOM),10)
      CALL RMBLANK(CHSYS(IHORB,IHATOM),10)
C Rotation axis
	DO I=1,80
      CHAXE(IHORB,IHATOM)(I:I)=' '
	ENDDO
      HELP='! rotational axe                        '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'outaxis',7,IN,1,0,RE,1,0,CM,1,0,CHAXE(IHORB,IHATOM),80,1,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(CHAXE(IHORB,IHATOM),80)
      CALL RMBLANK(CHAXE(IHORB,IHATOM),80)
C Rotation angle
      DO I=1,80
      CHANG(IHORB,IHATOM)(I:I)=' '
      ENDDO 
      HELP='! rotational angle                      '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'outangle',8,IN,1,0,RE,1,0,CM,1,0,CHANG(IHORB,IHATOM),80,1,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(CHANG(IHORB,IHATOM),80)
      CALL RMBLANK(CHANG(IHORB,IHATOM),80)
C Apply inversion
      DO I=1,10
      CHINV(IHORB,IHATOM)(I:I)=' '
      ENDDO
      HELP='! apply inversion after rotation        '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'outinv',6,IN,1,0,RE,1,0,CM,1,0,CHINV(IHORB,IHATOM),10,1,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.)
      CALL CONVLOW(CHINV(IHORB,IHATOM),10)
      CALL RMBLANK(CHINV(IHORB,IHATOM),10)
C Set output-system arrays
	DO L=0,ILSB(IHSORT)                !!! over l
      IF(CHSYS(IHORB,IHATOM)(1:5).NE.'local' )CYCLE
	DO I=1,80
	STRARR(I)=CHAXE(IHORB,IHATOM)(I:I)
	ENDDO
	CALL COMPVEC(STRARR,ROUTAXE(1,L,IHATOM),3)
	DO I=1,80
	STRARR(I)=CHANG(IHORB,IHATOM)(I:I)
	ENDDO
	CALL COMPVEC(STRARR,ROUTANG(L,IHATOM),1)
      IF(CHINV(IHORB,IHATOM)(1:2).EQ.'no' )ROUTINV(L,IHATOM)=0.D0
 	IF(CHINV(IHORB,IHATOM)(1:3).EQ.'yes')ROUTINV(L,IHATOM)=1.D0
	ENDDO                              !!! over l
 1000	CONTINUE                           !!! over tb-states
C **************************************
      CALL READINI_ERRR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,'TBAS')
      DEALLOCATE(HOPCOPY)
C *************************************************************
C HOPPING INTEGRALS ARE DEFINED FROM A PARTICULAR ORBITAL
C TO ANOTHER ORBITAL VIA A VECTOR SEPARATING TWO SITES.
C THE OVERLAP INTEGRAL BETWEEN TWO SITES MUST ALSO BE 
C GIVEN. 
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(HOPDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=hopp',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(HOPDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)HOPDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! DESCRIPTION OF HOPPINGS:              '
      IF(MSEC.NE.0)HOPDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(HOPCOPY(NSEC))
      DO ILIN=1,MSEC
      HOPCOPY(ILIN)=HOPDATA(ILIN+ISEC-1)
      ENDDO
C Process NINF
	NINF=0
      HELP='! # of hopping integrals                '
      LHLP=40
      CALL READINI_CHAR(HOPDATA(ISEC),HOPCOPY(1),NSEC,MSEC,
     &'nhop',4,NINF,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
	IF(NINF.GT.0)IHO=1
      IF(NINF.EQ.0)IHO=2
C HOPPINGS INTEGRALS AVAIABLE, READ THEM
	IF(IHO.EQ.1)THEN
	IERROR=0
	IREC=ISEC+2
	TXTH=HOPDATA(IREC)
      DO INF=1,NINF
	IREC=IREC+1
	IF(IREC.GT.NLEN)CALL FULLSTOP('<<READHOP>:: CANNOT READ HOPPINGS')
	TXTH=HOPDATA(IREC)
      CALL REDORB(TXTH,150,ICUBI,IRE,2,CVAL(1),
     &IATOM1,ISPIN1,NM1,L1,M1,IATOM,ISPIN,NM,L,M,IENV,IENV1)
	L1M1=L1*(L1+1)+M1+1
	LM=L*(L+1)+M+1
	IF(ISPIN1.EQ.0.AND.ISPIN.EQ.0)THEN
	TMAT(L1M1,LM,IATOM1,IENV,1,1)=CVAL(1)
	SMAT(L1M1,LM,IATOM1,IENV,1,1)=CVAL(2)
	TMAT(L1M1,LM,IATOM1,IENV,NSPIN,1)=CVAL(1)
	SMAT(L1M1,LM,IATOM1,IENV,NSPIN,1)=CVAL(2)
	WRITE(HINF(INF),1020)IATOM1,NM1,L1,M1,IATOM,NM,
     &L,M,IENV,IENV1,1,1
	IF(NSPIN.EQ.2)
     &WRITE(HINF(INF),1020)IATOM1,NM1,L1,M1,IATOM,NM,
     &L,M,IENV,IENV1,NSPIN,1
	ELSEIF(ISPIN1.EQ.ISPIN.AND.ISPIN.NE.0)THEN
	ISPIN=MIN(ISPIN,NSPIN)
	TMAT(L1M1,LM,IATOM1,IENV,ISPIN,1)=CVAL(1)
	SMAT(L1M1,LM,IATOM1,IENV,ISPIN,1)=CVAL(2)
	WRITE(HINF(INF),1020)IATOM1,NM1,L1,M1,IATOM,NM,
     &L,M,IENV,IENV1,ISPIN,1
	ELSEIF(ISPIN1.GT.ISPIN.AND.ISPIN.NE.0)THEN
	TMAT(L1M1,LM,IATOM1,IENV,1,NORBS)=CVAL(1)
	SMAT(L1M1,LM,IATOM1,IENV,1,NORBS)=CVAL(2)
	TMAT(L1M1,LM,IATOM1,IENV,NSPIN,NORBS)=DCONJG(CVAL(1))
	SMAT(L1M1,LM,IATOM1,IENV,NSPIN,NORBS)=DCONJG(CVAL(2))
	WRITE(HINF(INF),1020)IATOM1,NM1,L1,M1,IATOM,NM,
     &L,M,IENV,IENV1,1,NORBS
	ELSEIF(ISPIN1.LT.ISPIN.AND.ISPIN.NE.0)THEN
	TMAT(L1M1,LM,IATOM1,IENV,NSPIN,NORBS)=CVAL(1)
	SMAT(L1M1,LM,IATOM1,IENV,NSPIN,NORBS)=CVAL(2)
	TMAT(L1M1,LM,IATOM1,IENV,1,NORBS)=DCONJG(CVAL(1))
	SMAT(L1M1,LM,IATOM1,IENV,1,NORBS)=DCONJG(CVAL(2))
	WRITE(HINF(INF),1020)IATOM1,NM1,L1,M1,IATOM,NM,
     &L,M,IENV,IENV1,NSPIN,NORBS
	ENDIF
	IF(.NOT.LTBAS(L1,IATOM1))CALL READHOP_MESG05(L1,IATOM1)
	IF(.NOT.LTBAS(L ,IATOM ))CALL READHOP_MESG05(L ,IATOM )
	ENDDO
C GENERATE SUBBLOCKS FROM IRREDUCIBLE HOPPINGS
	CALL FINDIRR(ICUBI,RINPAXE,RINPANG,RINPINV,1,1)
C ************************************************************
C NO HOPPING INTEGRALS AVAIABLE
	ELSEIF(IHO.EQ.2)THEN
C GENERATE IRREDUCIBLE HOPPINGS, HINF ARRAY WILL BE KNOWN NOW
	CALL FINDIRR(ICUBI,RINPAXE,RINPANG,RINPINV,1,2)
	ENDIF
C **************************************
      DEALLOCATE(HOPCOPY)
C ********************************************************
C HOPFILE HAS BEEN READ, REFORMAT IT
      IF(MODIFIED)CALL READINI_OVWR(HOPFILE,HOPDATA,NLEN)
C MEMORY DEALLOCATIONS
      DEALLOCATE(HOPDATA)
C ********************************************************
C TRANSFORM TO COMPLEX HARMONICS IF NECESSARY
	IF(ICUBI.EQ.1)THEN
	CALL TRANSC(TC)   ! built transformation matrices
	DO IORBS=1,NORBS                       !!! over iorbs
	DO IUPDN=1,NSPIN                       !!! over spins
	DO IHOP=1,NHOP                         !!! over hopping integrals
	READ(HIND(IHOP),*)L1,L,IATOM1,IENV
	ISORT1=IS(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
C Local systems should be known for these orbitals
	IF(.NOT.LTBAS(L1,IATOM1))CYCLE ! skip errors
	IF(.NOT.LTBAS(L ,IATOM ))CYCLE ! skip errors
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	THOP(M1,M)=(0.D0,0.D0)
	SHOP(M1,M)=(0.D0,0.D0)
	DO K1=-L1,L1
	L1K1=L1*(L1+1)+K1+1
	DO K=-L,L
	LK=L*(L+1)+K+1
	THOP(M1,M)=THOP(M1,M)+CONJG(TC(M1,K1+L1+1,L1))*
     &TMAT(L1K1,LK,IATOM1,IENV,IUPDN,IORBS)*TC(M,K+L+1,L)
	SHOP(M1,M)=SHOP(M1,M)+CONJG(TC(M1,K1+L1+1,L1))*
     &SMAT(L1K1,LK,IATOM1,IENV,IUPDN,IORBS)*TC(M,K+L+1,L)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=THOP(M1,M)
	SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=SHOP(M1,M)
	ENDDO
	ENDDO
      ENDDO                                 !!! over hopping integrals
	ENDDO                                 !!! over spins
	ENDDO                                 !!! over iorbs
	ENDIF
C ************************************************************
C TRANSFERE TO GLOBAL COORDINATE SYSTEM
	ITRAN=1
	IF(ITRAN.EQ.1)THEN
	DO IORBS=1,NORBS                       !!! over iorbs
	DO IUPDN=1,NSPIN                       !!! over spins
	DO IHOP=1,NHOP                         !!! over hopping integrals
	READ(HIND(IHOP),*)L1,L,IATOM1,IENV
	ISORT1=IS(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
C Local systems should be known for these orbitals
	IF(.NOT.LTBAS(L1,IATOM1))CYCLE ! skip errors
	IF(.NOT.LTBAS(L ,IATOM ))CYCLE ! skip errors
C Built transformation matrices. Operation transforms GLOBAL system to LOCAL system
C                                            (maybe vice versa, it has to be checked!)
      CALL TRANSU(L1,RINPAXE(1,L1,IATOM1),RINPANG(L1,IATOM1),
     &RINPINV(L1,IATOM1),UL,NWIGMEM)
      CALL TRANSU(L ,RINPAXE(1,L ,IATOM ),RINPANG(L ,IATOM ),
     &RINPINV(L ,IATOM ),UR,NWIGMEM)
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	THOP(M1,M)=(0.D0,0.D0)
	SHOP(M1,M)=(0.D0,0.D0)
	DO K1=-L1,L1
	L1K1=L1*(L1+1)+K1+1
	DO K=-L,L
	LK=L*(L+1)+K+1
	IWIG1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+K1)+L1+M1+1 ! (l1,m1 k1) packed
	IWIG =L *(2*L -1)*(2*L +1)/3+(2*L +1)*(L +K )+L +M +1 ! (l ,m  k ) packed
C Tglobal(m'm) = U(m'k')(g)*Tlocal(k'k)*conjg(U)(mk)(g)       ! <Y*(m', r)|Y(m, r)>=
	THOP(M1,M)=THOP(M1,M)+UL(IWIG1)*                      ! <Y*(m',gr)|Y(m,gr)>
     &TMAT(L1K1,LK,IATOM1,IENV,IUPDN,IORBS)*CONJG(UR(IWIG))
	SHOP(M1,M)=SHOP(M1,M)+UL(IWIG1)*
     &SMAT(L1K1,LK,IATOM1,IENV,IUPDN,IORBS)*CONJG(UR(IWIG))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=THOP(M1,M)
	SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=SHOP(M1,M)
	ENDDO
	ENDDO
      ENDDO                                 !!! over hopping integrals
	ENDDO                                 !!! over spins
	ENDDO                                 !!! over iorbs
	ENDIF
C **********************************************************
C GENERATE WHOLE HOPPING MATRIX BY APPLYING GROUP OPERATIONS
	ISTOP=0
	DO IORBS=1,NORBS                            !!! over iorbs
	DO IUPDN=1,NSPIN                            !!! over spins
	DO IHOP=1,NHOP                              !!! over hopping integrals
	READ(HIND(IHOP),*)L1,L,IATOM1,IENV
	ISORT1=IS(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
      DO IR=1,NGROUP                              !!! over point group
      IG=IKOV(IR)
	IATOM1G=IP(IATOM1,IR)
	IENVG=IPENV(IENV,IATOM1,IR)
	IATOMG=ISENV(IENVG,IATOM1G)
C Set complex conjugate:
      DO IE=0,NENV(IATOMG)
      DIFF=(TENV(1,IENVG,IATOM1G)+TENV(1,IE,IATOMG))**2
     &    +(TENV(2,IENVG,IATOM1G)+TENV(2,IE,IATOMG))**2
     &    +(TENV(3,IENVG,IATOM1G)+TENV(3,IE,IATOMG))**2
      IF(DIFF.LE.1.D-10)EXIT
      ENDDO
      IF(IE.EQ.NENV(IATOMG)+1)
     &CALL FULLSTOP('<READHOP> WRONG CONJUGATION')
      IENV1G=IE
C Start looping over subblock
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	THOP(M1,M)=(0.D0,0.D0)
	SHOP(M1,M)=(0.D0,0.D0)
	DO M2=-L1,L1
      L1M2=L1*(L1+1)+M2+1
      IWIG21=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M1)+L1+M2+1
	DO M3=-L,L
      LM3=L*(L+1)+M3+1
      IWIG30=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M3+1
	THOP(M1,M)=THOP(M1,M)+CONJG(U(IWIG21,IG))*
     &TMAT(L1M2,LM3,IATOM1,IENV,IUPDN,IORBS)*U(IWIG30,IG)
	SHOP(M1,M)=SHOP(M1,M)+CONJG(U(IWIG21,IG))*
     &SMAT(L1M2,LM3,IATOM1,IENV,IUPDN,IORBS)*U(IWIG30,IG)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C ************************************************************
C SET UP ROTATED MATRIX, CHECK IT WHETHER IT COINCIDES
C WITH THE INPUT MATRIX
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(IHO.EQ.1.AND.ISCHM.EQ.1)THEN
	DO INF=1,NINF
	READ(HINF(INF),*)IATOM1R,NM1R,L1R,M1R,IATOMR,NMR,
     &LR,MR,IENVR,IENV1R
	IF(IATOM1R.EQ.IATOM1G.AND.L1R.EQ.L1.AND.M1R.EQ.M1.AND.
     &IATOMR.EQ.IATOMG.AND.LR.EQ.L.AND.MR.EQ.M.
     &AND.IENVR.EQ.IENVG)THEN
	DIFF=ABS(TMAT(L1M1,LM,IATOM1G,IENVG,IUPDN,IORBS)-THOP(M1,M))
	IF(DIFF.GE.1.D-04)
     &WRITE(IUT,*)'<READHOP>: ROTATED TMATRIX MISMATCHES WITH INPUT:',
     &THOP(M1,M),TMAT(L1M1,LM,IATOM1G,IENVG,IUPDN,IORBS),
     &L1M1,LM,IATOM1G,IENVG
	IF(DIFF.GE.1.D-04)ISTOP=1
	DIFF=ABS(SMAT(L1M1,LM,IATOM1G,IENVG,IUPDN,IORBS)-SHOP(M1,M))
	IF(DIFF.GE.1.D-04)
     &WRITE(IUT,*)'<READHOP>: ROTATED SMATRIX MISMATCHES WITH INPUT:',
     &SHOP(M1,M),SMAT(L1M1,LM,IATOM1G,IENVG,IUPDN,IORBS),
     &L1M1,LM,IATOM1G,IENVG
	IF(DIFF.GE.1.D-04)ISTOP=1
	ENDIF
	ENDDO
	ENDIF
	TMAT(L1M1,LM,IATOM1G,IENVG,IUPDN,IORBS)=THOP(M1,M)
	SMAT(L1M1,LM,IATOM1G,IENVG,IUPDN,IORBS)=SHOP(M1,M)
C Complex conjugates
	IF(IORBS.EQ.1)IUPDN1=IUPDN
	IF(IORBS.EQ.2)IUPDN1=3-IUPDN
	TMAT(LM,L1M1,IATOMG,IENV1G,IUPDN1,IORBS)=DCONJG(THOP(M1,M))
	SMAT(LM,L1M1,IATOMG,IENV1G,IUPDN1,IORBS)=DCONJG(SHOP(M1,M))
	ENDDO
	ENDDO
	ENDDO                                     !!! over point group
      ENDDO                                     !!! over hopping integrals
	ENDDO                                     !!! over spins
	ENDDO                                     !!! over iorbs
C	IF(ISTOP.EQ.1)CALL FULLSTOP('<READHOP>: ERROR IN INPUT')
C ***************************************************************
C SET TB-SET
	IDIM=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	INBAS(LM,IATOM)=0
	IF(.NOT.LTBAS(L,IATOM))CYCLE
	IDIM=IDIM+1
	INBAS(LM,IATOM)=IDIM
	ENDDO
	ENDDO
	ENDDO
	NTBAS=IDIM
C PRINT TIGHT-BINDING BASIS SET
      NB=1
      DO ISORT=1,NSORT
      DO I=10,5,-1
      IF(TXTEL(ISORT)(I:I).NE.' ')EXIT
      ENDDO
      NB=MAX(NB,I)
      ENDDO
	WRITE(IUN,1030)NTBAS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(LTBAS(L,IATOM))WRITE(IUN,1040)TL(L),
     &TXTEL(ISORT)(:NB),IATOM
	ENDDO
	ENDDO
1010  FORMAT(A)
1020	FORMAT(1X,12(I3,1X))
1030	FORMAT(1X,'Tight-binding basis set::   ,total # =',I3)
1040	FORMAT(1X,A1,'-electrons ',A,'#',I2)
C IF INPUT REPRESENTATION DIFFERS FROM OUTPUT, WE MUST REBUILD HINF ARRAY
	INPOUT=.TRUE.
	IF(ICUBI.NE.ICUBC)INPOUT=.FALSE.
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
	IF(ABS(RINPAXE(1,L,IATOM)-ROUTAXE(1,L,IATOM)).GT.1.D-10.OR.
     &   ABS(RINPAXE(2,L,IATOM)-ROUTAXE(2,L,IATOM)).GT.1.D-10.OR.
     &   ABS(RINPAXE(3,L,IATOM)-ROUTAXE(3,L,IATOM)).GT.1.D-10.OR.
     &   ABS(RINPANG(L,IATOM)-ROUTANG(L,IATOM)).GT.1.D-10.OR.
     &   ABS(RINPINV(L,IATOM)-ROUTINV(L,IATOM)).GT.1.D-10)
     &   INPOUT=.FALSE.
	ENDDO
	ENDDO
      IF(.NOT.INPOUT)CALL FINDIRR(ICUBC,ROUTAXE,ROUTANG,ROUTINV,1,2)
C STORE INPUT HOPPINGS WITH THE NEW REPRESENTATION
	CALL WRITEHOP(1)
C MEMORY DEALLOCATIONS
	DEALLOCATE(THOP,SHOP)
	DEALLOCATE(UL,UR)
C ERROR HANDLINGS
      CONTAINS
      SUBROUTINE READHOP_MESG01
	WRITE(IUT,*)'Terminated in <READHOP>:'
	WRITE(IUT,*)'Input HOPFILE ',HOPFILE
	WRITE(IUT,*)'cannot be found. Check path and'
	WRITE(IUT,*)'its existence.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READHOP_MESG01
      SUBROUTINE READHOP_MESG02(CHARV,LSIZE)
      CHARACTER CHARV*(*)
      WRITE(IUT,*)'Terminated in <READHOP>:'
      WRITE(IUT,*)'Memory allocation problem detected by'
      WRITE(IUT,*)'the system. Array '//CHARV//' of the size:'
      WRITE(IUT,*) DBLE(LSIZE)/1024.D0,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
      CALL FULLSTOP(' ')
      END SUBROUTINE READHOP_MESG02
      SUBROUTINE READHOP_MESG03
	WRITE(IUT,*)'Terminated in <READHOP>:'
	WRITE(IUT,*)'Screened LMTO representation must be selected'
	WRITE(IUT,*)'in order to deal with hopping integrals.'
	WRITE(IUT,*)'Specify input keyword LMTO=2 in INIFILE.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READHOP_MESG03
      SUBROUTINE READHOP_MESG04
	WRITE(IUT,*)'Terminated in <READHOP>:'
	WRITE(IUT,*)'Non-zero cluster size must be specified'
	WRITE(IUT,*)'in order to deal with hopping integrals.'
	WRITE(IUT,*)'Specify input keyword Rcls in INIFILE.'
	CALL FULLSTOP(' ')
	END SUBROUTINE READHOP_MESG04
      SUBROUTINE READHOP_MESG05(L,IATOM)
	WRITE(IUT,*)'State l,iatom::',L,IATOM,
     &  'is not described in the section TBAS!'
	IERROR=1
	END SUBROUTINE READHOP_MESG05
	END SUBROUTINE READHOP



	SUBROUTINE WRITEHOP(KW)
*******************************************************
*  Writes hopping matrix back to the HOPFILE.         *
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY : NATOM,NSORT,NSPIN,IS,ILSB        !!! from readini
      USE COM_TBBPAR ,ONLY : LTBAS,LSBAS,INBAS,NTBAS,MQBAS    !!! from readhop
	USE COM_SPHERE ,ONLY : FILING                           !!! from readhop
      USE COM_HOPCOM ,ONLY : TMAT,SMAT,PMAT                   !!! from readhop
      USE COM_TBBSYS ,ONLY : RINPAXE,RINPANG,ROUTAXE,ROUTANG  !!! from readhop
     &                      ,RINPINV,ROUTINV,CHSYS,CHAXE,CHANG,CHINV
      USE COM_HOPDAT ,ONLY : NINF,NHOP,ISCHM,ICUBC,IRE,IHO    !!! from readhop
     &                      ,HINF,HIND                        !!! from readhop
      USE COM_LMTINP ,ONLY : ICHOP,HOPFILE                    !!! from readini
      USE COM_LMTOUT ,ONLY : ICHPP,HPPFILE                    !!! from readini
      USE COM_LABELS ,ONLY : TXTEL,TXTSP,TXTAT                !!! from readini
      USE COM_UNIT   ,ONLY : IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL EXIST
	CHARACTER TCTRL*10,TXTH*150,TL(0:3)*1,TEXT*60,STRING*150
     &    ,FILE*130,HELP*40
      DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/
	IF(ICHOP.EQ.0.AND.KW.EQ.1)RETURN
	IF(ICHPP.EQ.0.AND.KW.EQ.2)RETURN
	IF(KW.EQ.1)FILE=HOPFILE
	IF(KW.EQ.2)FILE=HPPFILE
C CHECK EXISTENCE
      INQUIRE(FILE=FILE,EXIST=EXIST)
      IF(EXIST)THEN
      OPEN(UNIT=IUINP,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUINP,STATUS='DELETE')
	ENDIF
      OPEN(UNIT=IUINP,FILE=FILE,STATUS='NEW',FORM='FORMATTED')
C START STORAGE
	WRITE(IUINP,10100)
	WRITE(IUINP,10110)
10100	FORMAT(1X,'<FILE=HOPFILE,INPUT=MODERN>')
10110 FORMAT('****************************************************')
C PRINT CONTROL PARAMETERS
	WRITE(IUINP,10120)
10120 FORMAT(1X,'<SECTION=CTRL>',14X,'! CONTROL PARAMETERS:')
C Process SCHM
	IF(ISCHM.EQ.0)TCTRL='Bnd0     '
	IF(ISCHM.EQ.1)TCTRL='Bnd1     '
      HELP='! Bnd0/Bnd1 -performing symmetry checks '
	WRITE(IUINP,10130)TCTRL,HELP
10130 FORMAT(1X,'Scheme=',A10,11X,A40)
C Process CUBC
      HELP='! Cubic/Spherical harmonics (output)    '
	IF(ICUBC.EQ.1)TCTRL='cubic    '
	IF(ICUBC.EQ.2)TCTRL='spherical'
	WRITE(IUINP,10150)TCTRL,HELP
10150 FORMAT(1X,'Yharm =',A10,11X,A40)
C Process CUBI
      HELP='! Cubic/Spherical harmonics (input)     '
	IF(ICUBC.EQ.1)TCTRL='cubic    '
	IF(ICUBC.EQ.2)TCTRL='spherical'
	WRITE(IUINP,10160)TCTRL,HELP
10160 FORMAT(1X,'Iharm =',A10,11X,A40)
C Process REIM
      HELP='! Real/Complex input/output             '
	IF(IRE.EQ.1)TCTRL='real      '
	IF(IRE.EQ.2)TCTRL='complex   '
	WRITE(IUINP,10190)TCTRL,HELP
10190 FORMAT(1X,'Format=',A10,11X,A40)
C PRINT CORRELATED STATES
	WRITE(IUINP,10510)
10510 FORMAT(1X,'<SECTION=TBAS>',14X,'! TIGHT-BINDING STATES:')
C Process FILLING
      HELP='! # of tight-binding states             '
	WRITE(IUINP,10520)FILING,HELP
10520 FORMAT(1X,'Fill  =',G12.5,9X,A40)
C Process NTBS
      HELP='! # of tight-binding states             '
	NTBS=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
	NTBS=NTBS+1
	ENDDO
	ENDDO
	WRITE(IUINP,10530)NTBS,HELP
10530 FORMAT(1X,'Ntbs  =',I3,18X,A40)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
C Process LHUB
      HELP='! TB state pointer                      '
	MQ=MQBAS(L,IATOM)
	CALL SET_STATE(TCTRL,10,TXTAT(ISORT),IATOM,0,MQ,L,-100,ICUBC)
	WRITE(IUINP,10540)TCTRL,HELP
10540 FORMAT(1X,'hState  =',A10,9X,A40)
C ************************
C Output coordinate system
      HELP='! global/local coordinate system        '
	CALL FIND_LBLANK(CHSYS(L,IATOM),10,NBL)
	IF(NBL.GT.0)
     &WRITE(IUINP,10550)CHSYS(L,IATOM),HELP
10550 FORMAT(1X,'OutSys  =',A10,9X,A40)
      HELP='! rotational axis                       '
	CALL FIND_LBLANK(CHAXE(L,IATOM),80,NBL)
	IF(NBL.LE.18.AND.NBL.GT.0)
     &WRITE(IUINP,10560)CHAXE(L,IATOM)(1:18),HELP
	IF(NBL.GT.18)
     &WRITE(IUINP,10565)CHAXE(L,IATOM)
10560 FORMAT(1X,'OutAxis =',A18,1X,A40)
10565 FORMAT(1X,'OutAxis =',A80)
      HELP='! rotational angle                      '
	CALL FIND_LBLANK(CHANG(L,IATOM),80,NBL)
	IF(NBL.LE.18.AND.NBL.GT.0)
     &WRITE(IUINP,10570)CHANG(L,IATOM)(1:18),HELP
	IF(NBL.GT.18)
     &WRITE(IUINP,10575)CHANG(L,IATOM)
10570 FORMAT(1X,'OutAngle=',A18,1X,A40)
10575 FORMAT(1X,'OutAngle=',A80)
C Apply inversion
      HELP='! apply inversion after rotation        '
	CALL FIND_LBLANK(CHINV(L,IATOM),10,NBL)
	IF(NBL.GT.0)
     &WRITE(IUINP,10580)CHINV(L,IATOM),HELP
10580 FORMAT(1X,'OutInv  =',A10,9X,A40)
C ************************
C Input coordinate system
      HELP='! global/local coordinate system        '
	CALL FIND_LBLANK(CHSYS(L,IATOM),10,NBL)
	IF(NBL.GT.0)
     &WRITE(IUINP,10590)CHSYS(L,IATOM),HELP
10590 FORMAT(1X,'InpSys  =',A10,9X,A40)
      HELP='! rotational axis                       '
	CALL FIND_LBLANK(CHAXE(L,IATOM),80,NBL)
	IF(NBL.LE.18.AND.NBL.GT.0)
     &WRITE(IUINP,10600)CHAXE(L,IATOM)(1:18),HELP
	IF(NBL.GT.18)
     &WRITE(IUINP,10605)CHAXE(L,IATOM)
10600 FORMAT(1X,'InpAxis =',A18,1X,A40)
10605 FORMAT(1X,'InpAxis =',A80)
      HELP='! rotational angle                      '
	CALL FIND_LBLANK(CHANG(L,IATOM),80,NBL)
	IF(NBL.LE.18.AND.NBL.GT.0)
     &WRITE(IUINP,10610)CHANG(L,IATOM)(1:18),HELP
	IF(NBL.GT.18)
     &WRITE(IUINP,10615)CHANG(L,IATOM)
10610 FORMAT(1X,'InpAngle=',A18,1X,A40)
10615 FORMAT(1X,'InpAngle=',A80)
C Apply inversion
      HELP='! apply inversion after rotation        '
	CALL FIND_LBLANK(CHINV(L,IATOM),10,NBL)
	IF(NBL.GT.0)
     &WRITE(IUINP,10620)CHINV(L,IATOM),HELP
10620 FORMAT(1X,'InpInv  =',A10,9X,A40)
	ENDDO                                  !!! over correlated states
	ENDDO                                  !!! over correlated states
C PRINT HOPPINGS
	CALL PRINTHM(IUINP)
	CLOSE(IUINP)
	END





	SUBROUTINE PRINTHM(ICHAN)
*******************************************************
*  Prints hopping matrix.                             *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
      USE COM_TBBPAR ,ONLY : LTBAS,LSBAS,INBAS,NTBAS          !!! from readhop
      USE COM_TBBSYS ,ONLY : RINPAXE,RINPANG,ROUTAXE,ROUTANG  !!! from readhop
     &                      ,RINPINV,ROUTINV
      USE COM_HOPCOM ,ONLY : TMAT,SMAT,PMAT                   !!! from readhop
      USE COM_HOPDAT ,ONLY : NINF,NHOP,ISCHM,ICUBC,IRE,IHO    !!! from readhop
     &                      ,HINF,HIND                        !!! from readhop
      USE COM_LMTINP ,ONLY : ICHOP,HOPFILE                    !!! from readini
      USE COM_LABELS ,ONLY : TXTEL,TXTSP,TXTAT                !!! from readini
      USE COM_UNIT   ,ONLY : IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: THOPL(:,:)
	COMPLEX*16, ALLOCATABLE :: SHOPL(:,:)
	COMPLEX*16, ALLOCATABLE :: THOPC(:,:)
	COMPLEX*16, ALLOCATABLE :: SHOPC(:,:)
	COMPLEX*16, ALLOCATABLE :: UL(:)
	COMPLEX*16, ALLOCATABLE :: UR(:)
	COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3),CVAL(2)
	CHARACTER TXTH*150
      DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(THOPL(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(SHOPL(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(THOPC(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(SHOPC(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(UL(NWIGMEM))
	ALLOCATE(UR(NWIGMEM))
C PRINT CORRELATED STATES
	IF(NINF.EQ.0)RETURN
	WRITE(ICHAN,10000)
C STORE CALCULATED HOPPING INTEGRALS
      WRITE(ICHAN,10010)NINF
      WRITE(ICHAN,10020)
      DO INF=1,NINF
	READ(HINF(INF),*)IATOM1,NM1,L1,K1R,IATOM,NM,
     &  L,KR,IENV,IENV1,IUPDN,IORBS
	IF(NSPIN.EQ.1)THEN
	ISPIN1=0
	ISPIN =0
	ELSEIF(NSPIN.EQ.2.AND.IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(NSPIN.EQ.2.AND.IORBS.EQ.2)THEN
      ISPIN1=NSPIN+1-IUPDN
      ISPIN =IUPDN
	ENDIF
C TRANSFERE TO GLOBAL COORDINATE SYSTEM
	ISORT1=IS(IATOM1)
	ISORT=IS(IATOM)
C Local systems should be known for these orbitals
	IF(.NOT.LTBAS(L1,IATOM1))CYCLE ! skip errors
	IF(.NOT.LTBAS(L ,IATOM ))CYCLE ! skip errors
C Built transformation matrices, Operation trasforms GLOBAL system to LOCAL system
C                                         (maybe vice versa, it has to be checked!)
      CALL TRANSU(L1,ROUTAXE(1,L1,IATOM1),ROUTANG(L1,IATOM1),
     &ROUTINV(L1,IATOM1),UL,NWIGMEM)
      CALL TRANSU(L ,ROUTAXE(1,L ,IATOM ),ROUTANG(L ,IATOM ),
     &ROUTINV(L ,IATOM ),UR,NWIGMEM)
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	THOPL(M1,M)=(0.D0,0.D0)
	SHOPL(M1,M)=(0.D0,0.D0)
	DO K1=-L1,L1
	L1K1=L1*(L1+1)+K1+1
	DO K=-L,L
	LK=L*(L+1)+K+1
      IWIG1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M1)+L1+K1+1 ! (l1,k1 m1) packed
      IWIG =L *(2*L -1)*(2*L +1)/3+(2*L +1)*(L +M )+L +K +1 ! (l ,k  m ) packed
C Tlocal(m'm) = U(m'k')(g^-1)*Tglobal(k'k)*conjg(U)(mk)(g^-1) ! reciprocal operation
C Tlocal(m'm) = conjg(U)(k'm')(g)*Tglobal(k'k)*U(km)(g)       ! <Y*(m',g^-1r)|Y(m,g^-1r)>=
      THOPL(M1,M)=THOPL(M1,M)+CONJG(UL(IWIG1))*             ! <Y*(m',    r)|Y(m,    r)>
     &TMAT(L1K1,LK,IATOM1,IENV,IUPDN,IORBS)*UR(IWIG)
      SHOPL(M1,M)=SHOPL(M1,M)+CONJG(UL(IWIG1))*
     &SMAT(L1K1,LK,IATOM1,IENV,IUPDN,IORBS)*UR(IWIG)
      THOPL(M1,M)=THOPL(M1,M)+CONJG(UL(IWIG1))*
     &PMAT(L1K1,LK,IATOM1,IENV,IUPDN,IORBS)*UR(IWIG)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C TRANSFER TO CUBIC HARMONICS IF NECESSARY
	IF(ICUBC.EQ.1)THEN
	CALL TRANSS(TS)   ! built transformation matrices
      DO K1=-L1,L1
      L1K1=L1*(L1+1)+K1+1
      DO K=-L,L
      LK=L*(L+1)+K+1
      THOPC(K1,K)=(0.D0,0.D0)
      SHOPC(K1,K)=(0.D0,0.D0)
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      THOPC(K1,K)=THOPC(K1,K)+CONJG(TS(K1+L1+1,M1,L1))*
     &THOPL(M1,M)*TS(K+L+1,M,L)
      SHOPC(K1,K)=SHOPC(K1,K)+CONJG(TS(K1+L1+1,M1,L1))*
     &SHOPL(M1,M)*TS(K+L+1,M,L)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	ELSE
	L1K1R=L1*(L1+1)+K1R+1
	LKR=L*(L+1)+KR+1
	THOPC(K1R,KR)=THOPL(K1R,KR)
	SHOPC(K1R,KR)=SHOPL(K1R,KR)
	ENDIF
	CVAL(1)=THOPC(K1R,KR)
	CVAL(2)=SHOPC(K1R,KR)
      CALL WRIORB(TXTH,NB,ICUBC,IRE,2,CVAL(1),
     &IATOM1,ISPIN1,NM1,L1,K1R,IATOM,ISPIN,NM,L,KR,IENV,IENV1)
      WRITE(ICHAN,10030)TXTH(:NB)
	ENDDO
 1000	CONTINUE                           !!! over spins
 2000	CONTINUE                           !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(THOPL,SHOPL)
	DEALLOCATE(THOPC,SHOPC)
	DEALLOCATE(UL,UR)
C FORMATS
10000 FORMAT(1X,'<SECTION=HOPP>',14X,'! HOPPINGS INTEGRALS:')
10010 FORMAT(1X,'nHop = ',I5,16X,'! # of hoppings')
10020	FORMAT('!    <From>',7X,
     &'<To> the orbital via connection:',
     &14X,'<Energy>',3X,'<Overlap>')
10030	FORMAT(1X,A)                           
	END









      SUBROUTINE REDORB(TXTH,NB,ICUBC,IRE,NV,CVAL,
     &IATOM1,ISPIN1,NM1,L1,M1,IATOM,ISPIN,NM,L,M,IENV,IENV1)
*******************************************************
*  Reads information from the TXTH string concerning  *
*  hopping matrix elements.                           *
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM,  ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
      USE COM_LATPAR, ONLY : PAR,ORTH,OMEGAC                  !!! from readini
      USE COM_LATTICE,ONLY : RBAS,GBAS,TAU                    !!! from readstr
      USE COM_SCRINP, ONLY : RLOC                             !!! from alpcon
      USE COM_ENVSITE,ONLY : NENV,TENV,ISENV,IPENV,IRENV      !!! from envmesh
      USE COM_LABELS, ONLY : TXTEL,TXTSP,TXTAT                !!! from readini
      USE COM_UNIT,   ONLY : IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEC(3),RVAL(10)
	COMPLEX*16 CVAL(NV)
	CHARACTER TXTH*(*),TL(0:3)*1,TCUBC(-3:3,0:3,2)*10
     &    ,STRING(80)*1,TW1*10,TW2*10,TNOT*30
      DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/
	CALL INTCUBC(TCUBC)
	CALL CONVLOW(TXTH,NB)
	IPOS=1
C STATE <FROM>
	DO IB=IPOS,NB
      IF(TXTH(IB:IB).EQ.'|')EXIT
	IF(IB-IPOS+1.GT.30)CALL FULLSTOP('<READHOP>: WRONG Syntax')
	TNOT(IB-IPOS+1:IB-IPOS+1)=TXTH(IB:IB)
	ENDDO
      DO IB0=IPOS,IB
      TXTH(IB0:IB0)=' '
      ENDDO
	DO IB0=IB-IPOS+2,30
	TNOT(IB0:IB0)=' '
	ENDDO
	IPOS=IB
	CALL GET_STATE(TNOT,30,IATOM1,ISPIN1,NM1,L1,M1,ICUBC)
C STATE <TO>
	DO IB=IPOS,NB
      IF(TXTH(IB:IB).EQ.'|')EXIT
	IF(IB-IPOS+1.GT.30)CALL FULLSTOP('<READHOP>: WRONG Syntax')
	TNOT(IB-IPOS+1:IB-IPOS+1)=TXTH(IB:IB)
	ENDDO
      DO IB0=IPOS,IB
      TXTH(IB0:IB0)=' '
      ENDDO
	DO IB0=IB-IPOS+2,30
	TNOT(IB0:IB0)=' '
	ENDDO
	IPOS=IB
	CALL GET_STATE(TNOT,30,IATOM,ISPIN,NM,L,M,ICUBC)
C SEARCH FOR CONNECTING VECTOR
	LENGHT=0
	DO I1=1,80
	STRING(I1)=' '
	ENDDO
	DO IB=IPOS,NB
      IF(TXTH(IB:IB).EQ.'|')EXIT
	LENGHT=LENGHT+1
	STRING(LENGHT:LENGHT)=TXTH(IB:IB)
	ENDDO
	CALL COMPVEC(STRING,VEC,3)
	VEC(1)=VEC(1)*1.D0
	VEC(2)=VEC(2)*ORTH(2)
	VEC(3)=VEC(3)*ORTH(3)
      IF(SQRT(VEC(1)**2+VEC(2)**2+VEC(3)**2).GT.RLOC(IS(IATOM1)))
     &CALL FULLSTOP('<REDORB> RLOC IS TOO SMALL')
	DO IE=0,NENV(IATOM1)
	DIFF=(VEC(1)-TENV(1,IE,IATOM1))**2+
     &     (VEC(2)-TENV(2,IE,IATOM1))**2+
     &     (VEC(3)-TENV(3,IE,IATOM1))**2
	IF(DIFF.LE.1.D-04)EXIT
	ENDDO
	IF(IE.EQ.NENV(IATOM1)+1)
     &CALL FULLSTOP('<REDORB>: CANNOT FIND <TO IENV>')
	IENV=IE
	IATOM=ISENV(IENV,IATOM1)
C Set complex conjugate:
      DO IE=0,NENV(IATOM)
      DIFF=(VEC(1)+TENV(1,IE,IATOM))**2
     &    +(VEC(2)+TENV(2,IE,IATOM))**2
     &    +(VEC(3)+TENV(3,IE,IATOM))**2
      IF(DIFF.LE.1.D-10)EXIT
      ENDDO
      IF(IE.EQ.NENV(IATOM)+1)
     &CALL FULLSTOP('<REDORB> WRONG CONJUGATION')
	IENV1=IE
	DO IB0=IPOS,IB
	TXTH(IB0:IB0)=' '
	ENDDO
C READ NUMBERS
	DO IB0=IPOS,NB
	IF(TXTH(IB0:IB0).EQ.'|')TXTH(IB0:IB0)=' '
	ENDDO
	IF(IRE.EQ.1)READ(TXTH,*)(RVAL(I),I=1,NV)
	IF(IRE.EQ.2)READ(TXTH,*)(CVAL(I),I=1,NV)
	IF(IRE.EQ.1)THEN
	DO IV=1,NV
	CVAL(IV)=DCMPLX(RVAL(IV),0.D0)
	ENDDO
	ENDIF
	END



      SUBROUTINE WRIORB(TXTH,NB,ICUBC,IRE,NV,CVAL,
     &IATOM1,ISPIN1,NM1,L1,M1,IATOM,ISPIN,NM,L,M,IENV,IENV1)
*******************************************************
*  Writes information to the TXTH string concerning   *
*  hopping matrix elements.                           *
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM,  ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
      USE COM_LATPAR, ONLY : PAR,ORTH,OMEGAC                  !!! from readini
      USE COM_LATTICE,ONLY : RBAS,GBAS,TAU                    !!! from readstr
      USE COM_SCRINP, ONLY : RLOC                             !!! from alpcon
      USE COM_ENVSITE,ONLY : NENV,TENV,ISENV,IPENV,IRENV      !!! from envmesh
      USE COM_LABELS, ONLY : TXTEL,TXTSP,TXTAT                !!! from readini
      USE COM_UNIT,   ONLY : IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEC(3),RVAL(10)
	COMPLEX*16 CVAL(NV)
	CHARACTER TXTH*150,TL(0:3)*1,TCUBC(-3:3,0:3,2)*10
     &    ,STRING(80)*1,TW1*10,TW2*10
     &    ,TDPS*8,TCPS*19,TW3*19
        DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/
	CALL INTCUBC(TCUBC)
C INITIALIZE STRING
	DO IB=1,150
	TXTH(IB:IB)=' '
	ENDDO
C SET IATOM1, SITE <FROM>
	IPOINT=0
	ISORT1=IS(IATOM1)
	CALL FIND_LBLANK(TXTAT(ISORT1),10,NBL)
	DO IB=1,NBL
	TXTH(IPOINT+IB:IPOINT+IB)=TXTAT(ISORT1)(IB:IB)
	ENDDO
	IPOINT=IPOINT+NBL+1
	TXTH(IPOINT:IPOINT)='@'
	IPOINT=IPOINT+1
	IF(IATOM1.LE.9)THEN
      WRITE(TXTH(IPOINT:IPOINT+1),FMT='(I1)')IATOM1
	ELSEIF(IATOM1.LE.99.AND.IATOM1.GT.9)THEN
      WRITE(TXTH(IPOINT:IPOINT+2),FMT='(I2)')IATOM1
	ELSEIF(IATOM1.LE.999.AND.IATOM1.GT.99)THEN
      WRITE(TXTH(IPOINT:IPOINT+3),FMT='(I3)')IATOM1
	ELSE
	CALL FULLSTOP('<WRIORB> # ATOMS>999 NOT ALLOWED HERE')
	ENDIF
	IF(NATOM.LE.999)ID=3
	IF(NATOM.LE.99 )ID=2
	IF(NATOM.LE.9  )ID=1
	IPOINT=IPOINT+ID
C SET SPIN1
	IF(ISPIN1.EQ.1)THEN
	TXTH(IPOINT:IPOINT+2)='-up'
	IPOINT=IPOINT+3
	ELSEIF(ISPIN1.EQ.2)THEN
	TXTH(IPOINT:IPOINT+2)='-dn'
	IPOINT=IPOINT+3
	ENDIF
C SET ORBITAL <FROM>
	TXTH(IPOINT:IPOINT+1)='::'
	IPOINT=IPOINT+2
	WRITE(TXTH(IPOINT:IPOINT),FMT='(I1)')NM1
	IPOINT=IPOINT+1
	IF(L1.EQ.0)TXTH(IPOINT:IPOINT)='s'
	IF(L1.EQ.1)TXTH(IPOINT:IPOINT)='p'
	IF(L1.EQ.2)TXTH(IPOINT:IPOINT)='d'
	IF(L1.EQ.3)TXTH(IPOINT:IPOINT)='f'
	IPOINT=IPOINT+1
	JPOINT=IPOINT
	TXTH(IPOINT:IPOINT)='{'
	TW2=TCUBC(M1,L1,ICUBC)
	CALL RMBLANK(TW2,10)
	DO IB=1,10
	IF(TW2(IB:IB).EQ.' ')EXIT
	TXTH(IPOINT+IB:IPOINT+IB)=TW2(IB:IB)
	ENDDO
	IPOINT=IPOINT+IB
	TXTH(IPOINT:IPOINT)='}'
	IPOINT=JPOINT+10
	TXTH(IPOINT:IPOINT)='|'
	IPOINT=IPOINT+2
C SET IATOM, SITE <TO>
	ISORT=IS(IATOM)
	CALL FIND_LBLANK(TXTAT(ISORT),10,NBL)
	DO IB=1,NBL
	TXTH(IPOINT+IB:IPOINT+IB)=TXTAT(ISORT)(IB:IB)
	ENDDO
	IPOINT=IPOINT+NBL+1
	TXTH(IPOINT:IPOINT)='@'
	IPOINT=IPOINT+1
	IF(IATOM1.LE.9)THEN
      WRITE(TXTH(IPOINT:IPOINT+1),FMT='(I1)')IATOM
	ELSEIF(IATOM1.LE.99.AND.IATOM1.GT.9)THEN
      WRITE(TXTH(IPOINT:IPOINT+2),FMT='(I2)')IATOM
	ELSEIF(IATOM1.LE.999.AND.IATOM1.GT.99)THEN
      WRITE(TXTH(IPOINT:IPOINT+3),FMT='(I3)')IATOM
	ELSE
	CALL FULLSTOP('<WRIORB> # ATOMS>999 NOT ALLOWED HERE')
	ENDIF
	IF(NATOM.LE.999)ID=3
	IF(NATOM.LE.99 )ID=2
	IF(NATOM.LE.9  )ID=1
	IPOINT=IPOINT+ID
C SET SPIN
	IF(ISPIN.EQ.1)THEN
	TXTH(IPOINT:IPOINT+2)='-up'
	IPOINT=IPOINT+3
	ELSEIF(ISPIN.EQ.2)THEN
	TXTH(IPOINT:IPOINT+2)='-dn'
	IPOINT=IPOINT+3
	ENDIF
	TXTH(IPOINT:IPOINT+1)='::'
	IPOINT=IPOINT+2
C SET ORBITAL <TO>
	WRITE(TXTH(IPOINT:IPOINT),FMT='(I1)')NM
	IPOINT=IPOINT+1
	IF(L.EQ.0)TXTH(IPOINT:IPOINT)='s'
	IF(L.EQ.1)TXTH(IPOINT:IPOINT)='p'
	IF(L.EQ.2)TXTH(IPOINT:IPOINT)='d'
	IF(L.EQ.3)TXTH(IPOINT:IPOINT)='f'
	IPOINT=IPOINT+1
	JPOINT=IPOINT
	TXTH(IPOINT:IPOINT)='{'
	TW2=TCUBC(M,L,ICUBC)
	CALL RMBLANK(TW2,10)
	DO IB=1,10
	IF(TW2(IB:IB).EQ.' ')EXIT
	TXTH(IPOINT+IB:IPOINT+IB)=TW2(IB:IB)
	ENDDO
	IPOINT=IPOINT+IB
	TXTH(IPOINT:IPOINT)='}'
	IPOINT=JPOINT+10
	TXTH(IPOINT:IPOINT)='|'
	IPOINT=IPOINT+2
C  SET CONNECTING VECTOR
	VEC(1)=TENV(1,IENV,IATOM1)
	VEC(2)=TENV(2,IENV,IATOM1)/ORTH(2)
	VEC(3)=TENV(3,IENV,IATOM1)/ORTH(3)
	TW1=TDPS(VEC(1),1.D-05)
	DO IB=1,8
	TXTH(IPOINT+IB:IPOINT+IB)=TW1(IB:IB)
	ENDDO
	TXTH(IPOINT+9:IPOINT+9)=','
	IPOINT=IPOINT+9
	TW1=TDPS(VEC(2),1.D-05)
	DO IB=1,8
	TXTH(IPOINT+IB:IPOINT+IB)=TW1(IB:IB)
	ENDDO
	TXTH(IPOINT+9:IPOINT+9)=','
	IPOINT=IPOINT+9
	TW1=TDPS(VEC(3),1.D-05)
	DO IB=1,8
	TXTH(IPOINT+IB:IPOINT+IB)=TW1(IB:IB)
	ENDDO
	IPOINT=IPOINT+9
	TXTH(IPOINT:IPOINT)='|'
	IPOINT=IPOINT+2
C SET VALUES
	IF(IRE.EQ.1)THEN
	DO IV=1,NV
	TW1=TDPS(DREAL(CVAL(IV)),1.D-05)
	DO IB=1,8
	TXTH(IPOINT+IB:IPOINT+IB)=TW1(IB:IB)
	ENDDO
	TXTH(IPOINT+10:IPOINT+10)="|"
	IPOINT=IPOINT+11
	ENDDO
	IPOINT=IPOINT-3
	ELSEIF(IRE.EQ.2)THEN
	DO IV=1,NV
	TW3=TCPS(CVAL(IV),1.D-05)
	DO IB=1,19
	TXTH(IPOINT+IB:IPOINT+IB)=TW3(IB:IB)
	ENDDO
	TXTH(IPOINT+21:IPOINT+21)="|"
	IPOINT=IPOINT+22
	ENDDO
	IPOINT=IPOINT-3
	ENDIF
	NB=IPOINT
	END




