	SUBROUTINE SCRCON
******************************************************************* 
*  Calculates screened structure constants in real space using    *
*  inversion method.                                              *
*******************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                         !!! from setup
      USE COM_CONTROL   ,ONLY: LMTO                          !!! from readini
      USE COM_PARAM     ,ONLY: NATOM,NSORT,IS,ILST,ILSB,ILSV !!! from readini
      USE COM_LATPAR    ,ONLY: PAR,OMEGAC                    !!! from readini
      USE COM_KAPPAR    ,ONLY: NPAN,NKAP,EK,EKAP             !!! from readini
      USE COM_SPHERE    ,ONLY: SWZ,SMT                       !!! from readini
      USE COM_LATTICE   ,ONLY: RBAS,TAU                      !!! from readstr
      USE COM_SCRINP    ,ONLY: RLOC,ALPHA,ALPDOT,DTBLOG      !!! from alpcon
      USE COM_ENVSITE   ,ONLY: NENV,TENV,ISENV,IPENV,IRENV,ICENV!from envmesh
      USE COM_LMTOUT    ,ONLY: ICFTR,FTRFILE,ICSCR,SCRFILE   !!! from readini
      USE COM_LABELS    ,ONLY: TXTEL                         !!! from readini
      USE COM_UNIT      ,ONLY: IUN,IUR,IUT                   !!! from setup
      USE COM_MASHDEP   ,ONLY: NVAL,LENCMP                   !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: WORKS(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: WORKD(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: WORK(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SCRSS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SCRSD(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SBARE(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SBDOT(:,:,:)
	INTEGER, INTRINSIC :: SIZE
	INTEGER, ALLOCATABLE :: NENV0(:)
	COMPLEX*16, ALLOCATABLE :: SUMRUL(:,:)
	COMPLEX*16, ALLOCATABLE :: EK0(:)
	REAL*8, ALLOCATABLE :: TAUT(:,:)
	REAL*8, ALLOCATABLE :: WRK(:)
	COMPLEX*16 EXPKR,KAPPA,EXPDT
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C START CODE:
	IF(LMTO.EQ.1)RETURN
	IF(ICFTR.EQ.0)RETURN
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
      ALLOCATE(TMAT(LIMBMEM*(NENVMEM+1),LIMBMEM*(NENVMEM+1)),
     &STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL SCRCON_MESG01('TMAT',
     &LIMBMEM*(NENVMEM+1)*LIMBMEM*(NENVMEM+1))
      SIZE_TMAT=DBLE(SIZE(TMAT)*LENCMP)/1024.D0**2
      ALLOCATE(WORKS(LIMBMEM,0:NENVMEM,LIMBMEM,NATOMMEM),
     &STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL SCRCON_MESG01('WORKS',
     &LIMBMEM*(NENVMEM+1)*LIMBMEM*NATOMMEM)
      SIZE_WORKS=DBLE(SIZE(WORKS)*LENCMP)/1024.D0**2
      ALLOCATE(WORKD(LIMBMEM,0:NENVMEM,LIMBMEM,NATOMMEM),
     &STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL SCRCON_MESG01('WORKD',
     &LIMBMEM*(NENVMEM+1)*LIMBMEM*NATOMMEM)
      SIZE_WORKD=DBLE(SIZE(WORKD)*LENCMP)/1024.D0**2
      ALLOCATE(WORK(LIMBMEM,0:NENVMEM,LIMBMEM))
      ALLOCATE(SCRSS(LIMTMEM,0:NENVMEM,LIMBMEM))
      SIZE_SCRSS=DBLE(SIZE(SCRSS)*LENCMP)/1024.D0**2
      ALLOCATE(SCRSD(LIMBMEM,0:NENVMEM,LIMBMEM))
      SIZE_SCRSD=DBLE(SIZE(SCRSD)*LENCMP)/1024.D0**2
      ALLOCATE(SBARE(LIMTMEM,LIMBMEM,0:NENVMEM))
      SIZE_SBARE=DBLE(SIZE(SBARE)*LENCMP)/1024.D0**2
      ALLOCATE(SBDOT(LIMBMEM,LIMBMEM,0:NENVMEM))
      SIZE_SBDOT=DBLE(SIZE(SBDOT)*LENCMP)/1024.D0**2
      SIZE_WORK=DBLE(SIZE(WORK)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_TMAT+SIZE_SCRSS+SIZE_SCRSD+SIZE_SBARE+
     &SIZE_SBDOT+SIZE_WORKS+SIZE_WORKD+SIZE_WORK
      IF(TOTMEM.LT.CURMEM)TXTMEM='<SCRCON> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C Memory allocations for small arrays
	ALLOCATE(EK0(NKAPMEM))
	ALLOCATE(NENV0(NATOMMEM))
	ALLOCATE(SUMRUL(2,NATOMMEM))
	ALLOCATE(TAUT(3,NATOMMEM))
	ALLOCATE(WRK(LIMBMEM*(NENVMEM+1)))
C OPEN FTRFILE FOR STORING TB-STRUCTURE CONSTANTS
	NRECL=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	ILSM=ILST(ISORT)
	NRECL=MAX(NRECL,NVAL*((ILSM+1)**2*(ILSB(ISORT)+1)**2+
     &(ILSB(ISORT)+1)**4)+2*NVAL)
	ENDDO
	IF(ICFTR.EQ.1)THEN
	OPEN(24,FILE=FTRFILE,STATUS='NEW',FORM='UNFORMATTED',
     &ACCESS='DIRECT',RECL=NRECL) 
	WRITE(24,REC=1)NRECL,LMTO,NATOM,(NENV(IATOM),IATOM=1,NATOM),
     &NKAP(1),(EK(IKAP,1),IKAP=1,NKAP(1))
	ELSEIF(ICFTR.EQ.2)THEN
	INQUIRE(FILE=FTRFILE,RECL=NRECL)
CWRONGIF(WRONG)THEN           !!! wrong compiler statement
	NRECL=NVAL
	OPEN(24,FILE=FTRFILE,STATUS='OLD',FORM='UNFORMATTED',
     &ACCESS='DIRECT',RECL=NRECL) 
	READ(24,REC=1)NRECL
	CLOSE(24)
CWRONGENDIF   
	OPEN(24,FILE=FTRFILE,STATUS='OLD',FORM='UNFORMATTED',
     &ACCESS='DIRECT',RECL=NRECL) 
	READ(24,REC=1)NRECL,LMTO0,NATOM0,(NENV0(IATOM),IATOM=1,NATOM),
     &NKAP0
	IF(NATOM.NE.NATOM0)CALL SCRCON_MESG02
	IF(NKAP(1).NE.NKAP0)CALL SCRCON_MESG02
	READ(24,REC=1)NRECL,LMTO0,NATOM0,(NENV0(IATOM),IATOM=1,NATOM),
     &NKAP0,(EK0(IKAP),IKAP=1,NKAP(1))
	DO IKAP=1,NKAP(1)
	IF(ABS(EK(IKAP,1)-EK0(IKAP)).GE.1.D-10)
     &CALL SCRCON_MESG02
	ENDDO
	DO IATOM=1,NATOM
	IF(NENV(IATOM).NE.NENV0(IATOM))
     &CALL SCRCON_MESG02
	ENDDO
	ENDIF
C ***** DO GLOBALLY OVER ENERGIES AND ATOMS IN CELL FOR THE FIRST PANEL *****
	IRECORD=1
	DO 5000 IKAP=1,NKAP(1)                    !!! over energies
	IF(ICFTR.EQ.2)GOTO2000
	DO 1000 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
C STEP 1. GENERATE MATRIX TO BE INVERTED
      IND1=0
      DO IENV1=0,NENV(IATOM)                    !!! over ienv1
      IATOM1=ISENV(IENV1,IATOM)
      ISORT1=IS(IATOM1)
      DO IENV2=0,NENV(IATOM)
      IATOM2=ISENV(IENV2,IATOM)
      TX=TENV(1,IENV2,IATOM)-TENV(1,IENV1,IATOM)
      TY=TENV(2,IENV2,IATOM)-TENV(2,IENV1,IATOM)
      TZ=TENV(3,IENV2,IATOM)-TENV(3,IENV1,IATOM)
      CALL BARCON(IKAP,1,IATOM1,IATOM2,TX,TY,TZ,
     &SBARE(1,1,IENV2),SBDOT(1,1,IENV2))
	ENDDO
      DO L1=0,ILSB(ISORT1)                      !!! over l1
      DO M1=-L1,L1                              !!! over m1
      L1M1=L1*(L1+1)+M1+1
      IND1=IND1+1
      IND2=0
      DO IENV2=0,NENV(IATOM)                    !!! over ienv2
      IATOM2=ISENV(IENV2,IATOM)
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)                      !!! over l2
      DO M2=-L2,L2                              !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IND2=IND2+1
      TMAT(IND1,IND2)=-ALPHA(L1,ISORT1,IKAP,1)*
     &SBARE(L1M1,L2M2,IENV2)*ALPHA(L2,ISORT2,IKAP,1)
	ENDDO                                     !!! over m2
      ENDDO                                     !!! over l2
      ENDDO                                     !!! over ienv2
      TMAT(IND1,IND1)=TMAT(IND1,IND1)+ALPHA(L1,ISORT1,IKAP,1)
      ENDDO                                     !!! over m1
      ENDDO                                     !!! over l1
      ENDDO                                     !!! over ienv1
	NDIM=IND1
C STEP 2. INVERT MATRIX
      DO IDIM=1,NDIM
      DO JDIM=1,NDIM
      A=ABS(TMAT(IDIM,JDIM)-CONJG(TMAT(JDIM,IDIM)))
      IF(A.GT.1.D-10)WRITE(IUT,*)IDIM,JDIM,A
	ENDDO
	ENDDO
	CALL CINV(NDIM,TMAT,LIMBMEM*(NENVMEM+1),WRK,IFAIL)
	IF(IFAIL.NE.0)
     &CALL FULLSTOP('<SCRCON>:: ERROR IN INVERSION PROGRAM')
C STEP 3. GENERATE SCREENED STRUCTURE CONSTANTS (IN HERMITIAN FORM)
      DO L=0,ILSB(ISORT)                        !!! over l
      DO M=-L,L                                 !!! over m
      LM=L*(L+1)+M+1
      IND1=0
      DO IENV1=0,NENV(IATOM)                    !!! over ienv1
      IATOM1=ISENV(IENV1,IATOM)
      ISORT1=IS(IATOM1)
      DO L1=0,ILSB(ISORT1)                      !!! over l1
      DO M1=-L1,L1                              !!! over m1
      L1M1=L1*(L1+1)+M1+1
      IND1=IND1+1
      WORKS(L1M1,IENV1,LM,IATOM)=TMAT(IND1,LM)
      ENDDO                                     !!! over m1
      ENDDO                                     !!! over l1
      ENDDO                                     !!! over ienv1
      WORKS(LM,0,LM,IATOM)=WORKS(LM,0,LM,IATOM)-
     &1.D0/ALPHA(L,ISORT,IKAP,1)
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
C STEP 4. GENERATE ENERGY DERIVATIVES OF THE SCREENED STR.CON.
      IND2=0
      DO IENV2=0,NENV(IATOM)                    !!! over ienv2
      IATOM2=ISENV(IENV2,IATOM)
      ISORT2=IS(IATOM2)
      DO IENV3=0,NENV(IATOM)
      IATOM3=ISENV(IENV3,IATOM)
      TX=TENV(1,IENV3,IATOM)-TENV(1,IENV2,IATOM)
      TY=TENV(2,IENV3,IATOM)-TENV(2,IENV2,IATOM)
      TZ=TENV(3,IENV3,IATOM)-TENV(3,IENV2,IATOM)
      CALL BARCON(IKAP,1,IATOM2,IATOM3,TX,TY,TZ,
     &SBARE(1,1,IENV3),SBDOT(1,1,IENV3))
	ENDDO 
      DO L2=0,ILSB(ISORT2)                      !!! over l2
      DO M2=-L2,L2                              !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IND2=IND2+1
      DO L=0,ILSB(ISORT)                        !!! over l
      DO M=-L,L                                 !!! over m
      LM=L*(L+1)+M+1
      WORK(L2M2,IENV2,LM)=(0.D0,0.D0)
      IND3=0
      DO IENV3=0,NENV(IATOM)                    !!! over ienv3
      IATOM3=ISENV(IENV3,IATOM)
      ISORT3=IS(IATOM3)
      DO L3=0,ILSB(ISORT3)                      !!! over l3
      DO M3=-L3,L3                              !!! over m3
      L3M3=L3*(L3+1)+M3+1
      IND3=IND3+1
      WORK(L2M2,IENV2,LM)=WORK(L2M2,IENV2,LM)+
     &ALPHA(L2,ISORT2,IKAP,1)*SBDOT(L2M2,L3M3,IENV3)*
     &ALPHA(L3,ISORT3,IKAP,1)*TMAT(IND3,LM)
      ENDDO                                     !!! over m3
      ENDDO                                     !!! over l3
      ENDDO                                     !!! over ienv3
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over m2
      ENDDO                                     !!! over l2
	ENDDO                                     !!! over ienv2
C STEP 4. (CONTINUED)
      DO L=0,ILSB(ISORT)                        !!! over l
      DO M=-L,L                                 !!! over m
      LM=L*(L+1)+M+1
      IND1=0
      DO IENV1=0,NENV(IATOM)                    !!! over ienv1
      IATOM1=ISENV(IENV1,IATOM)
      ISORT1=IS(IATOM1)
      DO L1=0,ILSB(ISORT1)                      !!! over l1
      DO M1=-L1,L1                              !!! over m1
      L1M1=L1*(L1+1)+M1+1
      WORKD(L1M1,IENV1,LM,IATOM)=(0.D0,0.D0)
      IND1=IND1+1
      IND2=0
      DO IENV2=0,NENV(IATOM)                    !!! over ienv2
      IATOM2=ISENV(IENV2,IATOM)
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)                      !!! over l2
      DO M2=-L2,L2                              !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IND2=IND2+1
      WORKD(L1M1,IENV1,LM,IATOM)=WORKD(L1M1,IENV1,LM,IATOM)+
     &TMAT(IND1,IND2)*WORK(L2M2,IENV2,LM)
      WORKD(L1M1,IENV1,LM,IATOM)=WORKD(L1M1,IENV1,LM,IATOM)+
     &TMAT(IND1,IND2)*ALPDOT(L2,ISORT2,IKAP,1)*
     &WORKS(L2M2,IENV2,LM,IATOM)
      ENDDO                                     !!! over m2
      ENDDO                                     !!! over l2
      ENDDO                                     !!! over ienv2
      WORKD(L1M1,IENV1,LM,IATOM)=WORKD(L1M1,IENV1,LM,IATOM)-
     &1.D0/ALPHA(L1,ISORT1,IKAP,1)*ALPDOT(L1,ISORT1,IKAP,1)*
     &WORKS(L1M1,IENV1,LM,IATOM)
      ENDDO                                     !!! over m1
      ENDDO                                     !!! over l1
      ENDDO                                     !!! over ienv1
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
1000  CONTINUE                                  !!! over atoms
2000	CONTINUE
      DO 4000 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	IF(ICFTR.EQ.2)GOTO3000
C STEP 5. GENERATE SCREENED STRUCTURE CONSTANTS IN FINAL FORM
      DO IENV1=0,NENV(IATOM)                    !!! over ienv1
      IATOM1=ISENV(IENV1,IATOM)
      ISORT1=IS(IATOM1)
      KENV=ICENV(0,IENV1,IATOM)
C KATOM MUST BE EQUAL TO IATOM
C     KATOM=ISENV(KENV,IATOM1)
      DO L1=0,ILSB(ISORT1)                      !!! over l1
      DO M1=-L1,L1                              !!! over m1
      L1M1=L1*(L1+1)+M1+1
      DO L=0,ILSB(ISORT)                        !!! over l
      DO M=-L,L                                 !!! over m
      LM=L*(L+1)+M+1
      IF(KENV.GE.0)THEN
      SCRSS(L1M1,IENV1,LM)=0.5D0*(WORKS(L1M1,IENV1,LM,IATOM)+
     &DCONJG(WORKS(LM,KENV,L1M1,IATOM1)))
      SCRSD(L1M1,IENV1,LM)=0.5D0*(WORKD(L1M1,IENV1,LM,IATOM)+
     &DCONJG(WORKD(LM,KENV,L1M1,IATOM1)))
      ELSE
      SCRSS(L1M1,IENV1,LM)=WORKS(L1M1,IENV1,LM,IATOM)
      SCRSD(L1M1,IENV1,LM)=WORKD(L1M1,IENV1,LM,IATOM)
      ENDIF
	ENDDO                                     !!! over m1
      ENDDO                                     !!! over l1
      ENDDO                                     !!! over ienv1
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
C STEP 6. EXPAND SCREENED STRUCTURE CONSTANTS FOR HIGHER L'S
      IND1=0
      DO IENV1=0,NENV(IATOM)                    !!! over ienv1
      IATOM1=ISENV(IENV1,IATOM)
      ISORT1=IS(IATOM1)
      DO IENV2=0,NENV(IATOM)
      IATOM2=ISENV(IENV2,IATOM)
      TX=TENV(1,IENV2,IATOM)-TENV(1,IENV1,IATOM)
      TY=TENV(2,IENV2,IATOM)-TENV(2,IENV1,IATOM)
      TZ=TENV(3,IENV2,IATOM)-TENV(3,IENV1,IATOM)
      CALL BARCON(IKAP,1,IATOM1,IATOM2,TX,TY,TZ,
     &SBARE(1,1,IENV2),SBDOT(1,1,IENV2))
      ENDDO    
      DO L1=ILSB(ISORT1)+1,ILST(ISORT1)         !!! over l1
      DO M1=-L1,L1                              !!! over m1
      L1M1=L1*(L1+1)+M1+1
      IND1=IND1+1
      DO L=0,ILSB(ISORT)                        !!! over l
      DO M=-L,L                                 !!! over m
      LM=L*(L+1)+M+1
      IND2=0
      SCRSS(L1M1,IENV1,LM)=SBARE(L1M1,LM,0)
      DO IENV2=0,NENV(IATOM)                    !!! over ienv2
      IATOM2=ISENV(IENV2,IATOM)
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)                      !!! over l2
      DO M2=-L2,L2                              !!! over m2
      L2M2=L2*(L2+1)+M2+1
      SCRSS(L1M1,IENV1,LM)=SCRSS(L1M1,IENV1,LM)+
     &SBARE(L1M1,L2M2,IENV2)*ALPHA(L2,ISORT2,IKAP,1)*
     &SCRSS(L2M2,IENV2,LM)
      ENDDO                                     !!! over m2
      ENDDO                                     !!! over l2
      ENDDO                                     !!! over ienv2
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over m1
      ENDDO                                     !!! over l1
      ENDDO                                     !!! over ienv1
C  STORE/READ STRUCTURE CONSTANTS
3000	CONTINUE
	DO IENV=0,NENV(IATOM)
	JATOM=ISENV(IENV,IATOM)
	JSORT=IS(JATOM)
	LIM2T=(ILST(JSORT)+1)**2
	LIM2B=(ILSB(ISORT)+1)**2
	IRECORD=IRECORD+1
	IREC=IRECORD
	IF(ICFTR.NE.2)
     &	WRITE(24,REC=IREC)LIM2T,LIM2B,
     &  ((SCRSS(L1M1,IENV,LM),L1M1=1,LIM2T),LM=1,LIM2B),
     &  ((SCRSD(L1M1,IENV,LM),L1M1=1,LIM2B),LM=1,LIM2B)
	IF(ICFTR.EQ.2)
     &	READ(24,REC=IREC)LIM2T,LIM2B,
     &  ((SCRSS(L1M1,IENV,LM),L1M1=1,LIM2T),LM=1,LIM2B),
     &  ((SCRSD(L1M1,IENV,LM),L1M1=1,LIM2B),LM=1,LIM2B)
	ENDDO 
C  STEP 7. CHECK FOR SUM RULES FOR SCREENED STRUCTURE CONSTANTS
      SUMRUL(1,IATOM)=(0.D0,0.D0)
      SUMRUL(2,IATOM)=(-1.D0,0.D0)
      DO IENV1=0,NENV(IATOM)                    !!! over ienv1
      IATOM1=ISENV(IENV1,IATOM)
      ISORT1=IS(IATOM1)
      ABST=SQRT(TENV(1,IENV1,IATOM)**2+TENV(2,IENV1,IATOM)**2+
     &TENV(3,IENV1,IATOM)**2)
      KAPPA=SQRT(EK(IKAP,1))
      IF(ABS(KAPPA).LE.1.D-10.OR.ABST.LE.1.D-10)THEN
      EXPKR=(1.D0,0.D0)
      EXPDT=-1.D0/6.D0*ABST**2
      ELSE
      EXPKR=SIN(KAPPA*ABST)/(KAPPA*ABST)
      EXPDT=(COS(KAPPA*ABST)-EXPKR)/2.D0/EK(IKAP,1)
      ENDIF
      SUMRUL(1,IATOM)=SUMRUL(1,IATOM)+ALPHA(0,ISORT1,IKAP,1)*
     &SCRSS(1,IENV1,1)*SMT(ISORT1)/SMT(ISORT)*EXPKR
      SUMRUL(2,IATOM)=SUMRUL(2,IATOM)+ALPHA(0,ISORT1,IKAP,1)*
     &SCRSD(1,IENV1,1)*SMT(ISORT1)/SMT(ISORT)+
     &ALPDOT(0,ISORT1,IKAP,1)*SCRSS(1,IENV1,1)*
     &SMT(ISORT1)/SMT(ISORT)+
     &ALPHA(0,ISORT1,IKAP,1)*SCRSS(1,IENV1,1)*
     &SMT(ISORT1)/SMT(ISORT)*EXPDT
      ENDDO                                     !!! over ienv1
	WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(IS(IATOM))
	WRITE(IUN,1020)RLOC(ISORT),NENV(IATOM)
	WRITE(IUN,1030)DREAL(EKAP(IKAP,1)),DREAL(SUMRUL(1,IATOM)),
     &DREAL(SUMRUL(2,IATOM))
C PRINT OUT STRUCTURE CONSTANTS
      WRITE(IUN,1040)
      WRITE(IUN,1050)0.D0,DREAL(SCRSS(1,0,1)),DREAL(SCRSD(1,0,1))
      DO IENV=1,NENV(IATOM)
      ABST=SQRT(TENV(1,IENV,IATOM)**2+TENV(2,IENV,IATOM)**2+
     &TENV(3,IENV,IATOM)**2)
      IF(ABS(SCRSS(1,IENV,1)-SCRSS(1,IENV-1,1)).GT.1.D-10)
     &WRITE(IUN,1050)ABST,DREAL(SCRSS(1,IENV,1)),
     &DREAL(SCRSD(1,IENV,1))
	ENDDO
      WRITE(IUN,1060)(DREAL(DTBLOG(L,ISORT,IKAP,1)),L=0,ILSB(ISORT))
	WRITE(IUN,1070)(DREAL(ALPHA(L,ISORT,IKAP,1)),L=0,ILSB(ISORT))
	WRITE(IUN,1080)(DREAL(ALPDOT(L,ISORT,IKAP,1)),L=0,ILSB(ISORT))
4000  CONTINUE                                  !!! over atoms
5000  CONTINUE                                  !!! over energies
	CLOSE(24)
	OPEN(24,FILE=FTRFILE,STATUS='OLD',FORM='UNFORMATTED',
     &ACCESS='DIRECT',RECL=NRECL) 
C MEMORY DEALLOCATIONS
      DEALLOCATE(TMAT,SCRSS,SCRSD,SBARE,SBDOT,WORKS,WORKD,WORK)
      CURMEM=CURMEM-SIZE_TMAT-SIZE_SCRSS-SIZE_SCRSD-SIZE_SBARE-
     &SIZE_SBDOT-SIZE_WORKS-SIZE_WORKD-SIZE_WORK
	DEALLOCATE(NENV0,EK0,SUMRUL,TAUT,WRK)
C Format statements:
1010  FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1020  FORMAT(1X,'cluster size = ',G12.5,'   | nenv = ',I3)
1030  FORMAT(1X,'tail energy  = ',G12.5,' ; s-sum rule =',G14.7,
     &1X,G14.7)
1040  FORMAT(1X,'&',6X,'|R"-R|',6X,'&',3X,'S^a(R"L"RL)',4X,'&',
     &1X,'S^a-dot(R"L"RL)',2X,'&')
1050  FORMAT(1X,'&',2X,G14.7,2X,'&',2X,G14.7,2X,'&',2X,G14.7,2X,'&')
1060  FORMAT(1X,'spd log.deriv=',4(1X,G12.5))
1070  FORMAT(1X,'spd scr.alpha=',4(1X,G12.5))
1080  FORMAT(1X,'spd alpha-dot=',4(1X,G12.5))
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE SCRCON_MESG01(CHARV,LSIZE)
	CHARACTER CHARV*(*)
      WRITE(IUT,*)'Terminated in <SCRCON>:'
      WRITE(IUT,*)'Memory allocation problem detected by'
      WRITE(IUT,*)'the system. Complex array '//CHARV//' of the size:'
      WRITE(IUT,*) DBLE(LSIZE*LENCMP)/1024.D0,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
      CALL FULLSTOP(' ')
	END SUBROUTINE SCRCON_MESG01
	SUBROUTINE SCRCON_MESG02
	WRITE(IUT,*)'Terminated in <SCRCON>:'
	WRITE(IUT,*)'Current setup does not match with the'
	WRITE(IUT,*)'setup for which the screened structure'
	WRITE(IUT,*)'constants (stored in FTRFILE) have been'
	WRITE(IUT,*)'calculated. A recalculation of FTRFILE'
	WRITE(IUT,*)'is required to continue the execution.'
        CALL FULLSTOP(' ')
	END SUBROUTINE SCRCON_MESG02
	END SUBROUTINE SCRCON





	SUBROUTINE BARCON(IKAP,IPAN,IATOM,JATOM,TX,TY,TZ,SBARE,SBDOT)
*********************************************************************
*   The calculation of the unscreened (bare) structure constants    *
*   in real space.                                                  *
*********************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL,ONLY: LMTO                             !!! from readini
      USE COM_PARAM  ,ONLY: NATOM,NSORT,IS,ILST,ILSB,ILSV    !!! from readini
      USE COM_LATPAR ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR ,ONLY: NPAN,NKAP,EK,EKAP                !!! from readini
      USE COM_SPHERE ,ONLY: SWZ,SMT                          !!! from readini
      USE COM_GAUNT  ,ONLY: C,GGNT                           !!! from gdata
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SIGMA(:)
	COMPLEX*16, ALLOCATABLE :: SIGMADOT(:)
	COMPLEX*16, ALLOCATABLE :: HAN(:,:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	COMPLEX*16 SBARE(LIMTMEM,LIMBMEM),SBDOT(LIMBMEM,LIMBMEM)
     &    ,DIM,DIML,COEF,COEFDOT,HANDOT,HT,KAPPA,KAPPADOT
     &    ,KAP,HANM1
	LOGICAL LOG
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C MEMORY ALLOCATIONS
	ALLOCATE(SIGMA((LMAXTMEM+LMAXBMEM+2)**2))
	ALLOCATE(SIGMADOT((LMAXTMEM+LMAXBMEM+2)**2))
	ALLOCATE(HAN(3,0:LMAXTMEM+LMAXBMEM+1))
	ALLOCATE(YLM((LMAXTMEM+LMAXBMEM+2)**2))
C START CODE
	SQPI4=SQRT(4.D0*PI)
	KAP=SQRT(EK(IKAP,IPAN))
	IF(DREAL(EK(IKAP,IPAN)).LT.0.D0)HT=-(0.D0,1.D0)/
     &SQRT(EK(IKAP,IPAN))/(SWZ/PAR)
	IF(ABS(EK(IKAP,IPAN)).LE.1.D-10)HT=(1.D0,0.D0)
C  **** DO GLOBALLY OVER ENVIRONMENT VECTORS *****
	JSORT=IS(JATOM)
	ISORT=IS(IATOM)
	ILSMAX=ILST(ISORT)+ILSB(JSORT)
C  FIND LATTICE CONTRIBUTION
	TT=SQRT(TX*TX+TY*TY+TZ*TZ)
	IF(ABS(TT).GE.1.D-10)THEN
	CALL SPHHARM(TX/TT,TY/TT,TZ/TT,ILSMAX,YLM)
	CALL HANKEL(TT,EK(IKAP,IPAN),SWZ/PAR,HAN,ILSMAX)
	IF(DREAL(EK(IKAP,IPAN)).LT.0.D0)HANM1=HT*HAN(1,0)
	IF(ABS(EK(IKAP,IPAN)).LE.1.D-10)HANM1=(1.D0,0.D0)
	IF(DREAL(EK(IKAP,IPAN)).GT.0.D0)HANM1=SIN(KAP*TT)/(KAP*TT) ! Bes(l=0)
	DIML=DIM
	DO L=0,ILSMAX
	IF(L.NE.0)HANDOT=
     &0.5D0*TT/(SWZ/PAR)/(2.D0*L-1.D0)*HAN(1,L-1)
	IF(L.EQ.0)HANDOT=
     &0.5D0*TT/(SWZ/PAR)/(2.D0*L-1.D0)*HANM1
	DIML=-DIM*DIML
	COEF=SQPI4*DIML*HAN(1,L)
	COEFDOT=SQPI4*DIML*HANDOT
	DO M=-L,L
	LM=L*(L+1)+M+1
	SIGMA(LM)=COEF*DCONJG(YLM(LM))
	SIGMADOT(LM)=COEFDOT*DCONJG(YLM(LM))
	ENDDO
	ENDDO
	ELSE
	DO L=0,ILSMAX
	DO M=-L,L
	LM=L*(L+1)+M+1
	SIGMA(LM)=(0.D0,0.D0)
	SIGMADOT(LM)=(0.D0,0.D0)
	ENDDO 
	ENDDO 
	ENDIF
C  RESTORE FULL S AND SDOT -MATRICES
	DO L =0,ILSB(JSORT)                       !!! over l
	DO L1=0,ILST(ISORT)                       !!! over l1
	LOG=.FALSE.
	IF(L1.LE.ILSB(ISORT))LOG=.TRUE.
	SOS=(SMT(ISORT)/SWZ)**(L1+0.5)*(SMT(JSORT)/SWZ)**(L+0.5)
	QSOSQ=SQRT(SMT(ISORT)/2.D0/PAR)*SOS*SQRT(SMT(JSORT)/2.D0/PAR)
	SQSOSQS=SWZ/PAR*QSOSQ*SWZ/PAR
	DO M =-L,L                                !!! over m
	LM=L*(L+1)+M+1
	DO M1=-L1,L1                              !!! over m1
	L1M1=L1*(L1+1)+M1+1
	SBARE(L1M1,LM)=(0.0,0.0)
	IF(LOG)SBDOT(L1M1,LM)=(0.0,0.0)
	DO L2=ABS(L-L1),L+L1,2                    !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2)THEN                     !!! over m2
	KAPPA=(1.D0,0.D0)     !!! energies are in units 1/a^2)
	IF(L+L1-L2.NE.0)KAPPA=(SWZ/PAR*KAP)**(L+L1-L2)
	KAPPADOT=(0.D0,0.D0)
	IF(L+L1-L2.NE.0.AND.ABS(EK(IKAP,IPAN)).NE.0.D0)THEN
	KAPPADOT=(L+L1-L2)*0.5D0*(SWZ/PAR*KAP)**(L+L1-L2-2)
	ELSEIF(L+L1-L2.EQ.2.AND.ABS(EK(IKAP,IPAN)).EQ.0.D0)THEN
	KAPPADOT=(1.D0,0.D0)
	ENDIF
	SBARE(L1M1,LM)=SBARE(L1M1,LM)+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &SIGMA(L2M2)*QSOSQ*KAPPA
	IF(LOG)
     &SBDOT(L1M1,LM)=SBDOT(L1M1,LM)+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &SIGMADOT(L2M2)*SQSOSQS*KAPPA+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &SIGMA(L2M2)*SQSOSQS*KAPPADOT
	ENDIF                          !!! over m2
	ENDDO                          !!! over l2
      ENDDO                          !!! over m1
      ENDDO                          !!! over m
      ENDDO                          !!! over l1
      ENDDO                          !!! over l
C MEMORY DEALLOCATIONS
	DEALLOCATE(SIGMA)
	DEALLOCATE(SIGMADOT)
	DEALLOCATE(HAN)
	DEALLOCATE(YLM)
	END SUBROUTINE BARCON
