	SUBROUTINE MIXHUB(ITER,KY)
**********************************************************
*  Mixes old and new partial occupancies.                *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: IDMF                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB,NHSORT              !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT                         !!! from readini
	USE COM_MIXRHO1 ,ONLY: ADMOPT,ADSPIN                    !!! from mixrho1
	USE COM_MIXBROY ,ONLY: LBROY,MTER,WMIX,WINP             !!! from mixrhob
      USE COM_HUBCOM  ,ONLY: DHUB                             !!! from readhub
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, SAVE, ALLOCATABLE :: DHUBOLD(:,:,:,:,:)
	COMPLEX*16 AMINP,AMNEW,ROOUT,ROINP,RONEW,AMOUT
	LOGICAL FIRST
	SAVE FIRST
	DATA PI/3.141592653589793D0/,ISCHEME/2/,FIRST/.TRUE./
      CALL ABORTNOW()
	IF(IDMF.LE.0)RETURN
C MEMORY ALLOCATIONS
	IF(FIRST)
     &ALLOCATE(DHUBOLD(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM,0:NTERMEM))
	FIRST=.FALSE.
	IF(ISCHEME.EQ.1.OR.LBROY.LT.0)THEN 
C  DO LINEAR MIXING FOR OCCUPANCIES
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
C  Mix density and magnetization
	IF(KY.EQ.2)THEN
      ROOUT=(DHUB(IU,IATOM,1,1)+DHUB(IU,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
      ROINP=(DHUBOLD(IU,IATOM,1,1,0)+DHUBOLD(IU,IATOM,NSPIN,1,0))/
     &2.D0*DBLE(NSPIN)
      RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
      AMOUT=(DHUB(IU,IATOM,1,1)-DHUB(IU,IATOM,NSPIN,1))
      AMINP=(DHUBOLD(IU,IATOM,1,1,0)-DHUBOLD(IU,IATOM,NSPIN,1,0))
      AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
      DHUB(IU,IATOM,1,1)    =(RONEW+AMNEW)/DBLE(NSPIN)
      DHUB(IU,IATOM,NSPIN,1)=(RONEW-AMNEW)/DBLE(NSPIN)
C  Mix transverse components
	DO IORBS=2,NORBS
	DO IUPDN=1,NSPIN
      ROOUT=DHUB(IU,IATOM,IUPDN,IORBS)
      ROINP=DHUBOLD(IU,IATOM,IUPDN,IORBS,0)
      RONEW=ADSPIN*ROOUT+(1.D0-ADSPIN)*ROINP
	DHUB(IU,IATOM,IUPDN,IORBS)=RONEW
	ENDDO
	ENDDO
	ENDIF
C  Remember old occupancies
	DO IORBS=1,NORBS
    	DO IUPDN=1,NSPIN
	DHUBOLD(IU,IATOM,IUPDN,IORBS,0)=DHUB(IU,IATOM,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO                                     !!! over k
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over atoms
	ELSEIF(ISCHEME.EQ.2.AND.LBROY.GE.0)THEN 
C  DO BROYDEN MIXING FOR OCCUPANCIES
    	DO IORBS=1,NORBS                          !!! over iorbs
    	DO IUPDN=1,NSPIN                          !!! over spins
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IF(KY.EQ.1.AND.MTER.EQ.0)
     &DHUBOLD(IU,IATOM,IUPDN,IORBS,MTER)=DHUB(IU,IATOM,IUPDN,IORBS)
	IF(KY.EQ.2)THEN
      DHUBOLD(IU,IATOM,IUPDN,IORBS,MTER)=DHUB(IU,IATOM,IUPDN,IORBS)
	RONEW=WINP(MTER)*DHUBOLD(IU,IATOM,IUPDN,IORBS,0)
	DO LTER=1,MTER                            !!! over iterations
	RONEW=RONEW+WMIX(MTER,LTER)*DHUBOLD(IU,IATOM,IUPDN,IORBS,LTER)
	ENDDO                                     !!! over iterations
 	DHUB(IU,IATOM,IUPDN,IORBS)=RONEW
	ENDIF
	ENDDO                                     !!! over k
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over atoms
	ENDDO                                     !!! over spins
	ENDDO                                     !!! over iorbs
	ENDIF
	END

