	SUBROUTINE MAKEHAN
***********************************************************
*  Sets optimal eta-parameters for gaussian waves.        *
***********************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
C General controls
	USE COM_CONTROL, ONLY : IASA
        USE COM_PARAM,   ONLY : NATOM,NSORT,IS,ILSV,ILSB,ILST   !!! from readini
C Inputs:
        USE COM_KAPPAR,  ONLY : NPAN,NKAP,EKAP                  !!! from readini
        USE COM_PANPAR,  ONLY : LTPAN,LSPAN                     !!! from readini
        USE COM_SPHERE,  ONLY : SMT                             !!! from readini
        USE COM_LATPAR,  ONLY : PAR,STRAIN                      !!! from readini
        USE COM_LATTICE, ONLY : GBAS,RBAS,ISTRAIN,TAU           !!! from readstr
C Plane waves and FFTs
        USE COM_PLWMESH, ONLY : NPLW,GPLW                       !!! from plwmesh
        USE COM_ETAPAR,  ONLY : NBAS,LBAS,ETA,CUT               !!! from setpar
        USE COM_ACCURG,  ONLY : EPSR,EPSG,ECUTG,BET             !!! from readini
C Outputs
        USE COM_UNIT,    ONLY : IUN,IUR,IUT                     !!! from setup
	USE COM_LABELS,  ONLY : TXTEL,TXTAT
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER SIZE
	REAL*8, ALLOCATABLE :: CUTGAR(:)
	COMPLEX*16, ALLOCATABLE :: RHAN(:)
	COMPLEX*16, ALLOCATABLE :: HAN(:,:)
	COMPLEX*16, ALLOCATABLE :: ERFG(:)
	COMPLEX*16, ALLOCATABLE :: ERFR(:)
	COMPLEX*16, ALLOCATABLE :: ERF0(:)
	DIMENSION GL(3),GN(3)
	CHARACTER BAS(0:5)*1
	LOGICAL TPAN
	DATA PI/3.141592653589793D0/,BAS/'s','p','d','f','g','h'/
	IF(IASA.NE.2)RETURN
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(ETA(0:LMAXBMEM,NSORTMEM,NKAPMEM,NPANMEM))
	ALLOCATE(CUT(0:LMAXBMEM,NSORTMEM,NKAPMEM,NPANMEM))
	ALLOCATE(LBAS(0:LMAXBMEM,NSORTMEM,NKAPMEM,NPANMEM))
	ALLOCATE(BET(0:LMAXVMEM,NSORTMEM))
        WRITE(IUN,1010)
1010    FORMAT(1X,'Start making pseudoHankel functions:'/)
C CALCULATE ETA-PARAMETERS AND CUTOFF VALUES IN RECIPROCAL SPACE
	DO IPAN=1,NPAN
	DO ISORT=1,NSORT
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
C LOCALIZATION ACCURACY IN DIRECT SPACE IS GIVEN BY ETA(L)
C       IF(L.LE.2)LCUT=MIN(ILSB(ISORT),2)
C       IF(L.GT.2)LCUT=L
	LCUT=L
	IF(IPAN.GT.1.AND.L.LE.2)LCUT=MIN(ILSB(ISORT),2)
	AR=LOG(EPSR)
	BR=DBLE(LCUT+2)
	CALL GAROOT(AR,BR,RROOT)
	ETA(L,ISORT,IKAP,IPAN)=RROOT/SMT(ISORT)
C CUTOFF VECTOR IN RECIPROCAL SPACE IS GIVEN BY CUT(L)
	AG=LOG(EPSG)
	BG=DBLE(LCUT)
	CALL GAROOT(AG,BG,GROOT)
	CUT(L,ISORT,IKAP,IPAN)=GROOT*2.D0*ETA(L,ISORT,IKAP,IPAN)
	IF(CUT(L,ISORT,IKAP,IPAN)**2.LE.DREAL(EKAP(IKAP,IPAN)))
     &  CALL MAKEHAN_MESG01
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C SET UP NUMBER OF PLANE WAVES FOR EVERY BASIS FUNCTION
	CUTG=0.D0
	NBAS=0
	DO IPAN=1,NPAN
	DO IKAP=1,NKAP(IPAN)
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	CUTI=CUT(L,ISORT,IKAP,IPAN)*PAR/2.D0/PI
C SET CUTOFF=GMAX
	DO IPLW=0,NPLW-1
	IF(ISTRAIN.EQ.1)THEN
        DO I=1,3
        GL(I)=0.D0
        GN(I)=0.D0
        DO J=1,3
        GL(I)=GL(I)+GPLW(J,IPLW)  *STRAIN(J,I,1)
        GN(I)=GN(I)+GPLW(J,IPLW+1)*STRAIN(J,I,1)
        ENDDO
        ENDDO
        ELSEIF(ISTRAIN.NE.1)THEN
	DO I=1,3
	GL(I)=GPLW(I,IPLW)
	GN(I)=GPLW(I,IPLW+1)
	ENDDO
	ENDIF
	ABSI=SQRT(GL(1)**2+GL(2)**2+GL(3)**2)
	IF(ABSI.LE.CUTI.AND.IPLW+1.EQ.NPLW)
     &  CALL MAKEHAN_MESG02
	IF(ABSI.LE.CUTI)GMAX=SQRT(GN(1)**2+GN(2)**2+GN(3)**2)
	IF(ABSI.LE.CUTI.AND.IPLW+1.EQ.NPLW)EXIT
	ENDDO
	GMAX=GMAX+1.D-10
C SET LBAS
	DO IPLW=0,NPLW
        IF(ISTRAIN.EQ.1)THEN
        DO I=1,3
        GL(I)=0.D0
        DO J=1,3
        GL(I)=GL(I)+GPLW(J,IPLW)*STRAIN(J,I,1)
        ENDDO
        ENDDO
        ELSEIF(ISTRAIN.NE.1)THEN
        DO I=1,3
        GL(I)=GPLW(I,IPLW)
        ENDDO
        ENDIF
	ABSI=SQRT(GL(1)**2+GL(2)**2+GL(3)**2)
	IF(ABSI.LE.GMAX)LBAS(L,ISORT,IKAP,IPAN)=IPLW
	IF(ABSI.LE.GMAX)CUT (L,ISORT,IKAP,IPAN)=ABSI*2.D0*PI/PAR
	ENDDO
	CUTG=MAX(CUTG,GMAX)
	NBAS=MAX(NBAS,LBAS(L,ISORT,IKAP,IPAN))
        ELSE
        LBAS(L,ISORT,IKAP,IPAN)=1
        ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C MEMORY LIMITS DATA
	NBASMEM=NBAS
C SET UP ENERGY LIMIT
	EMAX=ECUTG
	GMAX=SQRT(EMAX)*PAR/2.D0/PI
	DO IPAN=1,NPAN
	DO IKAP=1,NKAP(IPAN)
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
        IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	LPLW=LBAS(L,ISORT,IKAP,IPAN)
        IF(ISTRAIN.EQ.1)THEN
        DO I=1,3
        GL(I)=0.D0
        DO J=1,3
        GL(I)=GL(I)+GPLW(J,LPLW)*STRAIN(J,I,1)
        ENDDO
        ENDDO
        ELSEIF(ISTRAIN.NE.1)THEN
        DO I=1,3
        GL(I)=GPLW(I,LPLW)
        ENDDO
        ENDIF
	GCUT=SQRT(GL(1)**2+GL(2)**2+GL(3)**2)
	ECUT=GCUT**2*(2.D0*PI/PAR)**2
	ENDIF
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO 
C SET BETTA-PARAMETERS AND CUTOFF VALUES FOR THE POTENTIAL
        PMAX=GMAX*2.D0*PI/PAR ! cutoff value
        ECUTG=EMAX
        DO ISORT=1,NSORT
        DO L=0,ILSV(ISORT)
C CUTOFF IS GMAX, FIND BETA FROM THE RECIPROCAL SPACE ACCURACY "EPSG"
        AG=LOG(EPSG)
        BG=DBLE(L)
        CALL GAROOT(AG,BG,GROOT)
        BTG=PMAX/2.D0/GROOT
C DIRECT SPACE ACCURACY IS "EPSR", FIND BETA AGAIN
        AR=LOG(EPSR)
        BR=DBLE(L+2)
        CALL GAROOT(AR,BR,RROOT)
        BTR=RROOT/SMT(ISORT)
C CUTOFF IS GMAX, FIND BETA FROM EPSG/EPSR
CC      RTOG=EPSR/EPSG
        RTOG=0.5D0
        CALL GAROOT1(RTOG,PMAX,SMT(ISORT),L+2,L,RROOT)
        BTN=RROOT
C FIND OPTIMAL BETA (LET'S SEE WHICH ONE WILL WORK!)
C       BET(L,ISORT)=BTR
C       BET(L,ISORT)=(BTG+BTR)/2.D0
C       BET(L,ISORT)=MAX(BTG,BTR)
C       BET(L,ISORT)=BTG
        BET(L,ISORT)=BTN
	ENDDO
	ENDDO
C PRINT ACCURACY
	LMEM=MAX(LMAXVMEM,LMAXBMEM)
	ALLOCATE(CUTGAR(0:LMEM))
	ALLOCATE(RHAN(0:LMEM))
	ALLOCATE(HAN(3,0:LMEM))
	ALLOCATE(ERFG(-1:LMEM))
	ALLOCATE(ERFR(-1:LMEM))
	ALLOCATE(ERF0(-1:LMEM))
        DO IATOM=1,NATOM                           !!! over atoms
        ISORT=IS(IATOM)
        WRITE(IUN,1110)(TAU(I,IATOM),I=1,3),TXTEL(IS(IATOM))
	DO IPAN=1,NPAN                             !!! over panels
	DO IKAP=1,NKAP(IPAN)                       !!! over kappas
	TPAN=.FALSE.
	DO L=0,ILSB(ISORT)
	CUTGAR(L)=CUT(L,ISORT,IKAP,IPAN)
	IF(LSPAN(L,ISORT,IKAP,IPAN))TPAN=.TRUE.
	CALL SERFL2(ERF0,L,ETA(L,ISORT,IKAP,IPAN),
     &  SMT(ISORT),EKAP(IKAP,IPAN))
	ERFR(L)=ERF0(L)
	CALL SERFL3(ERF0,L,ETA(L,ISORT,IKAP,IPAN),
     &  SMT(ISORT),EKAP(IKAP,IPAN),CUTGAR(L))
	ERFG(L)=ERF0(L)
	ENDDO
	IF(TPAN)WRITE(IUN,1120)DREAL(EKAP(IKAP,IPAN)),IPAN
	CALL REGHAN(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),
     &  ETA(0,ISORT,IKAP,IPAN),RHAN(0),ILSB(ISORT))
	CALL HANKEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),
     &  HAN(1,0),ILSB(ISORT))
	DO L=0,ILSB(ISORT)                 !!! over l
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	NG=LBAS(L,ISORT,IKAP,IPAN)
	CUTE=CUTGAR(L)**2                         ! Ry
	SCRG=0.5D0*CUTGAR(L)/ETA(L,ISORT,IKAP,IPAN)*2.D0*PI/PAR
	SCRR=ETA(L,ISORT,1,1)*SMT(ISORT)
	ACCR=SCRR**(L+2)*EXP(-SCRR**2)
	ACCG=SCRG**(L+0)*EXP(-SCRG**2)
	IF(L.LE.5)WRITE(IUN,1130)BAS(L),NG,CUTE,ABS(RHAN(L)/HAN(1,L)),
     &  ABS(ERFG(L)/ERFR(L))
	ENDIF
        ENDDO                              !!! over l
	ENDDO                              !!! over kappas
	ENDDO                              !!! over panels
        DO L=0,ILSV(ISORT)                 !!! over l
        CUTGAR(L)=SQRT(ECUTG)
        CALL SERFL2(ERF0,L,BET(L,ISORT),SMT(ISORT),
     &  (0.D0,0.D0))
        ERFR(L)=ERF0(L)
        CALL SERFL3(ERF0,L,BET(L,ISORT),SMT(ISORT),
     &  (0.D0,0.D0),CUTGAR(L))
        ERFG(L)=ERF0(L)
	ENDDO
        CALL REGHAN(SMT(ISORT),(0.D0,0.D0),SMT(ISORT),BET(0,ISORT),
     &  RHAN(0),ILSV(ISORT))
        CALL HANKEL(SMT(ISORT),(0.D0,0.D0),SMT(ISORT),HAN(1,0),
     &  ILSV(ISORT))
        WRITE(IUN,1140)
        DO L=0,ILSV(ISORT)
        WRITE(IUN,1150)L,NPLW,CUTGAR(L)**2,
     &  ABS(RHAN(L)/HAN(1,L)),ABS(ERFG(L)/ERFR(L))
	ENDDO                              !!! over l
	ENDDO                              !!! over atoms
	DEALLOCATE(CUTGAR)
	DEALLOCATE(RHAN)
	DEALLOCATE(HAN)
	DEALLOCATE(ERFG)
	DEALLOCATE(ERFR)
	DEALLOCATE(ERF0)
1110    FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1120    FORMAT(1X,'Basis  Nplw   Ecut (Ry)   RH(S)/H(S) ',
     &  '   GH(S)/RH(S); Ekap=',G10.3, '; p#',I1)
1130    FORMAT(1X,1X,'"',A1,'"',2X,I5,2X,G10.3,2X,G12.5,2X,G12.5)
1140    FORMAT(1X,' l=    Nplw   Ecut (Ry)   RH(S)/H(S) ',
     &  '   GH(S)/RH(S)')
1150    FORMAT(1X,'"',I2,'"',2X,I5,2X,G10.3,2X,G12.5,2X,G12.5)
C ERROR HANDLINGS
        CONTAINS
        SUBROUTINE MAKEHAN_MESG01
        WRITE(IUT,*)'Terminated in <MAKEHAN>:'
	WRITE(IUT,*)'Plane wave energy cutoff for expanding'
	WRITE(IUT,*)'pseudoLMTO in the interstitial region'
	WRITE(IUT,*)'CUT(L,ISORT,IKAP,IPAN)**2 is estimated to be (Ry):'
	WRITE(IUT,*) CUT(L,ISORT,IKAP,IPAN)**2
	WRITE(IUT,*)'for l,isort,ikap,ipan ==',L,ISORT,IKAP,IPAN
	WRITE(IUT,*)'This value is SMALLER than the energy'
	WRITE(IUT,*)'of the Hankel function EKAP='
	WRITE(IUT,*) EKAP(IKAP,IPAN)
	WRITE(IUT,*)'Either decrease of EKAP is required or'
	WRITE(IUT,*)'increase of CUT by decreasing input parameter EPSR.'
        CALL FULLSTOP(' ')
        END SUBROUTINE MAKEHAN_MESG01
        SUBROUTINE MAKEHAN_MESG02
        WRITE(IUT,*)'Warning from <MAKEHAN>:'
	WRITE(IUT,*)'Plane wave energy cutoff seems to be too small.'
	WRITE(IUT,*)'Try to increase it by making more dense FFT grid.'
        END SUBROUTINE MAKEHAN_MESG02
        END SUBROUTINE MAKEHAN


	SUBROUTINE GAROOT(A,B,ROOT)
*****************************************************
*  Finds largest root for x^2=b*ln(x)-a when x>0.   *
*****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA ACCU/1.D-10/
	XMAX=20.D0
  10    VAL=A-B*LOG(XMAX)+XMAX**2
	IF(VAL.LT.0.D0)XMAX=XMAX*2.D0
	IF(VAL.LT.0.D0)GOTO10
	DO 20 X=XMAX,0.D0,-0.01D0
	IF(X.EQ.0.D0)
     &  CALL FULLSTOP(' NO ROOT FOUND IN <GAROOT>')
	VALL=A-B*LOG(X)+X**2
	IF(VALL.LT.0.D0)XLEFT=X
	IF(VALL.LT.0.D0)GOTO30
	XRIGHT=X
	VALR=VALL
  20    CONTINUE
C ROOT IS LOCATED, FIND IT
  30    XROOT=(VALL*XRIGHT-VALR*XLEFT)/(VALL-VALR)
	VAL=A-B*LOG(XROOT)+XROOT**2
C Check out for exit
	IF(ABS(VAL).LE.ACCU)THEN
	ROOT=XROOT
	RETURN
	ENDIF
C Root from the right
	IF(VAL.LT.0.D0)THEN
	XLEFT=XROOT
	VALL=VAL
C Root from the left
	ELSEIF(VAL.GT.0.D0)THEN
	XRIGHT=XROOT
	VALR=VAL
	ENDIF
	GOTO 30
	END


	SUBROUTINE GAROOT1(RTOG,CUT,S,L1,L2,ROOT)
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA ACCU/1.D-10/
	XMAX=20.D0
  10    VAL=LOG(RTOG)+DBLE(L2)*LOG(CUT/2.D0/XMAX)-
     &  (CUT/2.D0/XMAX)**2-DBLE(L1)*LOG(S*XMAX)+(S*XMAX)**2
	IF(VAL.LT.0.D0)XMAX=XMAX*2.D0
	IF(VAL.LT.0.D0)GOTO10
	DO 20 X=XMAX,ACCU,-0.01D0
	VALL=LOG(RTOG)+DBLE(L2)*LOG(CUT/2.D0/X)-
     &  (CUT/2.D0/X)**2-DBLE(L1)*LOG(S*X)+(S*X)**2
	IF(VALL.LT.0.D0)XLEFT=X
	IF(VALL.LT.0.D0)GOTO30
	XRIGHT=X
	VALR=VALL
  20    CONTINUE
	CALL FULLSTOP(' NO ROOT FOUND IN <GAROOT>')
C ROOT IS LOCATED, FIND IT
  30    XROOT=(VALL*XRIGHT-VALR*XLEFT)/(VALL-VALR)
	VAL=LOG(RTOG)+DBLE(L2)*LOG(CUT/2.D0/XROOT)-
     &  (CUT/2.D0/XROOT)**2-DBLE(L1)*LOG(S*XROOT)+(S*XROOT)**2
C Check out for exit
	IF(ABS(VAL).LE.ACCU)THEN
	ROOT=XROOT
	RETURN
	ENDIF
C Root from the right
	IF(VAL.LT.0.D0)THEN
	XLEFT=XROOT
	VALL=VAL
C Root from the left
	ELSEIF(VAL.GT.0.D0)THEN
	XRIGHT=XROOT
	VALR=VAL
	ENDIF
	GOTO 30
	END
