	SUBROUTINE WRONSK1(WHH,WJH,WHJ,WJJ,S,NE,E,LMAX)
*************************************************************
*  Calculate different Wronskians from Bessel and Hankel    *
*  functions.                                               *
*************************************************************
C SET ARRAY-SIZE DATA
	IMPLICIT COMPLEX*16 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: BES(:,:,:)
	COMPLEX*16, ALLOCATABLE :: HAN(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BESDOT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: HANDOT(:,:,:)
	REAL*8 S
	DIMENSION E(NE)
     &   ,WHH(NE,NE,0:LMAX),WJH(NE,NE,0:LMAX)
     &   ,WHJ(NE,NE,0:LMAX),WJJ(NE,NE,0:LMAX)
C MEMORY ALLOCATIONS
	ALLOCATE(BES(3,0:LMAX,NE))
	ALLOCATE(HAN(3,0:LMAX,NE))
	ALLOCATE(BESDOT(3,0:LMAX,NE))
	ALLOCATE(HANDOT(3,0:LMAX,NE))
C START CODE
	DO 10 IE=1,NE
	CALL HANDOT1(S,E(IE),S,HAN(1,0,IE),HANDOT(1,0,IE),LMAX)
	CALL BESDOT1(S,E(IE),S,BES(1,0,IE),BESDOT(1,0,IE),LMAX)
  10  CONTINUE
	DO 40 L=0,LMAX
	DO 30 IE1=1,NE
	DO 20 IE =1,NE
	IF(E(IE).NE.CONJG(E(IE1)))THEN
	VHH=S*S*(CONJG(HAN(1,L,IE1))*HAN(2,L,IE)
     &    -CONJG(HAN(2,L,IE1))*HAN(1,L,IE))
	WHH(IE1,IE,L)=1.D0/(E(IE)-CONJG(E(IE1)))*VHH
	VJH=S*S*(CONJG(BES(1,L,IE1))*HAN(2,L,IE)
     &    -CONJG(BES(2,L,IE1))*HAN(1,L,IE))
	WJH(IE1,IE,L)=1.D0/(E(IE)-CONJG(E(IE1)))*VJH
	VHJ=S*S*(CONJG(HAN(1,L,IE1))*BES(2,L,IE)
     &    -CONJG(HAN(2,L,IE1))*BES(1,L,IE))
	WHJ(IE1,IE,L)=1.D0/(E(IE)-CONJG(E(IE1)))*VHJ
	VJJ=S*S*(CONJG(BES(1,L,IE1))*BES(2,L,IE)
     &    -CONJG(BES(2,L,IE1))*BES(1,L,IE))
	WJJ(IE1,IE,L)=1.D0/(E(IE)-CONJG(E(IE1)))*VJJ
	ELSE
	WHH(IE1,IE,L)=S*S*(CONJG(HAN(1,L,IE1))*HANDOT(2,L,IE)
     &    -CONJG(HAN(2,L,IE1))*HANDOT(1,L,IE))
	WJH(IE1,IE,L)=S*S*(CONJG(BES(1,L,IE1))*HANDOT(2,L,IE)
     &    -CONJG(BES(2,L,IE1))*HANDOT(1,L,IE))
	WHJ(IE1,IE,L)=S*S*(CONJG(HAN(1,L,IE1))*BESDOT(2,L,IE)
     &    -CONJG(HAN(2,L,IE1))*BESDOT(1,L,IE))
	WJJ(IE1,IE,L)=S*S*(CONJG(BES(1,L,IE1))*BESDOT(2,L,IE)
     &    -CONJG(BES(2,L,IE1))*BESDOT(1,L,IE))
	ENDIF
  20  CONTINUE
  30  CONTINUE
  40  CONTINUE
C MEMORY DEALLOCATIONS
	DEALLOCATE(BES)
	DEALLOCATE(HAN)
	DEALLOCATE(BESDOT)
	DEALLOCATE(HANDOT)
	END





      SUBROUTINE WRONSK2(WHHS,WJHS,WHJS,WJJS,S,NE,E,LMAX,ALP,ALPDOT)
*************************************************************
*  Calculate different Wronskians from screened Bessel and  *
*  Hankel functions.                                        *
*************************************************************
C SET ARRAY-SIZE DATA
      IMPLICIT COMPLEX*16 (A-H,O-Z)
      REAL*8 S
	COMPLEX*16, ALLOCATABLE :: WHH0(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WJH0(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WHJ0(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WJJ0(:,:,:)
      DIMENSION ALP(0:LMAX,NE),ALPDOT(0:LMAX,NE),E(NE)
     &   ,WHHS(NE,NE,0:LMAX),WJHS(NE,NE,0:LMAX)
     &   ,WHJS(NE,NE,0:LMAX),WJJS(NE,NE,0:LMAX)
C MEMORY ALLOCATIONS
	ALLOCATE(WHH0(NE,NE,0:LMAX))
	ALLOCATE(WJH0(NE,NE,0:LMAX))
	ALLOCATE(WHJ0(NE,NE,0:LMAX))
	ALLOCATE(WJJ0(NE,NE,0:LMAX))
C START CODE
      CALL WRONSK1(WHH0,WJH0,WHJ0,WJJ0,S,NE,E,LMAX)
      DO 30 L=0,LMAX
      DO 20 IE1=1,NE
      DO 10 IE =1,NE
      IF(E(IE).NE.CONJG(E(IE1)))THEN
      WHHS(IE1,IE,L)=WHH0(IE1,IE,L)
      WHJS(IE1,IE,L)=WHJ0(IE1,IE,L)-WHH0(IE1,IE,L)*ALP(L,IE)
      WJHS(IE1,IE,L)=WJH0(IE1,IE,L)-DCONJG(ALP(L,IE1))*WHH0(IE1,IE,L)
      WJJS(IE1,IE,L)=WJJ0(IE1,IE,L)+DCONJG(ALP(L,IE1))*
     &WHH0(IE1,IE,L)*ALP(L,IE)-DCONJG(ALP(L,IE1))*
     &WHJ0(IE1,IE,L)-WJH0(IE1,IE,L)*ALP(L,IE)
      ELSE
      WHHS(IE1,IE,L)=WHH0(IE1,IE,L)
      WHJS(IE1,IE,L)=WHJ0(IE1,IE,L)-WHH0(IE1,IE,L)*ALP(L,IE)
      WJHS(IE1,IE,L)=WJH0(IE1,IE,L)-DCONJG(ALP(L,IE1))*WHH0(IE1,IE,L)
      WJJS(IE1,IE,L)=WJJ0(IE1,IE,L)+DCONJG(ALP(L,IE1))*
     &WHH0(IE1,IE,L)*ALP(L,IE)-DCONJG(ALP(L,IE1))*
     &WHJ0(IE1,IE,L)-WJH0(IE1,IE,L)*ALP(L,IE)+ALPDOT(L,IE)*S*(2*L+1)
      ENDIF
  10  CONTINUE
  20  CONTINUE
  30  CONTINUE
C MEMORY DEALLOCATIONS
	DEALLOCATE(WHH0)
	DEALLOCATE(WJH0)
	DEALLOCATE(WHJ0)
	DEALLOCATE(WJJ0)
      END






	SUBROUTINE BESSEL(R,E,S,BES,LMAX)
************************************************************
*  Calculate Bessel functions J defined as follows:        *
*                     (2l+1)!!                             *
*            J (kr)=  -------- j (kr)                      *
*             l        (kS)^l   l                          *
*  and their derivative with respect to r. Here k=sqrt(E)  *
*  and j(x) is a spherical Bessel function.                *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 BES(3,0:LMAX),BEST(0:26),BESTD(0:26),E,X,T
	IF(LMAX.GT.26)
     &CALL FULLSTOP('<BESSEL> LMAX>26 DOES NOT WORK')
	X=R*SQRT(E)     
	T=S*SQRT(E)
	CALL BESSC(X,BEST,BESTD,LMAX)
	IF(R.EQ.0.D0)THEN
	DO 10 L=0,LMAX
	BES(1,L)=(0.D0,0.D0)
	BES(2,L)=(0.D0,0.D0)
	BES(3,L)=(0.D0,0.D0)
  10  CONTINUE
	BES(1,0)=(1.D0,0.D0)
	IF(LMAX.GT.0)BES(2,1)=(1.D0,0.D0)
	IF(LMAX.GT.1)BES(3,2)=(2.D0,0.D0)
	RETURN
	ENDIF
	IF(ABS(E).NE.0.D0)THEN
	DO 20 L=0,LMAX
	FL=FAC2(2*L+1)
	BES(1,L)=FL*BEST(L)/(T**L)
	BES(2,L)=FL*BESTD(L)/(T**(L-1))/S
	BES(3,L)=((DBLE(L*(L+1))/R/R-E)*BES(1,L)-2.D0/R*BES(2,L))
  20  CONTINUE
	ELSEIF(ABS(E).EQ.0.D0)THEN
	DO 30 L=0,LMAX
	BES(1,L)=(R/S)**L
	BES(2,L)=DBLE(L)*(R/S)**(L-1)/S
	BES(3,L)=DBLE(L*(L-1))*(R/S)**(L-2)/S/S
  30  CONTINUE
	ENDIF
	END



	SUBROUTINE BESDOT1(R,E,S,BES,BESDOT,LMAX)
************************************************************
*  Calculate Bessel functions J defined as follows:        *
*                     (2l+1)!!                             *
*            J (kr)=  -------- j (kr)                      *
*             l        (kS)^l   l                          *
*  and their derivative with respect to r. Here k=sqrt(E)  *
*  and j(x) is a spherical Bessel function.                *
*  Also calculates energy derivatives of the Bessel        *
*  functions up to second order.                           *
************************************************************
	IMPLICIT COMPLEX*16 (A-H,O-Z)
	REAL*8 R,S
	COMPLEX*16 B(3,0:26),BES(3,0:LMAX),BESDOT(3,0:LMAX)
	IF(LMAX.GT.26)
     &CALL FULLSTOP('<BESDOT1> LMAX>26 DOES NOT WORK')
	CALL BESSEL(R,E,S,B(1,0),LMAX+1)
	DO 10 L=0,LMAX
	BES(1,L)=B(1,L)
	BES(2,L)=B(2,L)
	BES(3,L)=B(3,L)
	BESDOT(1,L)=-0.5D0*R*S/DBLE(2*L+3)*B(1,L+1)
	BESDOT(2,L)=-0.5D0*S/DBLE(2*L+3)*(B(1,L+1)+R*B(2,L+1))
	BESDOT(3,L)=-0.5D0*S/DBLE(2*L+3)*(2.D0*B(2,L+1)+R*B(3,L+1))
  10  CONTINUE
	END


	SUBROUTINE BESDOT2(R,E,S,BES,NDOT,LMAX,NDOT1,LMAX1)
************************************************************
*  Calculate Bessel functions J defined as follows:        *
*                     (2l+1)!!                             *
*            J (kr)=  -------- j (kr)                      *
*             l        (kS)^l   l                          *
*  and their derivative with respect to r. Here k=sqrt(E)  *
*  and j(x) is a spherical Bessel function.                *
*  Also calculates energy derivatives of the Bessel        *
*  functions up to Nth order.                              *
************************************************************
	IMPLICIT COMPLEX*16 (A-H,O-Z)
	REAL*8 R,S
	COMPLEX*16 B(3,0:26,0:26),BES(3,0:NDOT1,0:LMAX1)
	IF(LMAX+NDOT.GT.26)
     &  CALL FULLSTOP('<BESDOT2> LMAX>26 SEEMS TO DO NOT WORK')
	CALL BESSEL(R,E,S,B(1,0,0),LMAX+NDOT)
	DO 20 IP=1,NDOT
	DO 10 L=0,LMAX+NDOT-IP
	B(1,L,IP)=-0.5D0*R*S/DBLE(2*L+3)*B(1,L+1,IP-1)
	B(2,L,IP)=-0.5D0*S/DBLE(2*L+3)*(B(1,L+1,IP-1)+R*B(2,L+1,IP-1))
	B(3,L,IP)=-0.5D0*S/DBLE(2*L+3)*(2.D0*B(2,L+1,IP-1)+
     &R*B(3,L+1,IP-1))
  10  CONTINUE
  20  CONTINUE
	DO 50 ID=1,3
	DO 40 IP=0,NDOT
	DO 30 L=0,LMAX
	BES(ID,IP,L)=B(ID,L,IP)
  30  CONTINUE
  40  CONTINUE
  50  CONTINUE
	END


	SUBROUTINE NEUMAN(R,E,S,ANEU,LMAX)
************************************************************
*  Calculate Neuman functions N defined as follows:        *
*                     (kS)^l+1                             *
*            N (kr)=- -------- n (kr)                      *
*             l       (2l-1)!!  l                          *
*  and their derevatives with respect to r. Here k=sqrt(E) *
*  and n(x) is a spherical Neuman function.                *
*  It is supposed that E > 0.                              *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 ANEU(3,0:LMAX),X,T,E,ANEUT(3,0:1)
	IF(DREAL(E).LT.0)PRINT*,'<NEUMAN> : E.LT.0'
	X=R*SQRT(E)
	T=S*SQRT(E)
	IF(DREAL(E).GT.0.D0)THEN         !!! RECURSION SERIES
      ANEUT(1,0)=T/X*COS(X)
      ANEUT(1,1)=T*(ANEUT(1,0)+T*SIN(X))/X
      ANEUT(2,0)=-1.D0/S*ANEUT(1,1)
      ANEUT(2,1)=-2.D0/R*ANEUT(1,1)+T*T/S*ANEUT(1,0)
      ANEUT(3,0)=-E*ANEUT(1,0)-2.D0/R*ANEUT(2,0)
      ANEUT(3,1)=(2.D0/R/R-E)*ANEUT(1,1)-2.D0/R*ANEUT(2,1)
	DO 5 L=0,MIN(LMAX,1)
	ANEU(1,L)=ANEUT(1,L)
	ANEU(2,L)=ANEUT(2,L)
	ANEU(3,L)=ANEUT(3,L)
   5	CONTINUE
	DO 10 L=1,LMAX-1
	ANEU(1,L+1)=T/X*ANEU(1,L)-T*T/DBLE((2*L-1)*(2*L+1))*ANEU(1,L-1)
	ANEU(2,L+1)=-(L+2)/R*ANEU(1,L+1)+T*T/S/(2.D0*L+1.D0)*ANEU(1,L)
	ANEU(3,L+1)=((L+1)*(L+2)/R/R-E)*ANEU(1,L+1)-2.D0/R*ANEU(2,L+1)
  10  CONTINUE
	ELSEIF(ABS(E).EQ.0.D0)THEN  !!! ANALITICAL EXPRESSIONS
	DO 20 L=0,LMAX
	ANEU(1,L)=(R/S)**(-L-1)
	ANEU(2,L)=(-L-1)*(R/S)**(-L-2)/S
	ANEU(3,L)=(-L-1)*(-L-2)*(R/S)**(-L-3)/S/S
  20  CONTINUE
	ENDIF   
	RETURN
	END



	SUBROUTINE HANKEL(R,E,S,HAN,LMAX)
************************************************************
*  Calculate Hankel functions H defined as follows:        *
*                     (kS)^l+1                             *
*            H (kr)=- -------- h (kr)                      *
*             l       (2l-1)!!  l                          *
*  and their derevatives with respect to r. Here k=sqrt(E) *
*  and h(x) is a spherical Hankel function which can be    *
*  expressed through the Neuman and Bessel functions       *
*                h(x)=n(x)-ij(x)                           *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 HAN(3,0:LMAX),ANEU(3,0:26),BES(0:26),BESD(0:26)
     &   ,X,E,T,HANT(3,0:1)
	IF(LMAX.GT.26)CALL FULLSTOP('<HANKEL> LMAX>26 DOES NOT WORK')
	IF(DREAL(E).LT.0.D0)THEN     !! HANKEL FUNCTIONS ARE REAL ONES
	X=R*SQRT(-E)          !! IMAGINE PART OF AN ARGUMENT
	T=S*SQRT(-E)
	HANT(1,0)=T/X*EXP(-X)
	HANT(1,1)=HANT(1,0)*T*(1.D0+1.D0/X)
	HANT(2,0)=-1.D0/S*HANT(1,1)
	HANT(2,1)=-2.D0/R*HANT(1,1)-T*T/S*HANT(1,0)
	HANT(3,0)=-E*HANT(1,0)-2.D0/R*HANT(2,0)
	HANT(3,1)=(2.D0/R/R-E)*HANT(1,1)-2.D0/R*HANT(2,1)
	DO 5 L=0,MIN(LMAX,1)
	HAN(1,L)=HANT(1,L)
	HAN(2,L)=HANT(2,L)
	HAN(3,L)=HANT(3,L)
   5	CONTINUE
	DO 10 L=1,LMAX-1
	HAN(1,L+1)=T/X*HAN(1,L)+T*T/DBLE((2*L-1)*(2*L+1))*HAN(1,L-1)
	HAN(2,L+1)=-DBLE(L+2)/R*HAN(1,L+1)-T*T/S/DBLE(2*L+1)*HAN(1,L)
	HAN(3,L+1)=(DBLE((L+1)*(L+2))/R/R-E)*HAN(1,L+1)-
     &  2.D0/R*HAN(2,L+1)
  10  CONTINUE
	ELSEIF(ABS(E).EQ.0.D0)THEN
	DO 20 L=0,LMAX
	HAN(1,L)=(R/S)**(-L-1)
	HAN(2,L)=DBLE(-L-1)*(R/S)**(-L-2)/S
	HAN(3,L)=DBLE((-L-1)*(-L-2))*(R/S)**(-L-3)/S/S
  20  CONTINUE
	ELSEIF(DREAL(E).GT.0.D0)THEN  !!! HANKEL FUNCTIONS ARE COMPLEX ONES
	X=R*SQRT(E)     
	T=S*SQRT(E)
C     CALL BESSC(X,BES,BESD,LMAX)
	CALL NEUMAN(R,E,S,ANEU,LMAX)
	DO 30 L=0,LMAX
C     FL=FAC2(2*L-1)
C     HAN(1,L)=ANEU(1,L)+(0.D0,1.D0)*T**(L+1)/FL*BES(L)
C     HAN(2,L)=ANEU(2,L)+(0.D0,1.D0)*T**(L+2)/FL/S*BESD(L)
C     HAN(3,L)=(L*(L+1)/R/R-E)*HAN(1,L)-2.D0/R*HAN(2,L)
C  USE NEUNMAN'S SINCE 04.03.93
	HAN(1,L)=ANEU(1,L)
	HAN(2,L)=ANEU(2,L)
	HAN(3,L)=ANEU(3,L)
  30  CONTINUE
	ENDIF
	RETURN
	END



	SUBROUTINE HANDOT1(R,E,S,HAN,HANDOT,LMAX)
************************************************************
*  Calculate Hankel functions H defined as follows:        *
*                     (kS)^l+1                             *
*            H (kr)=- -------- h (kr)                      *
*             l       (2l-1)!!  l                          *
*  and their derevatives with respect to r. Here k=sqrt(E) *
*  and h(x) is a spherical Hankel function which can be    *
*  expressed through the Neuman and Bessel functions       *
*                h(x)=n(x)-ij(x)                           *
************************************************************
	IMPLICIT COMPLEX*16 (A-H,O-Z)
	REAL*8 R,S
	COMPLEX*16 HAN(3,0:LMAX),HANDOT(3,0:LMAX),H(3,-1:26),B(3)
	IF(LMAX.GT.26)CALL FULLSTOP('<HANDOT1> LMAX>26 DOES NOT WORK')
	CALL HANKEL(R,E,S,H(1,0),LMAX)
	IF(DREAL(E).LT.0.D0)THEN
	H(1,-1)=-(0.D0,1.D0)/SQRT(E)/S*H(1,0)
	H(2,-1)=-(0.D0,1.D0)/SQRT(E)/S*H(2,0)
	H(3,-1)=-(0.D0,1.D0)/SQRT(E)/S*H(3,0)
	ELSEIF(ABS(E).EQ.0.D0)THEN
	H(1,-1)=(1.D0,0.D0)
	H(2,-1)=(0.D0,0.D0)
	H(3,-1)=(0.D0,0.D0)
	ELSEIF(DREAL(E).GT.0.D0)THEN
	CALL BESSEL(R,E,S,B,0)
	H(1,-1)=B(1)
	H(2,-1)=B(2)
	H(3,-1)=B(3)
	ENDIF   
	DO 10 L=0,LMAX
	HAN(1,L)=H(1,L)
	HAN(2,L)=H(2,L)
	HAN(3,L)=H(3,L)
	HANDOT(1,L)=0.5D0*R*S/DBLE(2*L-1)*H(1,L-1)  
	HANDOT(2,L)=0.5D0*S/DBLE(2*L-1)*(H(1,L-1)+R*H(2,L-1))  
	HANDOT(3,L)=0.5D0*S/DBLE(2*L-1)*(2.D0*H(2,L-1)+R*H(3,L-1))
  10  CONTINUE
	END


	SUBROUTINE FASTHAN(R,E,S,HAN,LMAX)
************************************************************
*  Calculate Hankel functions H defined as follows:        *
*                     (kS)^l+1                             *
*            H (kr)=- -------- h (kr)                      *
*             l       (2l-1)!!  l                          *
*  using direct recursion method. Here k=sqrt(E)           *
*  and h(x) is a spherical Hankel function.                *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 HAN(0:LMAX),X,E,QE,SE,T,DIM
	DATA DIM/(0.D0,1.D0)/
	IF(DREAL(E).LE.0.D0)THEN !!! USE HANKEL FUNCTIONS
	SR=S/R
	SE=S*S*E
	QE=DIM*SQRT(E)
	HAN(0)=SR*EXP(QE*R)
	IF(LMAX.GT.0)HAN(1)=(SR-S*QE)*HAN(0)
	DO 10 L=1,LMAX-1
	HAN(L+1)=SR*HAN(L)-SE/DBLE((2*L-1)*(2*L+1))*HAN(L-1)
  10  CONTINUE
	ELSEIF(DREAL(E).GT.0.D0)THEN !!! USE NEUNMAN FUNCTIONS
	T=S*SQRT(E)
	X=R*SQRT(E)     
	SR=S/R
	SE=S*S*E
	HAN(0)=SR*COS(X)
	IF(LMAX.GT.0)HAN(1)=SR*(HAN(0)+T*SIN(X))
	DO 20 L=1,LMAX-1
	HAN(L+1)=SR*HAN(L)-SE/DBLE((2*L-1)*(2*L+1))*HAN(L-1)
  20  CONTINUE
	ENDIF
	END


	SUBROUTINE REGHAN(R,E,S,ETA,RHAN,LMAX)
****************************************************************
*  Calculates spherical function which is a Hankel function    *
*  for large "r" and regular at the origin. It is defined      *
*  via contour integral (see subroutine SERFL2) and analogious *
*  to the reciprocal lattice contribution in the Evald method. *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 RHAN(0:LMAX),E,ERFL(-1:30)
	DIMENSION ETA(0:LMAX)
	IF(LMAX.GT.30)
     &CALL FULLSTOP('<REGHAN>: LMAX.GT.30, INCREASE ARRAY SIZE')
	DATA PI/3.141592653589793D0/
	DO 10 L=0,LMAX
	CALL SERFL2(ERFL,L,ETA(L),R,E)
	IF(L.EQ.0)RL=1.D0
	IF(L.NE.0)RL=R**L
	RHAN(L)=RL*ERFL(L)*(2*S)**(L+1)/SQRT(PI)/FAC2(2*L-1)*
     &  ETA(L)**(2*L)*EXP(-(R*ETA(L))**2+0.25D0*E/ETA(L)/ETA(L))
  10  CONTINUE
	END


	SUBROUTINE BESSC(X,BES,BESD,LMAX)
******************************************************************
*   Caclculate Bessel functions of a general (complex) argument  *
*   as well as their derivatives with respect to argument.       *
******************************************************************
	IMPLICIT COMPLEX*16 (A-H,O-Z)
	REAL*8 FAC2
	DIMENSION BESW(0:26),BES(0:LMAX),BESD(0:LMAX)
C
	IF(LMAX.GT.26)CALL FULLSTOP('<BESSC> LMAX>26 DOES NOT WORK')
	IF(LMAX.GT.20)PRINT*,'LMAX EXCEEDED 20 IN BESSR FUNCTION'
C
	IF (ABS(X).GT.10.D0) THEN       ! DIRECT RECURSION
	BES(0)=SIN(X)/X
	BESD(0)=-(SIN(X)/X-COS(X))/X
	IF(LMAX.GT.0)BES(1)=-BESD(0)
C
	IF(LMAX.GT.0)BESD(1)=BES(0)-2.D0*BES(1)/X
C       
	DO 10 LI=0,LMAX-2
	BES(LI+2)=DBLE(2*LI+3)/X*BES(LI+1)-BES(LI)
	BESD(LI+2)=BES(LI+1)-DBLE(LI+3)*BES(LI+2)/X
  10  CONTINUE
	ELSE                    ! REVERSE RECURSION
	DO 20 IL=0,LMAX
	BES(IL)=(0.D0,0.D0)
	BESD(IL)=(0.D0,0.D0)
  20  CONTINUE
	IF(ABS(X).LT.1.D-08) THEN
	BES(0)=(1.D0,0.D0)
	BESD(0)=(0.D0,0.D0)
	IF(LMAX.GT.0)BESD(1)=DCMPLX(1.D0/3.D0,0.D0)
	RETURN
	ENDIF
	IF(ABS(X).EQ.1.D0)X=1.D0+1.D-06
	L00=-24.D0/LOG10(ABS(X))
	LUP=MIN(26,L00)
	IF (L00.LE.0) LUP=26
C
1     WW=X**LUP/FAC2(2*LUP+1)*(1.D0-
     &   X**2/2.D0/DBLE(2*LUP+3))
	IF(ABS(WW).EQ.0.D0) THEN
	LUP=LUP-1
	GOTO 1
	ENDIF
C
	BESW(LUP)=WW
	BESW(LUP-1)=X**(LUP-1)/FAC2(2*LUP-1)*(1.D0-
     &            X**2/2.D0/DBLE(2*LUP+1))
	BNOR=DBLE(2*LUP+1)*BESW(LUP)*BESW(LUP)+
     &      DBLE(2*LUP-1)*BESW(LUP-1)*BESW(LUP-1)
	DO 30 LI=LUP-2,0,-1
	BESW(LI)=DBLE(2*LI+3)/X*BESW(LI+1)-BESW(LI+2)
	BNOR=BNOR+DBLE(2*LI+1)*BESW(LI)*BESW(LI)
  30  CONTINUE
	SQBN=SQRT(BNOR)
	BES(0)=BESW(0)/SQBN
	BESD(0)=(COS(X)-SIN(X)/X)/X
	DO 40 LI=1,MIN(LMAX,LUP)
	BES(LI)=BESW(LI)/SQBN
	BESD(LI)=BES(LI-1)-DBLE(LI+1)*BES(LI)/X
  40  CONTINUE
	ENDIF
	RETURN
	END

	SUBROUTINE BESSR(X,BES,BESD,LMAX)
******************************************************************
*   Caclculate Bessel functions of a real argument               *
*   as well as their derivatives with respect to argument.       *
******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION BESW(0:26),BES(0:LMAX),BESD(0:LMAX)
C
	IF(LMAX.GT.26)CALL FULLSTOP('<BESSC> LMAX>26 DOES NOT WORK')
	IF(LMAX.GT.20)PRINT*,'LMAX EXCEEDED 20 IN BESSR FUNCTION'
C
	IF (ABS(X).GT.10.D0) THEN       ! DIRECT RECURSION
	BES(0)=SIN(X)/X
	BESD(0)=-(SIN(X)/X-COS(X))/X
	IF(LMAX.GT.0)BES(1)=-BESD(0)
C
	IF(LMAX.GT.0)BESD(1)=BES(0)-2.D0*BES(1)/X
C       
	DO 10 LI=0,LMAX-2
	BES(LI+2)=DBLE(2*LI+3)/X*BES(LI+1)-BES(LI)
	BESD(LI+2)=BES(LI+1)-DBLE(LI+3)*BES(LI+2)/X
  10  CONTINUE
	ELSE                    ! REVERSE RECURSION
	DO 20 IL=0,LMAX
	BES(IL)=0.D0
	BESD(IL)=0.D0
  20  CONTINUE
	IF(ABS(X).LT.1.D-08) THEN
	BES(0)=1.D0
	BESD(0)=0.D0
	IF(LMAX.GT.0)BESD(1)=1.D0/3.D0
	RETURN
	ENDIF
	IF(ABS(X).EQ.1.D0)X=1.D0+1.D-06
	L00=-24.D0/LOG10(ABS(X))
	LUP=MIN(26,L00)
	IF (L00.LE.0) LUP=26
C
1     WW=X**LUP/FAC2(2*LUP+1)*(1.D0-
     &   X**2/2.D0/DBLE(2*LUP+3))
	IF(ABS(WW).EQ.0.D0) THEN
	LUP=LUP-1
	GOTO 1
	ENDIF
C
	BESW(LUP)=WW
	BESW(LUP-1)=X**(LUP-1)/FAC2(2*LUP-1)*(1.D0-
     &            X**2/2.D0/DBLE(2*LUP+1))
	BNOR=DBLE(2*LUP+1)*BESW(LUP)*BESW(LUP)+
     &DBLE(2*LUP-1)*BESW(LUP-1)*BESW(LUP-1)
	DO 30 LI=LUP-2,0,-1
	BESW(LI)=DBLE(2*LI+3)/X*BESW(LI+1)-BESW(LI+2)
	BNOR=BNOR+DBLE(2*LI+1)*BESW(LI)*BESW(LI)
  30  CONTINUE
	SQBN=SQRT(BNOR)
	BES(0)=BESW(0)/SQBN
	BESD(0)=(COS(X)-SIN(X)/X)/X
	DO 40 LI=1,MIN(LMAX,LUP)
	BES(LI)=BESW(LI)/SQBN
	BESD(LI)=BES(LI-1)-DBLE(LI+1)*BES(LI)/X
  40  CONTINUE
	ENDIF
	RETURN
	END


	DOUBLE PRECISION FUNCTION FAC2(L)
	IF(L.EQ.-1)THEN
	FAC2=1.D0
	RETURN
	ENDIF
	IF(L.EQ.1) THEN
	FAC2=1.D0
	RETURN
	ENDIF
	FAC2=1.D0
	LL=(L-1)/2
	DO 10 I=1,LL
	FAC2=FAC2*DBLE(2*I+1)
  10    CONTINUE
	RETURN
	END     



