      MODULE COM_SITEGEN
*****************************************************************
*  Containes Sites generated by SITEGEN subroutine.             *
*****************************************************************
      INTEGER, SAVE :: NSITES                    !!! # of sites
      INTEGER, SAVE, ALLOCATABLE :: IREFSITES(:) !!! site pointer
      REAL*8, SAVE, ALLOCATABLE :: SITES(:,:)    !!! sites generated
      END MODULE COM_SITEGEN



	MODULE COM_TETRGEN
**************************************************************
*  Contains k-points sampling corresponding to NDIV numbers. *
**************************************************************
	INTEGER, SAVE :: NPOINTS
	INTEGER, SAVE :: ITTRCUT(3,4,6)
	INTEGER, SAVE, ALLOCATABLE :: IREFPQS(:,:,:)
	INTEGER, SAVE, ALLOCATABLE :: IREFGQS(:,:,:)
	INTEGER, SAVE, ALLOCATABLE :: IREFTQS(:,:,:,:)
	REAL*8, SAVE, ALLOCATABLE :: POINTS(:,:)
	REAL*8, SAVE, ALLOCATABLE :: WEIGHS(:)
      END MODULE COM_TETRGEN
	



      MODULE COM_LMSTRS
**************************************************************
* Containes combinations of lmax's.                          *
**************************************************************
      INTEGER, SAVE :: NR2
      INTEGER, SAVE :: NR4
      INTEGER, SAVE, ALLOCATABLE :: IDELP(:,:)
      INTEGER, SAVE, ALLOCATABLE :: ILS2(:)
      INTEGER, SAVE, ALLOCATABLE :: ILS4(:)
      INTEGER, SAVE, ALLOCATABLE :: ILD2(:)
      INTEGER, SAVE, ALLOCATABLE :: ILD4(:)
      INTEGER, SAVE, ALLOCATABLE :: LIMLPL2(:)
      INTEGER, SAVE, ALLOCATABLE :: LIMLPL4(:)
      INTEGER, SAVE, ALLOCATABLE :: LIMLDL2(:)
      INTEGER, SAVE, ALLOCATABLE :: LIMLDL4(:)
      END MODULE COM_LMSTRS


      MODULE COM_VECGEN
**************************************************************
* Containes structure vectors.                               *
**************************************************************
      INTEGER, SAVE :: LIMDT
      INTEGER, SAVE :: NIVEC                 !!! input # of vectors
      INTEGER, SAVE :: NRVEC                 !!! Nvec in real space
      INTEGER, SAVE :: NGVEC                 !!! Nvec in reciprical space
      INTEGER, SAVE :: NSVEC                 !!! Nvec for semicore states
      REAL*8, SAVE :: ALPHEVL                !!! Otimal splitting parameter
      REAL*8, SAVE :: ETAEVLD                !!! Splitting in Evald method
      REAL*8, SAVE, ALLOCATABLE :: RVEC(:,:) !!! Vectors in R-space
      REAL*8, SAVE, ALLOCATABLE :: GVEC(:,:) !!! Vectors in G-space
      REAL*8, SAVE, ALLOCATABLE :: SVEC(:,:) !!! Vectors for semicore states
      REAL*8, SAVE, ALLOCATABLE :: DELTAU(:,:)!! Tau'(i)-Tau(i)
      END MODULE COM_VECGEN





      MODULE COM_STRCON
**************************************************************
* Containes structure constants of the LMTO method.          *
**************************************************************
      COMPLEX*16, SAVE, ALLOCATABLE :: SSCON(:,:,:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: SDCON(:,:,:,:,:)
      END MODULE COM_STRCON


	MODULE COM_HAMPAR
**************************************************************
* Contains potential parameters of the hamiltonian.          *
* Spontaneoulsy contains TOS matrix in Hpars.                *
**************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: HPARHH(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: HPARJH(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: HPARHJ(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: HPARJJ(:,:,:)
      END MODULE COM_HAMPAR


	MODULE COM_RINPAR
**************************************************************
* Contains parameters for calculating interstitial potential *
* matrix elements. Spontaneously contains parameters for     *
* calculating pseudocharge density.                          *
**************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: RFUN(:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: RINT0(:,:)
	END MODULE COM_RINPAR




      MODULE COM_LMTMAT
**************************************************************
* Containes LMTO hamiltonian and overlap matrix              *
**************************************************************
      COMPLEX*16, SAVE, ALLOCATABLE :: HMAT(:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: OMAT(:,:)
      REAL*8, SAVE :: SIZE_HMAT
      REAL*8, SAVE :: SIZE_OMAT
      END MODULE COM_LMTMAT




