	SUBROUTINE TTRGRF(EF0,KMSB,ZMSB,TOS,DOS,KEY,KEYDOS)
***********************************************************
*  The calculation of weights for Greens function integ-  *
*  rations over IBZ by means of tetrahedron method.       *
***********************************************************
C  SET ARRAY-SIZE DATA
      USE DIM_LMTART
C  SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS           !!! from readini
      USE COM_KAPPAR ,ONLY: NPAN,NKAP                         !!! from readini
      USE COM_LATPAR ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
      USE COM_LATTICE,ONLY: RBAS,GBAS,AKBAS,RKBAS             !!! from readstr
      USE COM_NBANDS ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
      USE COM_MSBMESH,ONLY: TEMP,NMSB,WMSB,FMSB               !!! from grfint
      USE COM_GRFDAT ,ONLY: EPOL,EPOW,GWGT,GWGD,GW0T,GW0D     !!! from grfbnd
      USE COM_ENERGY ,ONLY: EARR,EARW,WEIGH,WEIGD             !!! from bands
      USE COM_INPTTR ,ONLY: NDIV,NDIC,NDIW,SH,KEYTTR
     &                     ,TFERMI,GBROAD                     !!! from readini
      USE COM_KMESH  ,ONLY: NPNT,PNT,WGT,IPQ,IGQ,ITQ,KCUT     !!! from makettr
      USE COM_WMESH  ,ONLY: NPNW,PNW,WGW,IPW,IGW,ITW,KCUW     !!! from tetra
      USE COM_UNIT   ,ONLY: IUN,IUR,IUT                       !!! from setup
C  SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: FINT(:,:,:)
	INTEGER KTT(4),KTW(4)
      DIMENSION E(4),AT(4),AD(4),FAT(4),FAD(4),FL(0:4,4)
     &   ,PKT(3,4),PKW(3,4),CRW(3,4),REC(3,3)
	COMPLEX*16 ZE(4),AG(4),DG(4),A0(4),CINT(4),DINT(4)
     &   ,ZMSB,ZOMG,GH,GD,ZI,ZJ
      DATA PI/3.141592653589793D0/,EPS/1.D-10/,EPSDEG/1.D-05/
C  MEMORY ALLOCATIONS
	ALLOCATE(FINT(0:4,NBNDT(1)*NSPINMEM,NPNWMEM))
C  *********** INITIALIZATION **************
	EF=EF0
      VOLIBZ=1.D0
      OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
      OW=1.D0/NDIW(1)/NDIW(2)/NDIW(3)/6.D0
C  *********** TETRAHEDRON METHOD **********
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
	DO IMSB=0,NMSB+1
      GWGT(IBAND,IPNT,IMSB)=(0.D0,0.D0)
      GWGD(IBAND,IPNT,IMSB)=(0.D0,0.D0)
	ENDDO
      GW0T(IBAND,IPNT)=(0.D0,0.D0)
      GW0D(IBAND,IPNT)=(0.D0,0.D0)
      WEIGH(IBAND,IPNT)=(0.D0,0.D0)
      WEIGD(IBAND,IPNT)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C  Compute Fermi function integrals
	IF((KEYTTR.EQ.0.OR.KEYTTR.EQ.1).AND.TFERMI.NE.0.D0)THEN
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNW=1,NPNW(1)
	XT=(EARW(IBAND,IPNW,1)-EF)/TFERMI
	CALL FERMIINT(XT,40,FINT(0,IBAND,IPNW),0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C  DO OVER MICROCELLS
      DO 5200 I3=0,NDIV(3)-1               !!! over cells along G3
      DO 5200 I2=0,NDIV(2)-1               !!! over cells along G2
      DO 5200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRON INSIDE MICROCELL
      DO 5100 ITTR=1,6                     !!! over tetrahedra
	IF(ITQ(ITTR,I1,I2,I3).LT.0)GOTO 5100
	WTTR=DBLE(ITQ(ITTR,I1,I2,I3))
      DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      KTT(I)=IPQ(J1,J2,J3)
      ENDDO
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
      DO I=1,4
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      PKT(1,I)=(J1*AKBAS(1,1,1)+
     &          J2*AKBAS(1,2,1)+
     &          J3*AKBAS(1,3,1))*2.D0*PI/PAR
      PKT(2,I)=(J1*AKBAS(2,1,1)+
     &          J2*AKBAS(2,2,1)+
     &          J3*AKBAS(2,3,1))*2.D0*PI/PAR
      PKT(3,I)=(J1*AKBAS(3,1,1)+
     &          J2*AKBAS(3,2,1)+
     &          J3*AKBAS(3,3,1))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=2,4
      PKT(1,I)=PKT(1,I)-PKT(1,1)
      PKT(2,I)=PKT(2,I)-PKT(2,1)
      PKT(3,I)=PKT(3,I)-PKT(3,1)
      ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
      CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
      CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
      CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
      W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
      IF(ABS(W).LE.1.D-10)
     &CALL FULLSTOP('<TTRGRF>:: INTERNAL ERROR: W=0')
      DO I=1,3
      REC(I,1)=REC(I,1)/W
      REC(I,2)=REC(I,2)/W
      REC(I,3)=REC(I,3)/W
      ENDDO
C  DO OVER DIVISIONS OF THE MICROCELL
      DO 4200 ID3=0,NDIW(3)/NDIV(3)-1
      DO 4200 ID2=0,NDIW(2)/NDIV(2)-1
      DO 4200 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
      IW1=I1*NDIW(1)/NDIV(1)+ID1
      IW2=I2*NDIW(2)/NDIV(2)+ID2
      IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
      DO 4100 ITTRD=1,6
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      KTW(I)=IPW(JW1,JW2,JW3)
      ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      PKW(1,I)=(JW1*AKBAS(1,1,3)+
     &          JW2*AKBAS(1,2,3)+
     &          JW3*AKBAS(1,3,3))*2.D0*PI/PAR
      PKW(2,I)=(JW1*AKBAS(2,1,3)+
     &          JW2*AKBAS(2,2,3)+
     &          JW3*AKBAS(2,3,3))*2.D0*PI/PAR
      PKW(3,I)=(JW1*AKBAS(3,1,3)+
     &          JW2*AKBAS(3,2,3)+
     &          JW3*AKBAS(3,3,3))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=1,4
      PKW(1,I)=PKW(1,I)-PKT(1,1)
      PKW(2,I)=PKW(2,I)-PKT(2,1)
      PKW(3,I)=PKW(3,I)-PKT(3,1)
      ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
      DO I=1,4
      X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
      X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
      X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
      IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &         (X1+X2+X3.LE.1.D0+EPS)))GOTO 4100
      CRW(1,I)=X1
      CRW(2,I)=X2
      CRW(3,I)=X3
      ENDDO
C  CALCULATE CONTRIBUTION TO THE POINTS GIVEN BY "KTT=PKT"
      DO 1300 IMSB=KMSB,NMSB                    !!! over matsubara frequencies
	ZOMG=(0.D0,1.D0)*WMSB(IMSB)
      DO 1200 IBNDS=1,NSPIN                     !!! over spin subbands
      DO 1100 IBNDT=1,NBNDT(1)                  !!! over valence bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C  TAKE INTEGRAL FOR FREQUENCY DEPENDENT BANDS
      DO I=1,4
      IPNT=KTW(I)
	ZE(I)=EPOW(IBAND,IPNT,IMSB)-DCMPLX(EF,0.D0)
      ENDDO
      CALL MCTTRINT5(ZE,OW,ZOMG,CINT,DINT,KEYDOS)
	AG(1)=CINT(1)-CINT(2)-CINT(3)-CINT(4)
	AG(2)=CINT(2)
	AG(3)=CINT(3)
	AG(4)=CINT(4)
	DG(1)=DINT(1)-DINT(2)-DINT(3)-DINT(4)
	DG(2)=DINT(2)
	DG(3)=DINT(3)
	DG(4)=DINT(4)
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      GWGT(IBAND,IPNT,IMSB)=GWGT(IBAND,IPNT,IMSB)+AG(I)*WF*WTTR
      GWGD(IBAND,IPNT,IMSB)=GWGD(IBAND,IPNT,IMSB)+DG(I)*WF*WTTR
      ENDDO
      ENDDO
C  TAKE INTEGRAL FOR LIMIT i*Omega->i*Infinity, Sum over omega's
      DO I=1,4
      IPNT=KTW(I)
	ZE(I)=DCMPLX(EARW(IBAND,IPNT,1)-EF,0.D0)
      ENDDO
      CALL MCTTRINT5(ZE,OW,ZOMG,CINT,DINT,KEYDOS)
	AG(1)=CINT(1)-CINT(2)-CINT(3)-CINT(4)
	AG(2)=CINT(2)
	AG(3)=CINT(3)
	AG(4)=CINT(4)
	DG(1)=DINT(1)-DINT(2)-DINT(3)-DINT(4)
	DG(2)=DINT(2)
	DG(3)=DINT(3)
	DG(4)=DINT(4)
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      GW0T(IBAND,IPNT)=GW0T(IBAND,IPNT)+AG(I)*WF*FMSB(IMSB)*WTTR
      GW0D(IBAND,IPNT)=GW0D(IBAND,IPNT)+DG(I)*WF*FMSB(IMSB)*WTTR
      ENDDO
      ENDDO
 1100 CONTINUE                                  !!! over valence bands
 1200 CONTINUE                                  !!! over spin subbands
 1300 CONTINUE                                  !!! over Matsubara frequencies
C  TAKE INTEGRAL WITH FERMI DISTRIBUTION
      DO 2200 IBNDS=1,NSPIN                     !!! over spin subbands
      DO 2100 IBNDT=1,NBNDT(1)                  !!! over valence bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO I=1,4
      IPNT=KTW(I)
      E(I)=EARW(IBAND,IPNT,1)
	DO LD=0,4
	FL(LD,I)=FINT(LD,IBAND,IPNT)
	ENDDO
      ENDDO
C  USE TETRAHEDRON METHOD
	IF(KEYTTR.EQ.0.OR.KEYTTR.EQ.1)
     &CALL MCTTRINT0(E,EF,OW,AT,AD,TS,DS,'B','W')
C  ADD NON-ZERO TEMPERATURE CONTRIBUTION
	IF((KEYTTR.EQ.0.OR.KEYTTR.EQ.1).AND.TFERMI.NE.0.D0)THEN
      CALL MCTTRINTF(E,EF,TFERMI,FL,OW,FAT,FAD,FTS,FDS)
	TS=TS+FTS
	DS=DS+FDS
	DO I=1,4
	AT(I)=AT(I)+FAT(I)
	AD(I)=AD(I)+FAD(I)
	ENDDO
	ENDIF
C  USE GAUSSIAN BROADENING
	IF(KEYTTR.EQ.2)
     &CALL MCTTRINTG(E,EF,GBROAD,OW,AT,AD,TS,DS)
C  SET WEIGHTS
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      WEIGH(IBAND,IPNT)=WEIGH(IBAND,IPNT)+AT(I)*WF*WTTR
      WEIGD(IBAND,IPNT)=WEIGD(IBAND,IPNT)+AD(I)*WF*WTTR
      ENDDO
      ENDDO
 2100 CONTINUE                                  !!! over valence bands
 2200 CONTINUE                                  !!! over spin subbands
	IF(KMSB.NE.NMSB+1)CYCLE
      DO 3200 IBNDS=1,NSPIN                     !!! over spin subbands
      DO 3100 IBNDT=1,NBNDT(1)                  !!! over valence bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C  TAKE INTEGRAL FOR FREQUENCY DEPENDENT BANDS
      DO I=1,4
      IPNT=KTW(I)
	ZE(I)=EPOW(IBAND,IPNT,KMSB)-DCMPLX(EF,0.D0)
      ENDDO
      CALL MCTTRINT5(ZE,OW,ZMSB,CINT,DINT,KEYDOS)
	AG(1)=CINT(1)-CINT(2)-CINT(3)-CINT(4)
	AG(2)=CINT(2)
	AG(3)=CINT(3)
	AG(4)=CINT(4)
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      GWGT(IBAND,IPNT,KMSB)=GWGT(IBAND,IPNT,KMSB)+AG(I)*WF*WTTR
      ENDDO
      ENDDO
 3100 CONTINUE                                  !!! over valence bands
 3200 CONTINUE                                  !!! over spin subbands
 4100 CONTINUE                                  !!! over small tetrahedra
 4200 CONTINUE                                  !!! over small microcells
 5100 CONTINUE                                  !!! over tetrahedra
 5200 CONTINUE                                  !!! over microcells
C Average for degenerate bands
	IF(KEYTTR.EQ.0)THEN
      DO 7200 IPNT=1,NPNT(1)                    !!! over k-points
	DO 7100 IMSB=KMSB,NMSB                    !!! over frequencies
	IDEG=0
	JDEG=0
      DO 6200 IBNDS=1,NSPIN
      DO 6100 IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	ZI=EPOL(IBAND,IPNT,IMSB)
	IF(IDEG.LT.JDEG)IDEG=IDEG+1
	IF(IDEG.LT.JDEG)CYCLE
	IDEG=0
	JDEG=0
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,NBNDT(1)
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	ZJ=EPOL(JBAND,IPNT,IMSB)
	IF(ABS(ZI-ZJ).LE.EPSDEG)JDEG=JDEG+1
	IF(ABS(ZI-ZJ).GT.EPSDEG)EXIT
	ENDDO
	ENDDO
	GH=(0.D0,0.D0)
	GD=(0.D0,0.D0)
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	GH=GH+GWGT(JBAND,IPNT,IMSB)
	GD=GD+GWGD(JBAND,IPNT,IMSB)
	ENDDO
	ENDDO
	GH=GH/DBLE(JDEG)
	GD=GD/DBLE(JDEG)
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	GWGT(JBAND,IPNT,IMSB)=GH
	GWGD(JBAND,IPNT,IMSB)=GD
	ENDDO
	ENDDO
 6100	ENDDO
 6200	ENDDO
 7100 CONTINUE                                  !!! over frequencies
 7200 CONTINUE                                  !!! over k-points
      DO 9000 IPNT=1,NPNT(1)                    !!! over k-points
	IDEG=0
	JDEG=0
      DO 8200 IBNDS=1,NSPIN
      DO 8100 IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	EI=EARR(IBAND,IPNT,1)
	IF(IDEG.LT.JDEG)IDEG=IDEG+1
	IF(IDEG.LT.JDEG)CYCLE
	IDEG=0
	JDEG=0
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,NBNDT(1)
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	EJ=EARR(JBAND,IPNT,1)
	IF(ABS(EI-EJ).LE.EPSDEG)JDEG=JDEG+1
	IF(ABS(EI-EJ).GT.EPSDEG)EXIT
	ENDDO
	ENDDO
	WH=0.D0
	WD=0.D0
	GH=(0.D0,0.D0)
	GD=(0.D0,0.D0)
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	WH=WH+WEIGH(JBAND,IPNT)
	WD=WD+WEIGD(JBAND,IPNT)
	GH=GH+GW0T(JBAND,IPNT)
	GD=GD+GW0D(JBAND,IPNT)
	ENDDO
	ENDDO
	WH=WH/DBLE(JDEG)
	WD=WD/DBLE(JDEG)
	GH=GH/DBLE(JDEG)
	GD=GD/DBLE(JDEG)
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	WEIGH(JBAND,IPNT)=WH
	WEIGD(JBAND,IPNT)=WD
	GW0T(JBAND,IPNT)=GH
	GW0D(JBAND,IPNT)=GD
	ENDDO
	ENDDO
 8100	ENDDO
 8200	ENDDO
 9000 CONTINUE                              !!! over k-points
	ENDIF
C Normalization. Note that the imaginary part is PI times
C larger than density of states since ImG(E)=pi*N(E)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
C Frequency dependent weights
	DO IMSB=KMSB,NMSB+1
      GWGT(IBAND,IPNT,IMSB)=GWGT(IBAND,IPNT,IMSB)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
      GWGD(IBAND,IPNT,IMSB)=GWGD(IBAND,IPNT,IMSB)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
C Summed over frequencies weights
      GW0T(IBAND,IPNT)=GW0T(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
      GW0D(IBAND,IPNT)=GW0D(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
C Fermi distribution weights
      WEIGH(IBAND,IPNT)=WEIGH(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
      WEIGD(IBAND,IPNT)=WEIGD(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
	ENDDO
	ENDDO
C ESTIMATE NUMBER AND DENSITY OF STATES FOR GIVEN EF
	TOS=0.D0
	DOS=0.D0
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
	DO IMSB=KMSB,NMSB
	TOS=TOS+2.D0*TEMP*DREAL(GWGT(IBAND,IPNT,IMSB))*FMSB(IMSB)
	DOS=DOS+2.D0*TEMP*DREAL(GWGD(IBAND,IPNT,IMSB))*FMSB(IMSB)
	ENDDO
	TOS=TOS-2.D0*TEMP*DREAL(GW0T(IBAND,IPNT))
	DOS=DOS-2.D0*TEMP*DREAL(GW0D(IBAND,IPNT))
      TOS=TOS+WEIGH(IBAND,IPNT)
      DOS=DOS+WEIGD(IBAND,IPNT)
	ENDDO
	ENDDO
	ENDDO
	IF(KEY.EQ.0)WRITE(IUN,10010)EF,TOS,DOS
10010 FORMAT(' EF,TOS,DOS==',3(1X,G14.7))
C MEMORY DEALLOCATIONS
	DEALLOCATE(FINT)
	RETURN
	END
