      SUBROUTINE TTRVEL(EF0,DOS,VEL,SPTOS,SPDOS,SPVEL,
     &                  VELM,SPVELM,KPRINT)
***********************************************************
*  The calculation of the mean square velocities at EF.   *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS           !!! from readini
      USE COM_KAPPAR ,ONLY: NPAN,NKAP                         !!! from readini
      USE COM_LATPAR ,ONLY: PAR,OMEGAC                        !!! from readini
      USE COM_LATTICE,ONLY: RBAS,GBAS,AKBAS,RKBAS             !!! from readstr
      USE COM_NBANDS ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
      USE COM_INPTTR ,ONLY: NDIV,NDIC,NDIW,SH,KEYTTR
     &                     ,TFERMI,GBROAD                     !!! from readini
      USE COM_KMESH  ,ONLY: NPNT,PNT,WGT,IPQ,IGQ,ITQ,KCUT     !!! from makettr
      USE COM_GROUPS ,ONLY: NGROUP,INV,IKOV,IP,RDC,SHIFT,U,SJ !!! from groups
      USE COM_WMESH  ,ONLY: NPNW,PNW,WGW,IPW,IGW,ITW,KCUW     !!! from tetra
      USE COM_ENERGY ,ONLY: EARR,EARW,WEIGH,WEIGD             !!! from bands
      USE COM_UNIT   ,ONLY: IUN,IUR,IUT                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: FINT(:,:,:)
      INTEGER KTT(4),KTW(4)
      DIMENSION E(4),VEL(3),SPVEL(3,2),SPDOS(2),SPTOS(2)
     &   ,AT(4),AD(4),FAT(4),FAD(4),FL(0:4,4),VK(3)
     &   ,PKT(3,4),PKW(3,4),CRW(3,4),REC(3,3),VELM(3,3)
     &   ,SPVELM(3,3,2)
      COMPLEX*16 TRC(-3:3,7,0:3),TRS(7,-3:3,0:3)
     &   ,VELT(-1:1,-1:1,2),VELS(-1:1,-1:1,2)
      DATA PI/3.141592653589793D0/,EPS/1.D-10/
C MEMORY ALLOCATIONS
	ALLOCATE(FINT(0:4,NBNDT(1)*NSPINMEM,NPNWMEM))
	EF=EF0
	DO IBNDS=1,NSPIN
	SPTOS(IBNDS)=0.D0
	SPDOS(IBNDS)=0.D0
	DO IVEL1=1,3
	DO IVEL =1,3
	SPVELM(IVEL1,IVEL,IBNDS)=0.D0
	ENDDO
	ENDDO
	ENDDO
C Compute Fermi function integrals
	IF((KEYTTR.EQ.0.OR.KEYTTR.EQ.1).AND.TFERMI.NE.0.D0)THEN
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNW=1,NPNW(1)
	XT=(EARW(IBAND,IPNW,1)-EF)/TFERMI
	CALL FERMIINT(XT,40,FINT(0,IBAND,IPNW),0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C  DO OVER WHOLE BRILLOUIN ZONE REPRESENTED BY MICROCELLS AND 
C  INTEGRATE OVER THE TETRAHEDRA
      VOLIBZ=1.D0
      OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
      OW=1.D0/NDIW(1)/NDIW(2)/NDIW(3)/6.D0
C *********** TETRAHEDRON METHOD **********
C  DO OVER MICROCELLS
      DO 2200 I3=0,NDIV(3)-1               !!! over cells along G3
      DO 2200 I2=0,NDIV(2)-1               !!! over cells along G2
      DO 2200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRON INSIDE MICROCELL
      DO 2100 ITTR=1,6                     !!! over tetrahedra
	IF(ITQ(ITTR,I1,I2,I3).LT.0)GOTO 2100
	WTTR=DBLE(ITQ(ITTR,I1,I2,I3))
      DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      KTT(I)=IPQ(J1,J2,J3)
      ENDDO
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
      DO I=1,4
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      PKT(1,I)=(J1*AKBAS(1,1,1)+
     &          J2*AKBAS(1,2,1)+
     &          J3*AKBAS(1,3,1))*2.D0*PI/PAR
      PKT(2,I)=(J1*AKBAS(2,1,1)+
     &          J2*AKBAS(2,2,1)+
     &          J3*AKBAS(2,3,1))*2.D0*PI/PAR
      PKT(3,I)=(J1*AKBAS(3,1,1)+
     &          J2*AKBAS(3,2,1)+
     &          J3*AKBAS(3,3,1))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=2,4
      PKT(1,I)=PKT(1,I)-PKT(1,1)
      PKT(2,I)=PKT(2,I)-PKT(2,1)
      PKT(3,I)=PKT(3,I)-PKT(3,1)
      ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
      CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
      CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
      CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
      W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
      IF(ABS(W).LE.1.D-10)STOP'<TTRINT1>:: INTERNAL ERROR: W=0'
      DO I=1,3
      REC(I,1)=REC(I,1)/W
      REC(I,2)=REC(I,2)/W
      REC(I,3)=REC(I,3)/W
      ENDDO
C  DO OVER DIVISIONS OF THE MICROCELL
      DO 400 ID3=0,NDIW(3)/NDIV(3)-1
      DO 400 ID2=0,NDIW(2)/NDIV(2)-1
      DO 400 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
      IW1=I1*NDIW(1)/NDIV(1)+ID1
      IW2=I2*NDIW(2)/NDIV(2)+ID2
      IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SETUP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
      DO 300 ITTRD=1,6
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      KTW(I)=IPW(JW1,JW2,JW3)
      ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      PKW(1,I)=(JW1*AKBAS(1,1,3)+
     &          JW2*AKBAS(1,2,3)+
     &          JW3*AKBAS(1,3,3))*2.D0*PI/PAR
      PKW(2,I)=(JW1*AKBAS(2,1,3)+
     &          JW2*AKBAS(2,2,3)+
     &          JW3*AKBAS(2,3,3))*2.D0*PI/PAR
      PKW(3,I)=(JW1*AKBAS(3,1,3)+
     &          JW2*AKBAS(3,2,3)+
     &          JW3*AKBAS(3,3,3))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=1,4
      PKW(1,I)=PKW(1,I)-PKT(1,1)
      PKW(2,I)=PKW(2,I)-PKT(2,1)
      PKW(3,I)=PKW(3,I)-PKT(3,1)
      ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
      DO I=1,4
      X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
      X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
      X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
      IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &         (X1+X2+X3.LE.1.D0+EPS)))GOTO300
      CRW(1,I)=X1
      CRW(2,I)=X2
      CRW(3,I)=X3
      ENDDO
C  CALCULATE CONTRIBUTION TO THE POINTS GIVEN BY "KTT=PKT"
      DO 200 IBNDS=1,NSPIN                   !!! over spin subbands
      DO 100 IBNDT=1,NBNDT(1)                !!! over valence bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO I=1,4
      IPNT=KTW(I)
      E(I)=EARW(IBAND,IPNT,1)
	DO LD=0,4
	FL(LD,I)=FINT(LD,IBAND,IPNT)
	ENDDO
      ENDDO
      CALL GETVEL(E,PKW,VK)                  !!! dE(kj)/dk
C  USE TETRAHEDRON METHOD
	IF(KEYTTR.EQ.0.OR.KEYTTR.EQ.1)
     &CALL MCTTRINT0(E,EF,OW,AT,AD,TS,DS,'B','W')
C  ADD NON-ZERO TEMPERATURE CONTRIBUTION
	IF((KEYTTR.EQ.0.OR.KEYTTR.EQ.1).AND.TFERMI.NE.0.D0)THEN
      CALL MCTTRINTF(E,EF,TFERMI,FL,OW,FAT,FAD,FTS,FDS)
	TS=TS+FTS
	DS=DS+FDS
	DO I=1,4
	AT(I)=AT(I)+FAT(I)
	AD(I)=AD(I)+FAD(I)
	ENDDO
	ENDIF
C  USE GAUSSIAN BROADENING
	IF(KEYTTR.EQ.2)
     &CALL MCTTRINTG(E,EF,GBROAD,OW,AT,AD,TS,DS)
      SPTOS(IBNDS)=SPTOS(IBNDS)+TS*WTTR
      SPDOS(IBNDS)=SPDOS(IBNDS)+DS*WTTR
C  SET VELOCITIES
      DO IVEL1=1,3                            !!! velocities
      DO IVEL =1,3                            !!! velocities
      SPVELM(IVEL1,IVEL,IBNDS)=SPVELM(IVEL1,IVEL,IBNDS)+
     &DS*VK(IVEL1)*VK(IVEL)*WTTR
      ENDDO
      ENDDO
 100  CONTINUE                               !!! over valence bands
 200  CONTINUE                               !!! over spin subbands
 300  CONTINUE                               !!! over small tetrahedra
 400  CONTINUE                               !!! over small microcells
2100  CONTINUE                               !!! over tetrahedra
2200  CONTINUE                               !!! over microcells
C Build transformation matrices
	CALL TRANSC(TRC)
	CALL TRANSS(TRS)
C  TRANSFORM VELOCITY MATRIX TO SPHERICAL COORDINATES
	DO IBNDS=1,NSPIN
	DO MU=-1,1
	DO NU=-1,1
	VELT(MU,NU,IBNDS)=(0.D0,0.D0)
	DO IA=1,3
	DO IB=1,3
	VELT(MU,NU,IBNDS)=VELT(MU,NU,IBNDS)+
     &DCONJG(TRS(IA,MU,1))*SPVELM(IA,IB,IBNDS)*TRS(IB,NU,1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  SYMMETRIZE VELOCITY MATRIX
	DO IBNDS=1,NSPIN
	DO MU=-1,1
	DO NU=-1,1
	VELS(MU,NU,IBNDS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	DO IR=1,NGROUP
	IG=IKOV(IR)
	DO IBNDS=1,NSPIN
	DO MU=-1,1
	DO NU=-1,1
      DO MU1=-1,1
      DO NU1=-1,1
      MUMU1=3+3*(1+MU1)+MU
      NUNU1=3+3*(1+NU1)+NU
      VELS(MU,NU,IBNDS)=VELS(MU,NU,IBNDS)+
     &DCONJG(U(MUMU1,IG))*VELT(MU1,NU1,IBNDS)*U(NUNU1,IG)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO IBNDS=1,NSPIN
	DO MU=-1,1
	DO NU=-1,1
	VELT(MU,NU,IBNDS)=VELS(MU,NU,IBNDS)/DBLE(NGROUP)
	ENDDO
	ENDDO
	ENDDO
C  TRANSFORM VELOCITY MATRIX BACK TO CARTESIAN COORDINATES
	DO IBNDS=1,NSPIN
	DO IA=1,3
	DO IB=1,3
	SPVELM(IA,IB,IBNDS)=(0.D0,0.D0)
	DO MU=-1,1
	DO NU=-1,1
	SPVELM(IA,IB,IBNDS)=SPVELM(IA,IB,IBNDS)+
     &DCONJG(TRC(MU,IA,1))*VELT(MU,NU,IBNDS)*TRC(NU,IB,1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  NORMALIZATION
	DO IBNDS=1,NSPIN
	SPTOS(IBNDS)=SPTOS(IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)!!! tos
	SPDOS(IBNDS)=SPDOS(IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)!!! dos
	DO IVEL1=1,3
	DO IVEL =1,3
	SPVELM(IVEL1,IVEL,IBNDS)=SPVELM(IVEL1,IVEL,IBNDS)
     &                         /VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
	ENDDO
	DO IVEL=1,3
	SPVEL(IVEL,IBNDS)=SPVELM(IVEL,IVEL,IBNDS)
	ENDDO
	ENDDO
C
	TOS=(SPTOS(1)+SPTOS(NSPIN))/2.D0*DBLE(NSPIN)
	DOS=(SPDOS(1)+SPDOS(NSPIN))/2.D0*DBLE(NSPIN)
	DO IVEL=1,3
	VEL(IVEL)=(SPVEL(IVEL,1)+SPVEL(IVEL,NSPIN))/2.D0*DBLE(NSPIN)
	ENDDO
	DO IVEL1=1,3
	DO IVEL =1,3
	VELM(IVEL1,IVEL)=(SPVELM(IVEL1,IVEL,1)+SPVELM(IVEL1,IVEL,NSPIN))/
     &2.D0*DBLE(NSPIN)
	ENDDO
	ENDDO
	IF(KPRINT.EQ.0)THEN
C  PRINT DOS
      WRITE(IUN,1010)EF,TOS,DOS
1010  FORMAT(' EF,TOS,DOS==',3(1X,G14.7))
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
      WRITE(IUN,1020)SPTOS(1)    ,SPDOS(1)
      WRITE(IUN,1030)SPTOS(NSPIN),SPDOS(NSPIN)
      WRITE(IUN,1040)SPTOS(1)-SPTOS(NSPIN)
1020  FORMAT('    TUP,DUP==',15X,2(1X,G14.7))
1030  FORMAT('    TDN,DDN==',15X,2(1X,G14.7))
1040	FORMAT(' MM=TUP-TDN==',15X,1X,G14.7)
	ENDIF
C  PRINT VELOCITIES
      WRITE(IUN,1050)
1050  FORMAT(1X,'Calculated average square of electron velocities:')
      WRITE(IUN,1060)(VEL(I),I=1,3)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
      WRITE(IUN,1070)(SPVEL(I,1),I=1,3)
      WRITE(IUN,1080)(SPVEL(I,NSPIN),I=1,3)
1060  FORMAT(1X,'<Vx^2>=',G14.7,' ; <Vy^2>=',G14.7,' ; <Vz^2>=',G14.7)
1070  FORMAT(1X,'<Ux^2>=',G14.7,' ; <Uy^2>=',G14.7,' ; <Uz^2>=',G14.7)
1080  FORMAT(1X,'<Dx^2>=',G14.7,' ; <Dy^2>=',G14.7,' ; <Dz^2>=',G14.7)
	ENDIF
C  PRINT PLASMA FREQUENCIES
      WRITE(IUN,1090)
1090  FORMAT(1X,'Calculated bare plasma frequencies (in eV):')
      WRITE(IUN,1100)(13.6058D0*SQRT(8.D0*PI*VEL(I)/OMEGAC),I=1,3)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
      WRITE(IUN,1110)(13.6058D0*
     &SQRT(8.D0*PI*SPVEL(I,1)/OMEGAC),I=1,3)
      WRITE(IUN,1120)(13.6058D0*
     &SQRT(8.D0*PI*SPVEL(I,NSPIN)/OMEGAC),I=1,3)
1100  FORMAT(1X,'om_p^x=',G14.7,' ; om_p^y=',G14.7,' ; om_p^z=',G14.7)
1110  FORMAT(1X,'om_u^x=',G14.7,' ; om_u^y=',G14.7,' ; om_u^z=',G14.7)
1120  FORMAT(1X,'om_d^x=',G14.7,' ; om_d^y=',G14.7,' ; om_d^z=',G14.7)
	ENDIF
	ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(FINT)
	RETURN
	END




      SUBROUTINE GETVEL(E0,Q0,V)
*************************************************
*  Calculates velocities inside the tetrahedron *
*************************************************
	USE COM_UNIT ,ONLY: IUT
	IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION E0(4),Q0(3,4),V(3),Q(3,3),EV(3)
      DO J=1,3
      EV(J)=E0(J)-E0(4)
      DO I=1,3
      Q(J,I)=Q0(I,J)-Q0(I,4)
	ENDDO
	ENDDO
      CALL SIMQ(Q,EV,3,3,IFAIL)
      IF(IFAIL.NE.0)WRITE(IUT,*)'<GETVEL>: SIMQ FAILS'
      DO IV=1,3
      V(IV)=EV(IV)
	ENDDO
      END
